VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmCompWarn 
   BorderStyle     =   5  'Sizable ToolWindow
   Caption         =   "Compiler Warnings"
   ClientHeight    =   5370
   ClientLeft      =   135
   ClientTop       =   300
   ClientWidth     =   9735
   Icon            =   "frmCompWarn.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   MinButton       =   0   'False
   NegotiateMenus  =   0   'False
   ScaleHeight     =   5370
   ScaleWidth      =   9735
   ShowInTaskbar   =   0   'False
   Visible         =   0   'False
   Begin MSFlexGridLib.MSFlexGrid fgWarnings 
      Height          =   3270
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   4905
      _ExtentX        =   8652
      _ExtentY        =   5768
      _Version        =   393216
      Cols            =   6
      GridColorFixed  =   12632256
      WordWrap        =   -1  'True
      AllowBigSelection=   0   'False
      GridLinesFixed  =   1
      SelectionMode   =   1
      AllowUserResizing=   1
      BorderStyle     =   0
   End
   Begin MSComctlLib.ImageList ImageList1 
      Left            =   360
      Top             =   720
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   4
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmCompWarn.frx":058A
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmCompWarn.frx":0B24
            Key             =   ""
         EndProperty
         BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmCompWarn.frx":10BE
            Key             =   ""
         EndProperty
         BeginProperty ListImage4 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmCompWarn.frx":1658
            Key             =   ""
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "frmCompWarn"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

  Private mLoading As Boolean
  Private mX As Single, mY As Single

  Public PrevFGWndProc As Long
  

Public Sub DismissWarning()

  Debug.Assert fgWarnings.Row > 0
  
  Dim lngWarning As Long, i As Long
  
  On Error GoTo ErrHandler
  
  If fgWarnings.Rows = 2 Then
    fgWarnings.Clear
  Else
    fgWarnings.RemoveItem fgWarnings.Row
  End If

  'always restore column headers
  With fgWarnings
    .TextMatrix(0, 1) = "Warning"
    .TextMatrix(0, 2) = "Description"
    .TextMatrix(0, 3) = "Logic#"
    .TextMatrix(0, 4) = "Line#"
    .TextMatrix(0, 5) = "Module"
  End With

  
Exit Sub

ErrHandler:
  '
End Sub

Public Sub HelpWarning()

  Debug.Assert fgWarnings.Row > 0
  
  Dim strTopic As String, strNum As String
  
  On Error GoTo ErrHandler
  
  'show help for the warning (or error) that is selected
  If fgWarnings.Row > 0 Then
    strNum = fgWarnings.TextMatrix(fgWarnings.Row, 1)
    If Val(strNum) > 5000 Then
      strTopic = "htm\winagi\compilerwarnings.htm"
    Else
      strTopic = "htm\winagi\compilererrors.htm"
    End If
    strTopic = strTopic & "#" & strNum
  End If

  'show warning help
  HtmlHelpS HelpParent, WinAGIHelp, HH_DISPLAY_TOPIC, strTopic
Exit Sub

ErrHandler:
  '
End Sub

Public Sub IgnoreWarning()

  Debug.Assert fgWarnings.Row > 0
  
  Dim lngWarning As Long, i As Long
  
  On Error GoTo ErrHandler
  
  'get warning number
  lngWarning = fgWarnings.TextMatrix(fgWarnings.Row, 1)
  
  'set ignore flag
  LogicSourceSettings.IgnoreWarning(lngWarning) = True
  
  'delete all rows with this warning
  For i = fgWarnings.Rows - 1 To 1 Step -1
    If CLng(Val(fgWarnings.TextMatrix(i, 1))) = lngWarning Then
      If fgWarnings.Rows = 2 Then
        fgWarnings.Clear
      Else
        fgWarnings.RemoveItem i
      End If
    End If
  Next i
  'always restore column headers
  With fgWarnings
    .TextMatrix(0, 1) = "Warning"
    .TextMatrix(0, 2) = "Description"
    .TextMatrix(0, 3) = "Logic#"
    .TextMatrix(0, 4) = "Line#"
    .TextMatrix(0, 5) = "Module"
  End With

  
Exit Sub

ErrHandler:
  '
End Sub

Public Sub MouseWheel(ByVal MouseKeys As Long, ByVal Rotation As Long, ByVal xPos As Long, ByVal yPos As Long)
  Dim NewValue As Long
  Dim Lstep As Single
  
  On Error Resume Next
  
  With fgWarnings
    Lstep = 4
    
    If Rotation > 0 Then
      NewValue = .TopRow - Lstep
      If NewValue < 1 Then
        NewValue = 1
      End If
    Else
      NewValue = .TopRow + Lstep
      If NewValue > .Rows - 1 Then
        NewValue = .Rows - 1
      End If
    End If
    .TopRow = NewValue
  End With
End Sub

Public Sub AddWarning(ByRef WarningText As String, ByVal ResType As AGIResType, ByVal ResNumber As Long)

'Warning  Description  ResNum  Line  Module
'4118      Blah          1     34    Logic1
'--        Picture Blah  1     --    Picture1
'
'Text        1           2     3     4             smallicon=(type+1)



  'parse the text, and add it
  'WarningsText is in format:
  '  number\warningtext\line\module
  '
  'number and line only have meaning for logic warnings
  
  
  Dim strWarning() As String
  
  On Error GoTo ErrHandler
  
  If Not Visible Then
    Visible = True
  End If
  
  'split the warning text into its elements
  strWarning = Split(WarningText, "\")
  
  'add it to the grid
  fgWarnings.AddItem vbTab & strWarning(0) & vbTab & strWarning(1) & vbTab & CStr(ResNumber) & vbTab & strWarning(2) & vbTab & IIf(Len(strWarning(3)) <> 0, strWarning(3), Logics(ResNumber).ID)
  'save restype in row data tag
  fgWarnings.RowData(fgWarnings.Rows - 1) = ResType
  fgWarnings.Row = fgWarnings.Rows - 1
  fgWarnings.Col = 0
  'fgWarnings.CellPictureAlignment = flexAlignCenterCenter
  'Set fgWarnings.CellPicture = Me.ImageList1.ListImages(ResType + 1).Picture
  
  'if it's the first added (first row is blank), need to remove first row
  If Len(fgWarnings.TextMatrix(1, 1)) = 0 Then
    fgWarnings.RemoveItem 1
  End If
  
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Public Sub AddError(ByVal LineNum As Long, ByVal ErrNum As Long, ByVal ErrorText As String, ByVal ResNumber As Long, ByVal Module As String)

'Error  Description  ResNum  Line  Module
'4118      Blah          1     34    Logic1
  
  On Error GoTo ErrHandler
  
  Dim i As Long, lngNewRow As Long
  
  If Not Visible Then
    Visible = True
  End If
  
  'add it to the grid
  With fgWarnings
    .AddItem vbTab & ErrNum & vbTab & ErrorText & vbTab & CStr(ResNumber) & vbTab & LineNum & vbTab & IIf(Len(Module) <> 0, Module, Logics(ResNumber).ID)
    'make it bold/red
    lngNewRow = .Rows - 1
    .Row = lngNewRow
    For i = 1 To 5
      .Col = i
      .CellFontBold = True
      .CellForeColor = vbRed
    Next i
    
    'save restype in row data tag
    .RowData(lngNewRow) = rtLogic
    .Col = 0
  
    'if it's the first added (first row is blank), need to remove first row
    If Len(.TextMatrix(1, 1)) = 0 Then
      .RemoveItem 1
      lngNewRow = 1
    End If
    
    'always make it visible
    If Not .RowIsVisible(lngNewRow) Then
      .TopRow = lngNewRow
    End If
  End With
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Sub ClearWarnings(ByVal ResNum As Long, ByVal ResType As AGIResType)

'Warning  Description  ResNum  Line  Module
'4118      Blah          1     34    Logic1
'--        Picture Blah  --    --    Picture1
'
'Text        1           2     3     4             Tag=type


  'delete all lines from the grid that have the given resnum and restype
  'if resnum is -1, clear all
  
  Dim i As Long
  
  On Error GoTo ErrHandler
  
  If ResNum = -1 Then
    fgWarnings.Clear
    For i = fgWarnings.Rows To 3 Step -1
      fgWarnings.RemoveItem 1
    Next i
  Else
    For i = fgWarnings.Rows - 1 To 1 Step -1
      If CLng(Val(fgWarnings.TextMatrix(i, 3))) = ResNum And fgWarnings.RowData(i) = ResType Then
        If fgWarnings.Rows = 2 Then
          fgWarnings.Clear
        Else
          fgWarnings.RemoveItem i
        End If
      End If
    Next i
  End If
  
  'always restore column headers
  With fgWarnings
    .TextMatrix(0, 1) = "Warning"
    .TextMatrix(0, 2) = "Description"
    .TextMatrix(0, 3) = "Logic#"
    .TextMatrix(0, 4) = "Line#"
    .TextMatrix(0, 5) = "Module"
  End With

Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Public Sub MenuClickHelp()
  
  Dim strTopic As String
  
  'detect and respond to keyboard shortcuts
  On Error GoTo ErrHandler
  
  'show help for the warning that is selected

  strTopic = "htm\winagi\compilerwarnings.htm"
  If fgWarnings.Row > 0 Then
    strTopic = strTopic & "#" & fgWarnings.TextMatrix(fgWarnings.Row, 1)
  End If

  'show warning help
  HtmlHelpS HelpParent, WinAGIHelp, HH_DISPLAY_TOPIC, strTopic

Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Sub MenuClickCustom2()

End Sub
Public Sub MenuClickDelete()

''  On Error GoTo ErrHandler
''
''  'delete the selected row
''  If Me.fgWarnings.Rows > 2 Then
''    fgWarnings.RemoveItem fgWarnings.Row
''  Else
''    fgWarnings.RowData(0) = 0
''  End If
''Exit Sub
''
''ErrHandler:
''  Debug.Assert False
''  Resume Next
End Sub


Public Sub Activate()
  'bridge method to call the form's Activate event method
  Form_Activate
End Sub

Public Sub InitFonts()
  
  On Error GoTo ErrHandler

Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Public Sub MenuClickFind(Optional ByVal ffValue As FindFormFunction = ffFindLogic)

End Sub
Public Sub MenuClickFindAgain()

End Sub


Public Sub MenuClickPrint()
  
  Load frmPrint
  frmPrint.SetMode rtWarnings, Me, , True
  frmPrint.Show vbModal
  
  
End Sub

Public Sub MenuClickExport()
  'save as...
  
End Sub

Public Sub MenuClickCustom3()

End Sub

Private Sub fgWarnings_DblClick()
  
  Dim lngRow As Long, lngErrLine As Long, lngLogicNo As Long
  Dim strErrMsg As String, strModule As String, rtRes As AGIResType
  Dim blnWarn As Boolean
  
  On Error GoTo ErrHandler

  'MouseRow is the row actually clicked on
  'usuallys same as Row, but when header is
  'clicked, Row defaults to first row of data
  '(which is row 1)
  
  With fgWarnings
    lngRow = .Row
    If lngRow <> .MouseRow Then
      Exit Sub
    End If
      
    'get resource Type for selected row
    rtRes = .RowData(lngRow)
  
    'if a logic or text,
    If rtRes = rtLogic Or rtRes = rtText Then
      strErrMsg = .TextMatrix(.Row, 2)
      lngLogicNo = CLng(.TextMatrix(.Row, 3))
      lngErrLine = CLng(.TextMatrix(.Row, 4))
      strModule = .TextMatrix(.Row, 5)
      If strModule = Logics(lngLogicNo).ID Then
        strModule = vbNullString
      End If
      
      'warning?
      blnWarn = Val(.TextMatrix(.Row, 1)) > 5000
      'open the logic, and highlight error/warning
      SetError lngErrLine, strErrMsg, lngLogicNo, strModule, blnWarn
    End If
  End With
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next

End Sub


Private Sub fgWarnings_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

  Dim lngRow As Long, rtRes As AGIResType
  
  mX = X
  mY = Y

  'ignore if any shift keys are pressed at same time
  If Shift <> 0 Then
    Exit Sub
  End If
  
  'if right button, show menu to ignore!
  If Button = vbRightButton Then
    'ignore if clicking on header row
    If fgWarnings.MouseRow = 0 Then
      Exit Sub
    End If
    
    'make sure this row is selected
    With fgWarnings
      If .Row <> .MouseRow Then
        .Row = .MouseRow
        .RowSel = .MouseRow
        .Col = 1
        .ColSel = 5
      End If
    
      'get resource Type for selected row
      rtRes = fgWarnings.RowData(lngRow)
    
      'can only ignore/dismiss compiler warnings (restype has to be a logic/text)
      If rtRes = rtLogic Or rtRes = rtText Then
        If Val(.TextMatrix(.Row, 1)) < 5000 Then
          frmMDIMain.mnuCWIgnore.Visible = False
          frmMDIMain.mnuCWHelp.Caption = "Help with this Error"
        Else
          frmMDIMain.mnuCWIgnore.Visible = True
          frmMDIMain.mnuCWHelp.Caption = "Help with this Warning"
        End If
        PopupMenu frmMDIMain.mnuCWPopup, , mX, mY
      End If
    End With
  End If
End Sub


Private Sub fgWarnings_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

  'set tooltip if current warning doesnt fit
  
  On Error GoTo ErrHandler
  
  Select Case Button
  Case vbLeftButton
    'always reset rowsel to row; so only one row at a time
    With fgWarnings
      If .Row <> .MouseRow Then
        .Row = .MouseRow
        .RowSel = .Row
      End If
    End With
  End Select
  
'  'is mouse over an item?
'  Set tmpItem = lvWarnings.HitTest(x, y)
'  If tmpItem Is Nothing Then
'    Exit Sub
'  End If
'
'  'subitem(1) is text of the warning; but the column index is 2
'  If Me.TextWidth(tmpItem.SubItems(1)) > lvWarnings.ColumnHeaders(2).Width Then
'    tmpItem.ListSubItems(1).ToolTipText = tmpItem.ListSubItems(1).Text
'  Else
'    tmpItem.ListSubItems(1).ToolTipText = vbNullString
'  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub fgWarnings_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

  mX = X
  mY = Y
  
End Sub

Private Sub Form_Activate()

  On Error GoTo ErrHandler
  
  'if hiding prevwin on lost focus, hide it now
  If Settings.HidePreview Then
    If PreviewWin.Visible Then
  Debug.Print "prevwin: "; PreviewWin.Visible
  Debug.Print frmMDIMain.ActiveForm.Name
  
      PreviewWin.Hide
    End If
  End If
 
  'if visible,
  If Visible Then
    'force resize
    'Form_Resize
    
    'always set focus to grid
    On Error Resume Next
    fgWarnings.SetFocus
    On Error GoTo ErrHandler
  End If
  
  'set up the grid (for some reason, even though this is done in Form_load event,
  'the display blanks out even though the text values are still there...
  With Me.fgWarnings
    .TextMatrix(0, 1) = "Warning"
    .TextMatrix(0, 2) = "Description"
    .TextMatrix(0, 3) = "Logic#"
    .TextMatrix(0, 4) = "Line#"
    .TextMatrix(0, 5) = "Module"
    .ColAlignment(1) = flexAlignCenterTop
    .ColAlignment(2) = flexAlignLeftTop
    .ColAlignment(3) = flexAlignCenterTop
    .ColAlignment(4) = flexAlignCenterTop
    .ColAlignment(5) = flexAlignCenterTop
  End With
  
  'if findform is visible,
  If FindForm.Visible Then
    'hide it
    FindForm.Visible = False
  End If
  
  'adjust menus and statusbar
  AdjustMenus rtWarnings, False, True, False
  UpdateStatusBar
  
  'set edit menu
  SetEditMenu
  
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Private Sub UpdateStatusBar()
  Dim rtn As Long
  Dim lngRow As Long, lngCol As Long
  Dim blnErrFix As Boolean
  
  On Error GoTo ErrHandler
  
  If MainStatusBar.Tag <> CStr(rtWarnings) Then
    'hold status
    AdjustMenus rtWarnings, False, True, False
  End If
    
  SetEditMenu
Exit Sub

ErrHandler:
  'if error is due to wrong status bar
  If Err.Number = 35601 And Not blnErrFix Then
    'force update and retry
    blnErrFix = True
    AdjustMenus rtWarnings, False, True, False
    Resume
  Else
    Debug.Assert False
    Resume Next
  End If
End Sub


Public Sub SetEditMenu()
  'sets the menu captions on the Edit menu
  
  'for the warnings form, only delete is visible
  On Error GoTo ErrHandler
  
  With frmMDIMain
    'custom items not visible
    .mnuECustom1.Visible = False
    .mnuECustom2.Visible = False
    'undo, redo, bar0  visible, but disabled
    .mnuEUndo.Visible = True
    .mnuEUndo.Enabled = False
    .mnuEUndo.Caption = "Undo"
    .mnuERedo.Visible = True
    .mnuERedo.Enabled = False
    .mnuERedo.Caption = "Redo"
    
    'cut always visible, and never enabled
    .mnuECut.Visible = True
    .mnuECut.Enabled = False
    .mnuECut.Caption = "Cu&t" & vbTab & "Ctrl+X"

    'copy is same as cut
    .mnuECopy.Visible = True
    .mnuECopy.Enabled = False
    .mnuECopy.Caption = "&Copy" & vbTab & "Ctrl+C"

    'paste always visibie, nt enabled
    .mnuEPaste.Visible = True
    .mnuEPaste.Enabled = False
    .mnuEPaste.Caption = "&Paste" & vbTab & "Ctrl+V"

    'delete is always visible, enabled
    .mnuEDelete.Visible = True
    .mnuEDelete.Enabled = True
    .mnuEDelete.Caption = "Delete" & vbTab & "Del"

    'clear & insert menus always hidden
    .mnuEClear.Visible = False
    .mnuEInsert.Visible = False

    'select all always visible and not enabled
    .mnuESelectAll.Visible = True
    .mnuESelectAll.Enabled = False
    .mnuESelectAll.Caption = "Select &All" & vbTab & "Ctrl+A"

    'bar1, find and replace not visible
    .mnuEBar1.Visible = False
    .mnuEFind.Visible = False
    .mnuEReplace.Visible = False

    'find next not visible
    .mnuEFindAgain.Visible = False

  End With
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

  'detect and respond to keyboard shortcuts
  On Error GoTo ErrHandler
  
  If Shift = 0 Then
    Select Case KeyCode
    Case vbKeyF1
      'show help for the warning that is selected
      MenuClickHelp
    
    End Select
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub Form_Load()

  On Error GoTo ErrHandler
  
  'flag to ignore changes until after load complete
  mLoading = True
  
  Me.Left = 0
  Me.Top = 0
  
  'initialize font settings
  InitFonts
  
  'adjust menus and statusbar
  AdjustMenus rtWarnings, False, True, False
  UpdateStatusBar
  
  'set edit menu
  SetEditMenu
  
  'reset load flag
  mLoading = False
  
  'set up the grid
  With Me.fgWarnings
    .TextMatrix(0, 1) = "Warning"
    .TextMatrix(0, 2) = "Description"
    .TextMatrix(0, 3) = "Logic#"
    .TextMatrix(0, 4) = "Line#"
    .TextMatrix(0, 5) = "Module"
    .ColAlignment(1) = flexAlignCenterTop
    .ColAlignment(2) = flexAlignLeftTop
    .ColAlignment(3) = flexAlignCenterTop
    .ColAlignment(4) = flexAlignCenterTop
    .ColAlignment(5) = flexAlignCenterTop
  End With
  
  
  'position at bottom of main form
  Me.Left = 0
  Me.Width = frmMDIMain.ScaleWidth
  Me.Height = 2700 'frmMDIMain.picSplitH.Top * ScreenTWIPSY
  Me.Top = frmMDIMain.ScaleHeight - Me.Height
  
#If DEBUGMODE <> 1 Then
  'subclass the flexgrid
  PrevFGWndProc = SetWindowLong(Me.fgWarnings.hWnd, GWL_WNDPROC, AddressOf ScrollWndProc)
#End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub Form_Unload(Cancel As Integer)
  
  Dim i As Long
  
  'remove from logics collection
  For i = 1 To LogicEditors.Count
    If LogicEditors(i) Is Me Then
      LogicEditors.Remove i
      Exit For
    End If
  Next i

  'if this form is the searchform
  If SearchForm Is Me Then
    Set SearchForm = Nothing
  End If

  'release subclass hook to flexgrid
#If DEBUGMODE <> 1 Then
  SetWindowLong Me.fgWarnings.hWnd, GWL_WNDPROC, PrevFGWndProc
#End If
  'need to check if this is last form
  LastForm Me
End Sub



Private Sub Form_Resize()

'''  On Error GoTo ErrHandler
'''
'''  'if the form is not visible
'''  If Not Visible Then
'''    Exit Sub
'''  End If
'''
'''  With Me.fgWarnings
'''    'don't resize unless form is NOT minimized, and not resized too small
'''    If frmMDIMain.WindowState <> vbMinimized And frmMDIMain.Visible Then
'''      'if above minimum width, resize horizontally
'''      If frmMDIMain.ScaleWidth / Screen.TwipsPerPixelX >= 360 Then
''''''        .Width = ScaleWidth
''''''        .ColWidth(0) = 360
''''''        .ColWidth(1) = 1080
''''''        .ColWidth(2) = .Width - (72 * 4 + 24 + 18) * 15
''''''        .ColWidth(3) = 1080
''''''        .ColWidth(4) = 1080
''''''        .ColWidth(5) = 1080
'''      End If
'''      'if above minimum height, resize vertically
'''      If frmMDIMain.ScaleHeight / Screen.TwipsPerPixelY >= 361 Then
''''''        .Height = ScaleHeight
'''      End If
'''    End If
'''  End With
  
Exit Sub

ErrHandler:
'  Debug.Assert False
  Resume Next
End Sub


