VERSION 5.00
Begin VB.Form frmFind 
   AutoRedraw      =   -1  'True
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Find"
   ClientHeight    =   2385
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   5685
   Icon            =   "frmFind.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2385
   ScaleWidth      =   5685
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdReplaceAll 
      Caption         =   "Replace &All"
      Enabled         =   0   'False
      Height          =   336
      Left            =   4344
      TabIndex        =   14
      Top             =   1032
      Width           =   1176
   End
   Begin VB.TextBox txtReplace 
      Height          =   288
      Left            =   1320
      MultiLine       =   -1  'True
      TabIndex        =   3
      Top             =   624
      Width           =   2820
   End
   Begin VB.CommandButton cmdReplace 
      Caption         =   "&Replace"
      Enabled         =   0   'False
      Height          =   336
      Left            =   4344
      TabIndex        =   13
      Top             =   612
      Width           =   1176
   End
   Begin VB.Frame fraLogic 
      Caption         =   "Search"
      Height          =   1200
      Left            =   156
      TabIndex        =   4
      Top             =   1020
      Width           =   2010
      Begin VB.OptionButton optAllGameLogics 
         Caption         =   "All Logics in &Game"
         Height          =   240
         Left            =   156
         TabIndex        =   7
         Top             =   864
         WhatsThisHelpID =   10136
         Width           =   1720
      End
      Begin VB.OptionButton optCurrentLogic 
         Caption         =   "Current &Logic"
         Height          =   228
         Left            =   156
         TabIndex        =   5
         Top             =   264
         WhatsThisHelpID =   10134
         Width           =   1548
      End
      Begin VB.OptionButton optAllOpenLogics 
         Caption         =   "All Ope&n Logics"
         Height          =   240
         Left            =   156
         TabIndex        =   6
         Top             =   564
         WhatsThisHelpID =   10135
         Width           =   1800
      End
   End
   Begin VB.ComboBox cmbDirection 
      Height          =   288
      ItemData        =   "frmFind.frx":000C
      Left            =   3060
      List            =   "frmFind.frx":0019
      Style           =   2  'Dropdown List
      TabIndex        =   9
      Top             =   1068
      Width           =   1080
   End
   Begin VB.CommandButton cmdFind 
      Caption         =   "&Find"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   336
      Left            =   4344
      TabIndex        =   12
      Top             =   192
      Width           =   1176
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Close"
      Height          =   336
      Left            =   4344
      TabIndex        =   15
      Top             =   1860
      Width           =   1176
   End
   Begin VB.TextBox txtFindText 
      Height          =   288
      Left            =   1320
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   204
      Width           =   2820
   End
   Begin VB.CheckBox chkMatchCase 
      Caption         =   "Match &case"
      Height          =   240
      Left            =   2304
      TabIndex        =   11
      Top             =   1932
      Width           =   1464
   End
   Begin VB.CheckBox chkMatchWord 
      Caption         =   "Match &whole word &only"
      Height          =   240
      Left            =   2292
      TabIndex        =   10
      Top             =   1584
      Width           =   2400
   End
   Begin VB.Label lblReplace 
      Caption         =   "Replace &With:"
      Height          =   216
      Left            =   156
      TabIndex        =   2
      Top             =   660
      Width           =   1176
   End
   Begin VB.Label lblDirection 
      Caption         =   "&Direction:"
      Height          =   204
      Left            =   2328
      TabIndex        =   8
      Top             =   1092
      Width           =   720
   End
   Begin VB.Label Label1 
      Caption         =   "Fi&nd what:"
      Height          =   216
      Left            =   156
      TabIndex        =   0
      Top             =   240
      Width           =   840
   End
End
Attribute VB_Name = "frmFind"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'determines if form is find or replace
Public FormFunction As FindFormFunction

'these hold the publically accessible options of the form
Public FormAction As FindFormAction
Public FindDir As FindDirection
Public FindText As String
Public ReplaceText As String
Public MatchWord As Boolean
Public MatchCase As Boolean
Public LogicFindLoc As FindLocation

'used to adjust height of form depending on function
Private FormOffset As Single
Private MaxFormHeight As Single
Public Sub Activate()
  'bridge method to call the form's Activate event method
  
  'not used for this form
  'Form_Activate
End Sub

Public Sub SetForm(NewFunction As FindFormFunction)

  FormFunction = NewFunction
  'adjust form, based on formfunction
  
  Select Case FormFunction
  Case ffFindLogic, ffFindText
    'hide replace controls (except the replace button- just change caption)
    cmdReplace.Visible = True
    cmdReplace.Caption = "&Replace..."
    cmdReplaceAll.Visible = False
    txtReplace.Visible = False
    lblReplace.Visible = False

    'show logic frame
    fraLogic.Visible = True
    'set search location
    Select Case LogicFindLoc
    Case flCurrent
      optCurrentLogic.Value = True
    Case flOpen
      optAllOpenLogics.Value = True
    Case flAll
      optAllGameLogics.Value = True
    End Select
    'if alllogics set, but no game loaded
    If (Not GameLoaded) And optAllGameLogics.Value Then
      'change to all open logics
      optAllOpenLogics.Value = True
    End If
      
    'enable alllogics only if game is loaded
    optAllGameLogics.Enabled = GameLoaded
    
    'change text of option button
    If FormFunction = ffFindLogic Then
      'search logic
      optCurrentLogic.Caption = "Current Logic"
    Else
      'search text
      optCurrentLogic.Caption = "Current File"
    End If
    
    'show case checkbox
    chkMatchCase.Visible = True
    
  Case ffFindObject
    'hide replace controls (except the replace button- just change caption)
    cmdReplace.Visible = True
    cmdReplace.Caption = "&Replace..."
    cmdReplaceAll.Visible = False
    txtReplace.Visible = False
    lblReplace.Visible = False
    
    'hide logic frame
    fraLogic.Visible = False
  
    'show case checkbox
    chkMatchCase.Visible = True
  
  Case ffFindWord
    'hide replace controls (except the replace button- just change caption)
    cmdReplace.Visible = True
    cmdReplace.Caption = "&Replace..."
    cmdReplaceAll.Visible = False
    txtReplace.Visible = False
    lblReplace.Visible = False

    'hide logic frame and case checkbox
    fraLogic.Visible = False
    chkMatchCase.Visible = False
    
  Case ffReplaceLogic, ffReplaceText
    'show replace controls
    cmdReplace.Visible = True
    cmdReplace.Caption = "&Replace"
    cmdReplaceAll.Visible = True
    txtReplace.Visible = True
    lblReplace.Visible = True
    
    'show case checkbox
    chkMatchCase.Visible = True

    'show logic frame
    fraLogic.Visible = True
    'set search location
    Select Case LogicFindLoc
    Case flCurrent
      optCurrentLogic.Value = True
    Case flOpen
      optAllOpenLogics.Value = True
    Case flAll
      optAllGameLogics.Value = True
    End Select
    'if alllogics set, but no game loaded
    If (Not GameLoaded) And optAllGameLogics.Value Then
      'change to all open logics
      optAllOpenLogics.Value = True
    End If
    
    'change text of option button
    If FormFunction = ffReplaceLogic Then
      'search logic
      optCurrentLogic.Caption = "Current Logic"
    Else
      'search text
      optCurrentLogic.Caption = "Current File"
    End If
    
    'enable alllogics only if game is loaded
    optAllGameLogics.Enabled = GameLoaded
    
  Case ffReplaceObject
    'show replace controls
    cmdReplace.Visible = True
    cmdReplace.Caption = "&Replace"
    cmdReplaceAll.Visible = True
    txtReplace.Visible = True
    lblReplace.Visible = True
    
    'show case
    chkMatchCase.Visible = True
    'hide logic frame
    fraLogic.Visible = False
    
  Case ffReplaceWord
    'show replace controls
    cmdReplace.Visible = True
    cmdReplace.Caption = "&Replace"
    cmdReplaceAll.Visible = True
    txtReplace.Visible = True
    lblReplace.Visible = True
    
    'hide case and logic frame
    chkMatchCase.Visible = False
    fraLogic.Visible = False
  End Select
  
  'adjust height based on selection
  If FormFunction = ffFindLogic Or FormFunction = ffFindObject Or FormFunction = ffFindWord Then
    'adjust size to compensate for hidden replace controls
    If Height = MaxFormHeight Then
      cmdCancel.Top = cmdCancel.Top - FormOffset
      chkMatchWord.Top = chkMatchWord.Top - FormOffset
      chkMatchCase.Top = chkMatchCase.Top - FormOffset
      fraLogic.Top = fraLogic.Top - FormOffset
      cmbDirection.Top = cmbDirection.Top - FormOffset
      lblDirection.Top = lblDirection.Top - FormOffset
      Height = MaxFormHeight - FormOffset
    End If
  Else
    'adjust size to compensate for visible replace controls
    If Height <> MaxFormHeight Then
      cmdCancel.Top = cmdCancel.Top + FormOffset
      chkMatchWord.Top = chkMatchWord.Top + FormOffset
      chkMatchCase.Top = chkMatchCase.Top + FormOffset
      fraLogic.Top = fraLogic.Top + FormOffset
      cmbDirection.Top = cmbDirection.Top + FormOffset
      lblDirection.Top = lblDirection.Top + FormOffset
      Height = MaxFormHeight
    End If
  End If
  
  'set form values
  txtFindText.Text = FindText
  cmbDirection.ListIndex = FindDir
  chkMatchWord.Value = IIf(MatchWord, vbChecked, vbUnchecked)
  txtReplace.Text = ReplaceText
  chkMatchCase.Value = IIf(MatchCase, vbChecked, vbUnchecked)
End Sub

Private Sub chkMatchCase_Click()
  
  'always set newsearch flag
  Select Case FormFunction
  Case ffFindWord, ffFindObject
    'handled by individual editor
    
  Case Else
    'reset search flags
    FirstFind = False
    SearchStartLog = -1
    SearchStartPos = -1
    ClosedLogics = False
  End Select
End Sub

Private Sub chkMatchWord_Click()
  
  'always set newsearch flag
  Select Case FormFunction
  Case ffFindWord, ffFindObject
    'handled by individual editor
    
  Case Else
    'reset search flags
    FirstFind = False
    SearchStartLog = -1
    SearchStartPos = -1
    ClosedLogics = False
  End Select
End Sub


Private Sub cmdCancel_Click()

  'set action to cancel
  FormAction = faCancel
  
  'release reference to searching form
  Set SearchForm = Nothing
  
  'close form
  FindForm.Hide
End Sub


Private Sub cmdFind_Click()

  'if no search form,
  If SearchForm Is Nothing Then
    'nothing to do; ;hide the form and exit
    Me.Hide
    Exit Sub
  End If
  
  'search Type can only be set by
  'beginning a search from the objects or words form;
  'force searchtype back to none
  SearchType = rtNone
  
  'set form action, and variables
  FormAction = faFind
  FindText = txtFindText.Text
  ReplaceText = txtReplace.Text
  MatchWord = (chkMatchWord.Value = vbChecked)
  MatchCase = (chkMatchCase.Value = vbChecked)
  If Me.optCurrentLogic.Value Then
    LogicFindLoc = flCurrent
  ElseIf Me.optAllOpenLogics.Value Then
    LogicFindLoc = flOpen
  ElseIf Me.optAllGameLogics.Value Then
    LogicFindLoc = flAll
  End If
  FindDir = cmbDirection.ListIndex
  
  'set wait cursor
  WaitCursor
  
  'pass action back to calling editor
  SearchForm.BeginFind
  
  'restore cursor search ends
  Screen.MousePointer = vbDefault

End Sub

Private Sub cmdReplace_Click()

  'if no search form,
  If SearchForm Is Nothing Then
    'nothing to do; ;hide the form and exit
    Me.Hide
    Exit Sub
  End If
  
  'if function is find,
  If (FormFunction = ffFindLogic) Then
    SetForm ffReplaceLogic
    txtReplace.SetFocus
    
  ElseIf (FormFunction = ffFindObject) Then
    SetForm ffReplaceObject
    txtReplace.SetFocus
    
  ElseIf (FormFunction = ffFindWord) Then
    SetForm ffReplaceWord
    txtReplace.SetFocus
    
  Else
    'if no search form,
    If SearchForm Is Nothing Then
      Exit Sub
    End If
  
  'search Type can only be set by
  'beginning a search from the objects or words form;
  'force searchtype back to none
  SearchType = rtNone
  
    'set form action, and variables
    FormAction = faReplace
    FindDir = cmbDirection.ListIndex
    FindText = Me.txtFindText.Text
    ReplaceText = txtReplace.Text
    MatchWord = chkMatchWord.Value
    MatchCase = chkMatchCase.Value
    If Me.optCurrentLogic.Value Then
      LogicFindLoc = flCurrent
    ElseIf Me.optAllOpenLogics.Value Then
      LogicFindLoc = flOpen
    ElseIf Me.optAllGameLogics.Value Then
      LogicFindLoc = flAll
    End If
    
    'pass action back to calling editor
    SearchForm.BeginFind
  End If
End Sub


Private Sub cmdReplaceAll_Click()
  
  'if no search form,
  If SearchForm Is Nothing Then
    'nothing to do; ;hide the form and exit
    Me.Hide
    Exit Sub
  End If
  
  'search Type can only be set by
  'beginning a search from the objects or words form;
  'force searchtype back to none
  SearchType = rtNone
  
  'set form action, and variables
  FormAction = faReplaceAll
  FindText = txtFindText.Text
  ReplaceText = txtReplace.Text
  MatchWord = chkMatchWord.Value
  MatchCase = chkMatchCase.Value
  If Me.optCurrentLogic.Value Then
    LogicFindLoc = flCurrent
  ElseIf Me.optAllOpenLogics.Value Then
    LogicFindLoc = flOpen
  ElseIf Me.optAllGameLogics.Value Then
    LogicFindLoc = flAll
  End If

  'pass action back to calling editor
  SearchForm.BeginFind
End Sub

Private Sub Form_Activate()
  'this flag is used by logic and text editors
  'to update selection point after find form is activated
  FixSel = True
End Sub

Private Sub Form_Deactivate()

  'always reset the rtf selection flag
  'when form is deactivated
  
  'if the logic or text editor needed this
  'flag, it has already used it (since
  'the click event in the rtf box occurs
  'before the find form is deactivated)
  FixSel = False
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

  'check for help key
  If Shift = 0 And KeyCode = vbKeyF1 Then
    frmMDIMain.mnuHContents_Click
    KeyCode = 0
  End If
  
  'check for 'find next key
  If Shift = 0 And KeyCode = vbKeyF3 Then
    'assume logic or text editor has focus
    If frmMDIMain.ActiveForm.Name = "frmLogicEdit" Or frmMDIMain.ActiveForm.Name = "frmTextEdit" Then
      frmMDIMain.ActiveForm.MenuClickFindAgain
    End If
  End If
End Sub

Private Sub Form_Load()
  
  Dim rtn As Long
  
  'calculate the distance to remove from form when replace controls
  'are not visible
  FormOffset = cmdReplaceAll.Top - cmdReplace.Top
  'and Max height when replace commands are visible
  MaxFormHeight = Height
  
  'default to all
  cmbDirection.ListIndex = 0
  
  Move (frmMDIMain.Left + (frmMDIMain.Width - Width) / 2), (frmMDIMain.Top + (frmMDIMain.Height - Height) / 2)
End Sub


Private Sub txtFindText_Change()
  'enable find button if text is entered
  cmdFind.Enabled = (LenB(txtFindText.Text) > 0)
  cmdReplace.Enabled = cmdFind.Enabled Or FormFunction = ffFindLogic
  cmdReplaceAll.Enabled = cmdFind.Enabled
  
End Sub
Private Sub txtFindText_GotFocus()
  'select entire text
  txtFindText.SelStart = 0
  txtFindText.SelLength = Len(txtFindText.Text)
End Sub


Private Sub txtReplace_GotFocus()
  'select entire text
  txtReplace.SelStart = 0
  txtReplace.SelLength = Len(txtReplace.Text)

End Sub


