VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form frmGlobals 
   Caption         =   "Global Defines"
   ClientHeight    =   4650
   ClientLeft      =   135
   ClientTop       =   405
   ClientWidth     =   5250
   Icon            =   "frmGlobals.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   NegotiateMenus  =   0   'False
   ScaleHeight     =   4650
   ScaleWidth      =   5250
   Begin VB.PictureBox picSplit 
      BackColor       =   &H00808080&
      ForeColor       =   &H80000008&
      Height          =   4110
      Left            =   2310
      ScaleHeight     =   4110
      ScaleWidth      =   30
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   0
      Visible         =   0   'False
      Width           =   30
   End
   Begin VB.TextBox txtEditValue 
      Appearance      =   0  'Flat
      BackColor       =   &H8000000F&
      BorderStyle     =   0  'None
      Height          =   288
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   400
      Visible         =   0   'False
      Width           =   3690
   End
   Begin VB.TextBox txtEditName 
      Appearance      =   0  'Flat
      BackColor       =   &H00E0E0E0&
      BorderStyle     =   0  'None
      Height          =   288
      Left            =   0
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   1200
      Visible         =   0   'False
      Width           =   840
   End
   Begin MSFlexGridLib.MSFlexGrid fgGlobals 
      Height          =   3135
      Left            =   15
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   30
      Width           =   3675
      _ExtentX        =   6482
      _ExtentY        =   5530
      _Version        =   393216
      Cols            =   3
      FixedCols       =   0
      AllowBigSelection=   0   'False
      ScrollTrack     =   -1  'True
      FocusRect       =   2
      ScrollBars      =   2
      MergeCells      =   2
      BorderStyle     =   0
   End
End
Attribute VB_Name = "frmGlobals"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Option Compare Text

  Private Const SplitWidth = 60 'in twips
  
  Private SplitOffset As Single
  
  Private EditRow As Long, EditCol As ColType
  Private EditDefine As TDefine
  
  Private CellIndentH As Single
  Private CellIndentV As Single
  
  Private blnDuplicates As Boolean, blnReserved As Boolean
  
  Public PrevFGWndProc As Long
  
  Public InGame As Boolean
  Public FileName As String
  Public IsDirty As Boolean
  
  Private Enum ColType
    ctName = 1
    ctValue = 2
  End Enum
  
  Private CalcWidth As Long, CalcHeight As Long
  Private Const MinHeight = 361
  Private Const MinWidth = 360


Public Sub MenuClickECustom2()

  Dim i As Long, rtn As Long
  Dim OldCol As Long, OldRow As Long
  
  On Error GoTo ErrHandler
  
  With fgGlobals
    'save cursor position
    OldCol = .Col
    OldRow = .Row
    
    'hide globals form  ''''why???? it just causes problems when another form then needs to grab focus
'''    Me.Hide
    
    'edit reserved define names
    frmReserved.Show vbModal
    
    'if NOT canceled, gotta validate all defines again
    If Not frmReserved.Canceled Then
      'unload the form, and then
      'step through all rows, and format correctly based on
      'whether or not any define overrides a reserved define
      For i = 1 To .Rows - 1
        .Row = i
        .Col = ctName
        rtn = ValidateName(.TextMatrix(i, ctName))
        If rtn >= 8 And rtn <= 13 Then
          'override
          .CellFontBold = True
          .CellForeColor = vbRed
        Else
          'normal
          .CellFontBold = False
          .CellForeColor = vbBlack
        End If
      Next i
      
      'restore cursor
      .Col = OldCol
      .Row = OldRow
    End If
  End With
  'always unload the reserved form
  Unload frmReserved
  'now show globals
  Me.Show
  Me.SetFocus
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Sub MouseWheel(ByVal MouseKeys As Long, ByVal Rotation As Long, ByVal xPos As Long, ByVal yPos As Long)
  
  Dim NewValue As Long
  Dim Lstep As Single
  
  On Error Resume Next
  
  'scroll the grid
  With fgGlobals
    Lstep = 4
    If Rotation > 0 Then
      NewValue = .TopRow - Lstep
      If NewValue < 1 Then
        NewValue = 1
      End If
    Else
      NewValue = .TopRow + Lstep
      If NewValue > .Rows - 1 Then
        NewValue = .Rows - 1
      End If
    End If
    .TopRow = NewValue
  End With
End Sub


Public Sub MenuClickPrint()

  Load frmPrint
  frmPrint.SetMode rtGlobals, Me
  frmPrint.Show vbModal
End Sub
Public Sub Activate()
  'bridge method to call the form's Activate event method
  Form_Activate
End Sub

Public Sub ClearGlobalDefines()
  
  On Error GoTo ErrHandler
  
  
  'clear grid
  fgGlobals.Clear
  'set one row
  fgGlobals.Rows = 1
  'set up grid headings
  fgGlobals.TextMatrix(0, ctName) = "Name"
  fgGlobals.TextMatrix(0, ctValue) = "Value"
  
  'list has changed
  MarkAsDirty
Exit Sub

ErrHandler:
 ' Debug.Assert False
  ErrMsgBox "Error while clearing defines: ", "", "Global Defines Error"
  Resume Next
End Sub
Public Sub InitFonts()

  On Error Resume Next
  
  fgGlobals.Font.Name = Settings.EFontName
  fgGlobals.Font.size = Settings.EFontSize
  fgGlobals.Refresh
  
  txtEditName.Font.Name = Settings.EFontName
  txtEditName.Font.size = Settings.EFontSize
  txtEditValue.Font.Name = Settings.EFontName
  txtEditValue.Font.size = Settings.EFontSize
End Sub
Private Sub MarkAsDirty()

  If Not IsDirty Then
    'set dirty flag
    IsDirty = True
    
    'enable menu and toolbar button
    frmMDIMain.mnuRSave.Enabled = True
    frmMDIMain.Toolbar1.Buttons("save").Enabled = True
    
    If Asc(Caption) <> 42 Then
      'mark caption
      Caption = sDM & Caption
    End If
  End If
End Sub

Public Sub MenuClickClear()

  'if editing
  If txtEditName.Visible Or txtEditValue.Visible Then
    Exit Sub
  End If
  
  'verify action
  
  If MsgBox("All global defines will be discarded. Do you want to continue?", vbQuestion + vbOKCancel, "Clear Global Defines") = vbCancel Then
    Exit Sub
  End If
  
  'clear the list
  ClearGlobalDefines
  
  'add blank line
  fgGlobals.AddItem vbNullString
  
  'select name cel of first non-readonly row
  fgGlobals.Row = 1
  fgGlobals.Col = ctName
  
  'force column adjustment by resizing
  Form_Resize
End Sub

Public Sub MenuClickCopy()

  'if editing
  If txtEditName.Visible Or txtEditValue.Visible Then
    Exit Sub
  End If
  
  'copies the selected cell or the selected rows to the clipboard
  
  Dim i As Long, strData As String
  Dim TopRow As Long, BtmRow As Long
  
  With fgGlobals
    If .SelectionMode = flexSelectionByRow Then
      'select all the rows
      'ensure starting at top
      If .Row < .RowSel Then
        TopRow = .Row
        BtmRow = .RowSel
      Else
        TopRow = .RowSel
        BtmRow = .Row
      End If
      
      'add first row
      strData = .TextMatrix(TopRow, ctName) & vbTab & .TextMatrix(TopRow, ctValue)
      'add remaining rows, with carriage return separator
      For i = TopRow + 1 To BtmRow
        'add text
        strData = strData & vbCr & .TextMatrix(i, ctName) & vbTab & .TextMatrix(i, ctValue)
      Next i
    Else
      'select just this cell
      strData = .TextMatrix(.Row, .Col)
    End If
  
    'put on clipboard
    Clipboard.Clear
    Clipboard.SetText strData ', vbCFText
    
    'enable pasting, if selection contained entire row
    frmMDIMain.mnuEPaste.Enabled = (.SelectionMode = flexSelectionByRow)
  End With
End Sub


Public Sub MenuClickCustom1()

  'adds to the existing globals list, instead of replacing it
  
  On Error GoTo ErrHandler
  
  'if editing
  If txtEditName.Visible Or txtEditValue.Visible Then
    Exit Sub
  End If
  
  'get a globals file
  With MainDialog
    .Flags = cdlOFNHideReadOnly
    .DialogTitle = "Open Global Defines File"
    .DefaultExt = "txt"
    .Filter = "Text files (*.txt)|*.txt|All files (*.*)|*.*"
    .FileName = vbNullString
    .InitDir = DefaultResDir
    .ShowOpen
    
    LoadGlobalDefines .FileName, False
    DefaultResDir = JustPath(.FileName)
  End With
Exit Sub

ErrHandler:
  'if user canceled the dialogbox,
  If Err.Number = cdlCancel Then
    Exit Sub
  End If
  
  Debug.Assert False
  Resume Next
End Sub

Public Sub MenuClickCut()

  'if editing
  If txtEditName.Visible Or txtEditValue.Visible Then
    Exit Sub
  End If
  
  'for cut, make sure entire row is selected
  If fgGlobals.SelectionMode <> flexSelectionByRow Then
    fgGlobals.SelectionMode = flexSelectionByRow
  End If
  
  'copy, then delete
  MenuClickCopy
  MenuClickDelete
  'enable pasting
  frmMDIMain.mnuEPaste.Enabled = True
End Sub

Public Sub MenuClickDelete()
  
  'if more than one row is selected
  Dim i As Long, TopRow As Long, BtmRow As Long
  
  'if editing
  If txtEditName.Visible Or txtEditValue.Visible Then
    Exit Sub
  End If
  
  'ensure top row is <=bottom row
  If fgGlobals.RowSel < fgGlobals.Row Then
    TopRow = fgGlobals.RowSel
    BtmRow = fgGlobals.Row
  Else
    TopRow = fgGlobals.Row
    BtmRow = fgGlobals.RowSel
  End If
  
  'delete the selected rows
  '(go backwards so rows are deleted correctly)
  For i = BtmRow To TopRow Step -1
    RemoveRow i
  Next i
  
  'reset selection to a single row
  fgGlobals.Row = TopRow
  fgGlobals.Col = ctName
End Sub

Public Sub MenuClickHelp()
  
  On Error GoTo ErrHandler
  
  HtmlHelpS HelpParent, WinAGIHelp, HH_DISPLAY_TOPIC, "htm\winagi\Global Defines Editor.htm"
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Public Sub MenuClickExport()

  'save as
  
  Dim rtn As VbMsgBoxResult
  
  'if editing
  If txtEditName.Visible Or txtEditValue.Visible Then
    Exit Sub
  End If
  
  On Error Resume Next
  
  'set up commondialog
  With MainSaveDlg
    .DialogTitle = "Save Global Defines File"
    .DefaultExt = "txt"
    .Filter = "Text files (*.txt)|*.txt|All files (*.*)|*.*"
    .Flags = cdlOFNHideReadOnly Or cdlOFNPathMustExist Or cdlOFNExplorer
    .FilterIndex = 1
    .FullName = FileName
    .hWndOwner = frmMDIMain.hWnd
  End With
  
  Do
    MainSaveDlg.ShowSaveAs
    'if canceled,
    If Err.Number = cdlCancel Then
      'exit without doing anything
      Exit Sub
    End If
    
    'if file exists,
    If FileExists(MainSaveDlg.FullName) Then
      'verify replacement
      rtn = MsgBox(MainSaveDlg.FileName & " already exists. Do you want to overwrite it?", vbYesNoCancel + vbQuestion, "Overwrite file?")
      
      If rtn = vbYes Then
        Exit Do
      ElseIf rtn = vbCancel Then
        Exit Sub
      End If
    Else
      Exit Do
    End If
  Loop While True
  
  'save filename
  FileName = MainSaveDlg.FullName
  'use save method to finish
  MenuClickSave
End Sub

Public Sub MenuClickECustom1()
  
  'begin a logic search
  
  
  'if nothing to find,
  If LenB(fgGlobals.Text) = 0 Then
    Exit Sub
  End If
  
  'reset logic search
  FirstFind = False
  SearchStartLog = -1
  SearchStartPos = -1
  ClosedLogics = False
    
  'set global search values
  SearchFindText = fgGlobals.Text
  SearchFindDir = fdAll
  SearchMatchWord = True
  SearchMatchCase = False
  LogicSearchLoc = flAll
  
  'if the findform is visible,
  If FindForm.Visible Then
    'set it to match desired search parameters
    With FindForm
      'set form defaults
      .FindDir = SearchFindDir
      .MatchWord = SearchMatchWord
      .MatchCase = SearchMatchCase
      .LogicFindLoc = LogicSearchLoc
      .ReplaceText = vbNullString
      .FindText = SearchFindText
      
      'set find dialog to find textinlogic mode
      .SetForm ffFindLogic
    End With
  End If
  
  'ensure this form is the search form
  Set SearchForm = Me
  
  'find selected word in all logics
  FindInLogic fgGlobals.Text, fdAll, True, False, flAll
End Sub

Public Sub MenuClickInsert()

  'if editing
  If txtEditName.Visible Or txtEditValue.Visible Then
    Exit Sub
  End If
  
  'insert a row
  fgGlobals.AddItem vbNullString, fgGlobals.Row
  'now edit it
  fgGlobals_DblClick
End Sub

Public Sub MenuClickPaste()

  'take clipboard data, and add it to
  'grid, ignoring errors
  
  Dim strRows() As String, strItems() As String
  Dim strTemp As String, i As Long
  Dim Index As Long, blnErrors As Boolean
  Dim blnNoWarn As Boolean
  
  'if editing
  If txtEditName.Visible Or txtEditValue.Visible Then
    Exit Sub
  End If
  
  'convert crlf into just cr
  strTemp = Replace(Clipboard.GetText(vbCFText), vbCrLf, vbCr)
  'convert any remaining lf into cr
  strTemp = Replace(strTemp, vbLf, vbCr)
  
  'split text into rows based on carriage returns
  strRows = Split(strTemp, vbCr)
  
  'no edit row
  EditRow = -1
  'beginning index is curent row
  Index = fgGlobals.Row
  
  blnReserved = False
  blnDuplicates = False
  
  'add rows to end of list
  For i = 0 To UBound(strRows())
    'split row using tab
    strItems = Split(strRows(i), vbTab)
    
    'should be only two
    If UBound(strItems()) = 1 Then
      'validate the defines
      If ValidateDefine(strItems(0), strItems(1), True, Index) Then
        'increment index
        Index = Index + 1
      Else
        'bad define
        blnErrors = True
      End If
    Else
      'bad row
      blnErrors = True
    End If
  Next i
  
  'if errors
  If blnErrors Then
    MsgBox "Some entries could not be pasted because of formatting errors.", vbInformation + vbOKOnly, "Paste Errors"
  End If
End Sub
Public Sub MenuClickSave()

  'save list of globals
  
  Dim strTempFile As String
  Dim intFile As Integer
  Dim i As Long, strName As String, strValue As String
  Dim tmpNode As Node, rtn As VbMsgBoxResult, blnDontAsk As Boolean
  
  'if editing
  If txtEditName.Visible Or txtEditValue.Visible Then
    Exit Sub
  End If
  
  'replace any changed defines with new names
  Select Case Settings.AutoUpdateDefines
  Case 0
    'get user's response
    rtn = MsgBoxEx("Do you want to update all logics with any define names that have been changed?", vbQuestion + vbYesNo, "Update Logics?", WinAGIHelp, "htm\winagi\editingdefines.htm#edit", "Always take this action when saving the global defines list.", blnDontAsk)
    If blnDontAsk Then
      If rtn = vbYes Then
        Settings.AutoUpdateDefines = 2
      Else
        Settings.AutoUpdateDefines = 1
      End If
    End If
  Case 1
    rtn = vbNo
  Case 2
    rtn = vbYes
  End Select

  WaitCursor
  
  'if yes,
  If rtn = vbYes Then
    'step through all defines; if the current name is different than
    'the original name, use replaceall to make the change
    Load frmProgress
    frmProgress.pgbStatus.Max = fgGlobals.Rows
    frmProgress.pgbStatus.Value = 0
    frmProgress.Caption = "Updating Global Defines"
    frmProgress.lblProgress.Caption = "Locating modified defines"
    frmProgress.Show
    SafeDoEvents
    
    With fgGlobals
      For i = 1 To fgGlobals.Rows - 1
        frmProgress.pgbStatus.Value = i
        SafeDoEvents
        'if the original name (col0) is different from current name (col1)
        'then we need to replace it
        If .TextMatrix(i, 0) <> .TextMatrix(i, 1) Then
          ReplaceAll .TextMatrix(i, 0), .TextMatrix(i, 1), fdAll, True, True, flAll, rtGlobals
        End If
      Next i
    End With
    
    'all done
    Unload frmProgress
    'restore mouse pointer
    Screen.MousePointer = vbDefault
  End If

  On Error GoTo ErrHandler
  
  'create the new file
  strTempFile = TempFileName()
  intFile = FreeFile()
  
  Open strTempFile For Output As intFile
  
  'add a useful header
  Print #intFile, "["
  Print #intFile, "[ global defines file for "
  Print #intFile, "[ "; GameDir & GameID
  Print #intFile, "["
  
  'start with first entry
  For i = 1 To fgGlobals.Rows - 1
    Debug.Assert fgGlobals.RowData(i) = 0
    If fgGlobals.RowData(i) = 0 Then
      'get name and Value
      strName = fgGlobals.TextMatrix(i, ctName)
      strValue = fgGlobals.TextMatrix(i, ctValue)
      
      'verify something to add
      If LenB(strName) <> 0 And LenB(strValue) <> 0 Then
        'add it
        Print #intFile, "#define " & strName & " " & strValue
      End If
    End If
  Next i
  
  'close file
  Close intFile
  
  On Error Resume Next
  'erase any existing global file
  Kill GameDir & "globals.txt"
  
  On Error GoTo ErrHandler
  'copy tempfile to globals file
  FileCopy strTempFile, FileName
  
  On Error Resume Next
  'kill temp file
  Kill strTempFile
  
  'reset dirty flag
  IsDirty = False
  'set caption
  Caption = "Global Defines - "
  If GameLoaded Then
    Caption = Caption & GameID
    
    'force all logics to display as dirty
    Logics.MarkAllAsDirty
    
    'set them all to red text in the resource tree
    Set tmpNode = frmMDIMain.tvwResources.Nodes(2).Child
    Do Until tmpNode Is Nothing
      If FileExists(ResDir & Logics(CByte(tmpNode.Tag)).ID & LogicSourceSettings.SourceExt) Then
        tmpNode.ForeColor = vbRed
      End If
      Set tmpNode = tmpNode.Next
    Loop
    UpdateSelection SelResType, SelResNum, umPreview Or umProperty
    
  Else
    Caption = Caption & JustFileName(FileName)
  End If
    
  'disable menu and toolbar button
  frmMDIMain.mnuRSave.Enabled = False
  frmMDIMain.Toolbar1.Buttons("save").Enabled = False
  
  'restore cursor
  Screen.MousePointer = vbDefault
  
Exit Sub

ErrHandler:
  'something went wrong
  Debug.Assert False
  MsgBox "An error occurred while writing the global defines file. (Error number " & CStr(Err.Number) & "). You should check that the file manually by editing it as a text file.", vbCritical + vbOKOnly, "Global Defines File Error"
  'ensure file is closed
  Close intFile
  Err.Clear
End Sub

Public Sub MenuClickSelectAll()

  'if editing
  If txtEditName.Visible Or txtEditValue.Visible Then
    Exit Sub
  End If
  
  With fgGlobals
    .Col = 0
    .Row = 1
    .RowSel = fgGlobals.Rows - 1
    .ColSel = 2
    .SelectionMode = flexSelectionByRow
    .Highlight = flexHighlightAlways
  End With
End Sub

Public Sub MenuClickUndo()

  'if editing
  If txtEditName.Visible Or txtEditValue.Visible Then
    Exit Sub
  End If
  
  'TODO: implement an undo function for Globals editor
  'will need to create the undo class, determin what are
  'the actions that need to be undone, and what needs to
  'be saved with each undo object
  
  'add new define
  'edit existing define
  'delete define(s)
  'clear defines
  'import/add defines
  'paste defines
  
  'this might be completed in another releease, but not right now
  
End Sub

Public Sub RemoveRow(ByVal RowIndex As Long)

  'removes a row,
  'unless it is the last one
  
  'if this is last row OR only one row left
  If fgGlobals.Rows = 2 Or RowIndex = fgGlobals.Rows - 1 Then
    'set it to blank
    fgGlobals.TextMatrix(RowIndex, ctName) = vbNullString
    fgGlobals.TextMatrix(RowIndex, ctValue) = vbNullString
  Else
    'remove it
    fgGlobals.RemoveItem RowIndex
  End If
  
  'list has changed
  MarkAsDirty
  
  'adjust column widths by resizing
  Form_Resize
End Sub

Private Sub SetEditMenu()

  Dim strTemp As String
  
  On Error GoTo ErrHandler
  
  With frmMDIMain
    .mnuEdit.Enabled = True
    'redo, find, find again, replace and custom always hidden
    .mnuEBar1.Visible = False
    .mnuEFind.Visible = False
    .mnuERedo.Visible = False
    .mnuEFindAgain.Visible = False
    .mnuEReplace.Visible = False
    .mnuEBar2.Visible = False
    .mnuECustom1.Visible = False
    .mnuECustom2.Visible = False
    
    'undo is visible, but always disabled,
    .mnuEUndo.Visible = True
    .mnuEBar0.Visible = True
    .mnuEUndo.Enabled = False
    .mnuEUndo.Caption = "&Undo" & vbTab & "Ctrl+Z"
    
    'cut is enabled if selection is NOT on last row
    .mnuECut.Visible = True
    .mnuECut.Enabled = (fgGlobals.Row <> fgGlobals.Rows - 1)
    .mnuECut.Caption = "C&ut" & vbTab & "Ctrl+X"
    
    'copy is enabled as long as selection is NOT on last row (grid shown doesn't matter)
    .mnuECopy.Visible = True
    .mnuECopy.Enabled = (fgGlobals.Row <> fgGlobals.Rows - 1)
    .mnuECopy.Caption = "&Copy" & vbTab & "Ctrl+C"
    
    'paste available if globals data is on clipboard
    .mnuEPaste.Visible = True
    .mnuEPaste.Caption = "&Paste" & vbTab & "Ctrl+V"
    If Clipboard.GetFormat(vbCFText) Then
      'if text on clipboard has globals format (name-tab-val-cr...)
      strTemp = Clipboard.GetText(vbCFText)
      'checkf or tab character
      If InStr(2, strTemp, vbTab) <> 0 Then
        .mnuEPaste.Enabled = True
      Else
        .mnuEPaste.Enabled = False
      End If
    Else
      .mnuEPaste.Enabled = False
    End If
    
    'delete same as cut
    .mnuEDelete.Visible = True
    .mnuEDelete.Enabled = .mnuECut.Enabled
    .mnuEDelete.Caption = "&Delete" & vbTab & "Del"
    
    'clear will wipe out entire globals list (doesn't affect reserved grid)
    .mnuEClear.Visible = True
    .mnuEClear.Enabled = True
    .mnuEClear.Caption = "Clear List" & vbTab & "Shift+Del"
    
    'insert moves cursor to last row, and begins editing
    .mnuEInsert.Visible = True
    .mnuEInsert.Enabled = True
    .mnuEInsert.Caption = "Insert Row" & vbTab & "Shift+Ins"
    
    'selectall always available
    .mnuESelectAll.Visible = True
    .mnuESelectAll.Enabled = True
    .mnuESelectAll.Caption = "Select &All" & vbTab & "Ctrl+A"
    
    'ECustom1 visible if game loaded
    .mnuECustom1.Visible = GameLoaded
    ' enabled if selection mode is free
    .mnuECustom1.Enabled = (fgGlobals.SelectionMode = flexSelectionFree)
    .mnuECustom1.Caption = "&Find in Logics" & vbTab & "Shift+Ctrl+F"
    .mnuECustom2.Visible = GameLoaded
    .mnuECustom2.Enabled = True
    .mnuECustom2.Caption = "Edit Reserved Define Names"
    .mnuEBar2.Visible = GameLoaded
  End With
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Function AskClose() As Boolean

  Dim rtn As VbMsgBoxResult
  
  'assume ok to close
  AskClose = True
  
  On Error Resume Next
  
  'if dirty
  If IsDirty Then
    'ask if should save first
    rtn = MsgBox("Do you want to save changes to this global defines list?", vbQuestion + vbYesNoCancel, "Global Defines")
    
    Select Case rtn
    Case vbYes
      'save
      MenuClickSave
      
    Case vbCancel
      AskClose = False
    End Select
  End If
End Function

Private Sub SortGlobals(ByVal lngCol As Long)

  'sorts the global list by column
  Dim i As Long, j As Long
  Dim lngSwapRow As Long
  Dim tmpVal As String, blnBold As Boolean
  
  On Error GoTo ErrHandler

  #If DEBUGMODE <> 1 Then
    SendMessage fgGlobals.hWnd, WM_SETREDRAW, 0, 0
  #End If
  
  'show wait cursor
  WaitCursor
  
  'step through all rows
  For i = 1 To fgGlobals.Rows - 1
    'set swap row to starting row
    lngSwapRow = i
    For j = i + 1 To fgGlobals.Rows - 2
      'should row j be above swaprow?
      Select Case lngCol
      Case ctName
        If fgGlobals.TextMatrix(j, ctName) < fgGlobals.TextMatrix(lngSwapRow, ctName) Then
          'j is new swap row
          lngSwapRow = j
        End If
      Case ctValue
        'if isnumeric,
        If IsNumeric(fgGlobals.TextMatrix(j, ctValue)) Then
          If IsNumeric(fgGlobals.TextMatrix(lngSwapRow, ctValue)) Then
            If Val(fgGlobals.TextMatrix(j, ctValue)) < Val(fgGlobals.TextMatrix(lngSwapRow, ctValue)) Then
              lngSwapRow = j
            End If
          Else
            lngSwapRow = j
          End If
        Else
          If Not IsNumeric(fgGlobals.TextMatrix(lngSwapRow, ctValue)) Then
            If Left$(fgGlobals.TextMatrix(j, ctValue), 1) < Left$(fgGlobals.TextMatrix(lngSwapRow, ctValue), 1) Then
              'swap
              lngSwapRow = j
              
            'if both first letters are the same
            ElseIf Left$(fgGlobals.TextMatrix(j, ctValue), 1) = Left$(fgGlobals.TextMatrix(lngSwapRow, ctValue), 1) Then
              'are both numeric?
              If IsNumeric(Right$(fgGlobals.TextMatrix(j, ctValue), Len(fgGlobals.TextMatrix(j, ctValue)) - 1)) And IsNumeric(Right$(fgGlobals.TextMatrix(lngSwapRow, ctValue), Len(fgGlobals.TextMatrix(lngSwapRow, ctValue)) - 1)) Then
                'swap only if Value of j row is less than Value of swap row
                If Val(Right$(fgGlobals.TextMatrix(j, ctValue), Len(fgGlobals.TextMatrix(j, ctValue)) - 1)) < Val(Right$(fgGlobals.TextMatrix(lngSwapRow, ctValue), Len(fgGlobals.TextMatrix(lngSwapRow, ctValue)) - 1)) Then
                  lngSwapRow = j
                End If
              Else
                'swap if string is less than
                If fgGlobals.TextMatrix(j, ctValue) < fgGlobals.TextMatrix(lngSwapRow, ctValue) Then
                  lngSwapRow = j
                End If
              End If
            End If
          End If
        End If
        
      End Select
    Next j
    'if rows need to be swapped
    If lngSwapRow <> i Then
      With fgGlobals
        'swap name
        tmpVal = fgGlobals.TextMatrix(i, ctName)
        .TextMatrix(i, ctName) = .TextMatrix(lngSwapRow, ctName)
        .TextMatrix(lngSwapRow, ctName) = tmpVal
        'swap Value
        tmpVal = .TextMatrix(i, ctValue)
        .TextMatrix(i, ctValue) = .TextMatrix(lngSwapRow, ctValue)
        .TextMatrix(lngSwapRow, ctValue) = tmpVal
        'swap rowdata
        tmpVal = .RowData(i)
        .RowData(i) = .RowData(lngSwapRow)
        .RowData(lngSwapRow) = tmpVal
        'swap original name
        tmpVal = fgGlobals.TextMatrix(i, 0)
        .TextMatrix(i, 0) = .TextMatrix(lngSwapRow, 0)
        .TextMatrix(lngSwapRow, 0) = tmpVal
        
        'select swaprow to set colors  correctly
        .Row = lngSwapRow
        .Col = ctValue
        If .RowData(lngSwapRow) = 0 Then
          .CellForeColor = vbBlack
          .Col = ctName
          .CellForeColor = vbBlack
        Else
        Debug.Assert False
        'don't think this is ever possible
          .CellForeColor = EGAColor(7)
          .Col = ctName
          .CellForeColor = EGAColor(7)
        End If
        
        'check if bold status needs to be swapped too
        blnBold = .CellFontBold
        
        'now select i row, and set colors
        .Row = i
        .Col = ctValue
        If .RowData(i) = 0 Then
          .CellForeColor = vbBlack
          .Col = ctName
          .CellForeColor = vbBlack
        Else
        Debug.Assert False
        'don't believe this is ever possible; reserved defines are on separate tab now
          .CellForeColor = EGAColor(7)
          .Col = ctName
          .CellForeColor = EGAColor(7)
        End If
        
        'if bold status has changed,
        If .CellFontBold <> blnBold Then
          'make this row match blnBold
          .CellFontBold = blnBold
          If blnBold Then
            .CellForeColor = vbRed
          End If
          'make swap row match NOT blnBold
          .Row = lngSwapRow
          .Col = ctName
          .CellFontBold = Not blnBold
          If Not blnBold Then
            .CellForeColor = vbRed
          End If
        End If
      End With
      
      'don't mark as dirty; not actually changing anything
    End If
  Next i
  
  'select first item
  fgGlobals.Row = 1
  fgGlobals.Col = ctName
  If Not fgGlobals.RowIsVisible(1) Then
    fgGlobals.TopRow = fgGlobals.Row
  End If
  
  #If DEBUGMODE <> 1 Then
    SendMessage fgGlobals.hWnd, WM_SETREDRAW, 1, 0
  #End If
  fgGlobals.Refresh
  Screen.MousePointer = vbDefault
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Private Function StripComments(ByVal strLine As String) As String

  'strips off any comments on the line, and returns a trimmed string
  
  Dim blnInQuotes As Boolean
  Dim i As Long, lngLen As Long
  
  On Error GoTo ErrHandler
  
  'step through until end reached, or a comment marker found
  lngLen = Len(strLine)
  For i = 1 To lngLen
    Select Case Asc(Mid$(strLine, i))
    Case 34 'dbl quote
      'if not in a quote, we are now
      If Not blnInQuotes Then
        blnInQuotes = True
      Else
        'is this a real end quote? (check for \")
        If Mid$(strLine, i - 1, 1) <> "\" Then
          blnInQuotes = False
        End If
      End If
      
    Case 91 'bracket
      'if not in a quote, drop the rest of this line
      If Not blnInQuotes Then
        StripComments = Trim$(Left$(strLine, i - 1))
        Exit Function
      End If
    Case 47 'slash
      'if not in a quote, drop the rest of this line
      If Not blnInQuotes Then
        If Mid$(strLine, i + 1, 1) = "\" Then
          StripComments = Trim$(Left$(strLine, i - 1))
          Exit Function
        End If
      End If
    
    End Select
  Next i
  
  'return the string, trimmed
  StripComments = Trim$(strLine)
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Private Function ValidateDefine(ByVal strName As String, ByRef strValue As String, Optional ByVal WarnUser As Boolean = True, Optional ByRef Index As Long = -1) As Boolean

  Dim i As Long, j As Long
  Dim rtn As VbMsgBoxResult, blnNoWarn As Boolean
  Dim blnMark As Boolean
  
  On Error GoTo ErrHandler
  
  'validate the name and values seperately
  i = ValidateName(strName)
  j = ValidateValue(strValue)
  
  'check for error
  If (i >= 1 And i <= 6) Or i = 14 Or (j >= 15 And j <= 16) Then
    'just exit
    Exit Function
  End If
  
  'check for conditions that can be corrected or ignored
  Select Case i
  Case 7  'duplicate name
    'find the existing define
    For i = 1 To fgGlobals.Rows - 1
      If fgGlobals.TextMatrix(i, ctName) = strName Then
        Exit For
      End If
    Next i
    
    'if user needs warning, AND vaue is NOT the same
    If WarnUser And fgGlobals.TextMatrix(i, ctValue) <> strValue Then
      'does user want to replace this one?
      If Settings.WarnDupGName Then
        rtn = MsgBoxEx(ChrW$(39) & strName & "' is already defined in this list. Do" & vbNewLine & "you want to replace it with this define?", vbYesNo + vbQuestion + vbMsgBoxHelpButton, "Duplicate Global Define", WinAGIHelp, "htm\winagi\Global Defines.htm#syntax", "Don't show this warning again.", blnNoWarn)
        Settings.WarnDupGName = Not blnNoWarn
        'if now hiding, update settings file
        If Not Settings.WarnDupGName Then
          WriteAppSetting SettingsList, sGENERAL, "WarnDupGName", Settings.WarnDupGName
        End If
        
        If rtn = vbNo Then
          'same as error
          Exit Function
        End If
      End If
    End If
    
    'if Value DOES match
    If fgGlobals.TextMatrix(i, ctValue) = strValue Then
      'reset Value error so there isnt a useless warning
      j = 0
    End If
    
    'remove old one
    If i <> fgGlobals.Rows Then
      'delete row i
      fgGlobals.RemoveItem i
      blnDuplicates = True
    End If
    'if the deleted item is in front of insert pos
    If i < Index Then
      Index = Index - 1
    End If
    
  Case 8 To 13  'reserved var/flag/constant
    'always set flag so the entry gets marked as an override
    blnReserved = True
    'set flag so entry gets marked
    blnMark = True
    
    'if user needs warning
    If WarnUser Then
      'does user really want to re-defiine this name?
      If Settings.WarnResOvrd Then
        rtn = MsgBoxEx(ChrW$(39) & strName & "' is a reserved variable, flag or constant. Are you sure" & vbNewLine & "you want to override it?", vbYesNo + vbQuestion + vbMsgBoxHelpButton, "Duplicate Global Define", WinAGIHelp, "htm\winagi\Global Defines.htm#syntax", "Don't show this warning again.", blnNoWarn)
        Settings.WarnResOvrd = Not blnNoWarn
        'if now hiding update settings file
        If Not Settings.WarnResOvrd Then
          WriteAppSetting SettingsList, sGENERAL, "WarnResOvrd", Settings.WarnResOvrd
        End If
        
        If rtn = vbNo Then
          'same as error
          Exit Function
        End If
      End If
    End If
  End Select
  
  Select Case j
  Case 17 'unknown; probably string Value missing quotes
    'fix the define Value to be a string
    If Asc(strValue) <> 34 Then
      strValue = QUOTECHAR & strValue
    End If
    If Asc(Right$(strValue, 1)) <> 34 Then
      strValue = strValue & QUOTECHAR
    End If
    
  Case 18, 19 ' Value matches a reserved name, or Value matches a previously defined global name
    'if user needs warning
    If WarnUser Then
      'does user really want to re-defiine this name?
      If Settings.WarnDupGVal Then
        rtn = MsgBoxEx(ChrW$(39) & strValue & "' is already defined in this list, or as a reserved variable, flag or" & vbNewLine & _
                       "constant. Do you really want to have duplicate definitions for this Value?", vbYesNo + vbQuestion + vbMsgBoxHelpButton, "Duplicate Global Define", WinAGIHelp, "htm\winagi\Global Defines.htm#syntax", "Don't show this warning again.", blnNoWarn)
        Settings.WarnDupGVal = Not blnNoWarn
        
        'if now hiding update settings list
        If Not Settings.WarnDupGVal Then
          WriteAppSetting SettingsList, sGENERAL, "WarnDupGVal", Settings.WarnDupGVal
        End If
        
        If rtn = vbNo Then
          'same as error
          Exit Function
        End If
      End If
    End If
  End Select
  
  'no error- ok to add
  
  'if no position
  If Index = -1 Then
    'add it
    fgGlobals.AddItem Trim$(strName) & vbTab & Trim$(strName) & vbTab & Trim$(strValue)
    MarkAsDirty
    'set mark Value
    i = fgGlobals.Rows - 1
  Else
    'add it at Index position
    fgGlobals.AddItem Trim$(strName) & vbTab & Trim$(strName) & vbTab & Trim$(strValue), Index
    MarkAsDirty
    i = Index
  End If
  
  'if this is a reserved define that needs to be marked
  If blnMark Then
    'mark it by highlighting
    fgGlobals.Row = i
    fgGlobals.Col = ctName
    fgGlobals.CellFontBold = True
    fgGlobals.CellForeColor = vbRed
  End If
  
  ValidateDefine = True
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function
Private Function ValidateName(NewDefName As String) As Long
  'validates if a define name is agreeable or not
  'returns zero if ok;
  'error Value if not
  
  '1 = no name
  '2 = name is numeric
  '3 = name is command
  '4 = name is test command
  '5 = name is a compiler keyword
  '6 = name is an argument marker
  '7 = name is already globally defined
  '8 = name is reserved variable name
  '9 = name is reserved flag name
  '10 = name is reserved number constant
  '11 = name is reserved object constant
  '12 = name is reserved message constant
  '13 = name contains improper character
    
  Dim i As Long
  Dim tmpDefines() As TDefine
  
  On Error GoTo ErrHandler
  
  'if no name,
  If LenB(NewDefName) = 0 Then
    ValidateName = 1
    Exit Function
  End If
  
  'name cant be numeric
  If IsNumeric(NewDefName) Then
    ValidateName = 2
    Exit Function
  End If
  
  'check against regular commands
  For i = 0 To Commands.Count
    If NewDefName = Commands(i).Name Then
      ValidateName = 3
      Exit Function
    End If
  Next i
  
  'check against test commands
  For i = 0 To TestCommands.Count
    If NewDefName = TestCommands(i).Name Then
      ValidateName = 4
      Exit Function
    End If
  Next i
  
  'check against keywords
  If (NewDefName = "if") Or (NewDefName = "else") Or (NewDefName = "goto") Then
    ValidateName = 5
    Exit Function
  End If
      
  'check against variable/flag/controller/string/message names
  Select Case Asc(LCase$(NewDefName))
  '     v    f    m    o    i    s    w    c
  Case 118, 102, 109, 111, 105, 115, 119, 99
    If IsNumeric(Right$(NewDefName, Len(NewDefName) - 1)) Then
      ValidateName = 6
      Exit Function
    End If
  End Select
  
  If LogicSourceSettings.UseReservedNames Then
    'check against reserved names
    tmpDefines = LogicSourceSettings.ReservedDefines(atVar)
    For i = 0 To UBound(tmpDefines)
      If NewDefName = tmpDefines(i).Name Then
        ValidateName = 8
        Exit Function
      End If
    Next i
    tmpDefines = LogicSourceSettings.ReservedDefines(atFlag)
    For i = 0 To UBound(tmpDefines)
      If NewDefName = tmpDefines(i).Name Then
        ValidateName = 9
        Exit Function
      End If
    Next i
    tmpDefines = LogicSourceSettings.ReservedDefines(atNum)
    For i = 0 To UBound(tmpDefines)
      If NewDefName = tmpDefines(i).Name Then
        ValidateName = 10
        Exit Function
      End If
    Next i
    tmpDefines = LogicSourceSettings.ReservedDefines(atSObj)
    For i = 0 To UBound(tmpDefines)
      If NewDefName = tmpDefines(i).Name Then
        ValidateName = 11
        Exit Function
      End If
    Next i
    tmpDefines = LogicSourceSettings.ReservedDefines(atDefStr)
    For i = 0 To UBound(tmpDefines)
      If NewDefName = tmpDefines(i).Name Then
        ValidateName = 12
        Exit Function
      End If
    Next i
  End If
  
  'check against existing globals (skip editrow)
  '(do this check after checking reserved because reserved defines may be displayed
  For i = 1 To fgGlobals.Rows - 1
    If (NewDefName = fgGlobals.TextMatrix(i, ctName)) And i <> EditRow Then
      ValidateName = 7
      Exit Function
    End If
  Next i
  
  'check name against improper character list
  For i = 1 To Len(NewDefName)
    Select Case Asc(Mid$(NewDefName, i, 1))
    '!"#$%&'()*+,-/:;<=>?@[\]^`{|}~
    Case 32 To 45, 47, 58 To 64, 91 To 94, 96, Is >= 123
      ValidateName = 13
      Exit Function
    End Select
  Next i
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function
Private Function ValidateValue(ByVal NewDefValue As String) As Long
  'validates if a define Value is agreeable or not
  'returns zero if ok;
  'error Value if not

  '14 = no Value
  '15 = undefined
  '16 = Value contains an invalid argument Value
  '17 = Value is not a string, number or argument marker
  '18 = Value is already defined by a reserved name
  '19 = Value is already defined by a global name


  Dim strVal As String
  Dim i As Long
  
  On Error GoTo ErrHandler
  
  'check for no value
  If LenB(NewDefValue) = 0 Then
    ValidateValue = 14
    Exit Function
  End If
  
  'values must be a variable/flag/etc, string, or a number
  If Not IsNumeric(NewDefValue) Then
    'if Value is an argument marker
    Select Case Asc(LCase$(NewDefValue))
    '     v    f    m    o    i    s    w    c
    Case 118, 102, 109, 111, 105, 115, 119, 99
      'if rest of Value is numeric,
      strVal = Right$(NewDefValue, Len(NewDefValue) - 1)
      'if it is numeric
      If IsNumeric(strVal) Then
        'if Value is not between 0-255
        If Val(strVal) < 0 Or Val(strVal) > 255 Then
          ValidateValue = 16
          Exit Function
        End If
        
        'if using reserved words
        If LogicSourceSettings.UseReservedNames Then
          'if Value is a variable
          If Asc(LCase$(NewDefValue)) = 118 Then
            'if already defined as a reserved variable
            If Val(strVal) <= 26 Then
              'set error
              ValidateValue = 18
              Exit Function
            End If
          End If
          
          'if Value is a flag
          If Asc(LCase$(NewDefValue)) = 102 Then
            'if already defined as a reserved variable
            If Val(strVal) <= 16 Then
              'set error
              ValidateValue = 18
              Exit Function
            ElseIf Val(strVal) = 20 And Val(InterpreterVersion) >= 3.002102 Then
              'set error
              ValidateValue = 18
              Exit Function
            End If
          End If
          
          'if Value is o0
          If NewDefValue = "o0" Then
            'set error
            ValidateValue = 18
            Exit Function
          End If
          
          'if Value is s0
          If NewDefValue = "s0" Then
            'set error
            ValidateValue = 18
            Exit Function
          End If
        End If
        
        'check against existing globals (skip editrow)
        For i = 1 To fgGlobals.Rows - 1
          If (NewDefValue = fgGlobals.TextMatrix(i, ctValue)) And i <> EditRow Then
            'set error
            ValidateValue = 19
            Exit Function
          End If
        Next i
        
        'Value is ok
        Exit Function
      End If
    End Select
    
    'could be a string
    'check Value for string delimiters in Value
    If Asc(NewDefValue) <> 34 And Asc(Right$(NewDefValue, 1)) <> 34 Then
      ValidateValue = 17
      Exit Function
    End If
  End If
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function
Private Function ValidateInput() As Boolean
  
  Dim rtn As Long, msgRtn As VbMsgBoxResult
  Dim strText As String, blnBlank As Boolean
  Dim strErrMsg As String, blnOverride As Boolean
  Dim blnNoWarn As Boolean
  
  'checks input for new name/Value; if OK, add it to grid
  On Error GoTo ErrHandler
  
  'if no change made, that's OK
  Select Case EditCol
  Case ctName  'name
    'if name in textbox matches previous Value
    If txtEditName.Text = EditDefine.Name Then
      'no change made; return success
      ValidateInput = True
      Exit Function
    End If
    
    'if blank, do we consider it deletion of entire line?
    If Len(txtEditName.Text) = 0 Then
      If Settings.DelBlankG = 0 Then
        rtn = MsgBoxEx("Blank global define names are not allowed. Delete this global define?", _
              vbQuestion + vbYesNo + vbMsgBoxHelpButton, "Delete Blank Define", WinAGIHelp, "htm\winagi\Global Defines.htm#syntax", _
              "Always take this action", blnNoWarn)
        If blnNoWarn Then
          If rtn = vbNo Then Settings.DelBlankG = 1
          If rtn = vbYes Then Settings.DelBlankG = 2
        End If
      Else
        If Settings.DelBlankG = 1 Then rtn = vbNo
        If Settings.DelBlankG = 2 Then rtn = vbYes
      End If
      
      'if no, then let the validation function handle it
      'but if yes, then exit; calling function will know what to do
      If rtn = vbYes Then
        ValidateInput = True
        Exit Function
      End If
    End If
     
  Case ctValue  'Value
    'if Value in textbox matches previous Value
    If txtEditValue.Text = EditDefine.Value Then
      'no change made; return success
      ValidateInput = True
      Exit Function
    End If
  End Select
  
  'make local copies of name or Value
  If EditCol = ctName Then
    strText = txtEditName.Text
  Else
    strText = txtEditValue.Text
  End If
  
  'validate the define name and Value
  If EditCol = ctName Then
    rtn = ValidateName(strText)
  Else
    rtn = ValidateValue(strText)
  End If
  
  'if return code indicates error
  If rtn <> 0 Then
    Select Case rtn
    Case 1 ' no name
      strErrMsg = "Define name cannot be blank."
      EditCol = ctName
    Case 2 ' name is numeric
      strErrMsg = "Define names cannot be numeric."
      EditCol = ctName
    Case 3 ' name is command
      strErrMsg = ChrW$(39) & strText & "' is an AGI command, and cannot be redefined"
      EditCol = ctName
    Case 4 ' name is test command
      strErrMsg = ChrW$(39) & strText & "' is an AGI test command, and cannot be redefined"
      EditCol = ctName
    Case 5 ' name is a compiler keyword
      strErrMsg = ChrW$(39) & strText & "' is a compiler reserved word, and cannot be redefined"
      EditCol = ctName
    Case 6 ' name is an argument marker
      strErrMsg = "invalid define statement - define names cannot be argument markers"
      EditCol = ctName
    Case 7 ' name is already defined
      strErrMsg = ChrW$(39) & strText & "' is already in use as a global define"
      EditCol = ctName
    Case 8 ' name is reserved variable name
      'verify user wants to override
      If Settings.WarnResOvrd Then
        msgRtn = MsgBoxEx(ChrW$(39) & strText & "' is a reserved variable name." & vbNewLine & _
                 "Are you sure you want to override it?", vbYesNo + vbQuestion + vbMsgBoxHelpButton, "Validate Global Define", WinAGIHelp, "htm\winagi\Global Defines.htm#syntax", _
                 "Don't show this warning again.", blnNoWarn)
        Settings.WarnResOvrd = Not blnNoWarn
      Else
        'override without asking
        msgRtn = vbYes
      End If
      
      If msgRtn = vbYes Then
        blnOverride = True
        rtn = 0
      Else
        'set error code to -1
        rtn = -1
        'set column to name
        EditCol = ctName
      End If
    Case 9 ' name is reserved flag name
      'verify user wants to override
      If Settings.WarnResOvrd Then
        msgRtn = MsgBoxEx(ChrW$(39) & strText & "' is a reserved flag name." & vbNewLine & _
                 "Are you sure you want to override it?", vbQuestion + vbYesNo + vbMsgBoxHelpButton, "Validate Global Define", WinAGIHelp, "htm\winagi\Global Defines.htm#syntax", _
                 "Don't show this warning again.", blnNoWarn)
        Settings.WarnResOvrd = Not blnNoWarn
      Else
        'override without asking
        msgRtn = vbYes
      End If
      
      If msgRtn = vbYes Then
        blnOverride = True
        rtn = 0
      Else
        'set error code to -1
        rtn = -1
        'set column to name
        EditCol = ctName
      End If
      
    Case 10 ' name is reserved number constant
      'verify user wants to override
      If Settings.WarnResOvrd Then
        msgRtn = MsgBoxEx(ChrW$(39) & strText & "' is a reserved number constant." & vbNewLine & _
                 "Are you sure you want to override it?", vbYesNo + vbQuestion + vbMsgBoxHelpButton, "Validate Global Define", WinAGIHelp, "htm\winagi\Global Defines.htm#syntax", _
                 "Don't show this warning again.", blnNoWarn)
        Settings.WarnResOvrd = Not blnNoWarn
      Else
        'override without asking
        msgRtn = vbYes
      End If
      
      If msgRtn = vbYes Then
        blnOverride = True
        rtn = 0
      Else
        'set error code to -1
        rtn = -1
        'set column to name
        EditCol = ctName
      End If
      
    Case 11 ' name is reserved object constant
      'verify user wants to override
      If Settings.WarnResOvrd Then
        msgRtn = MsgBoxEx(ChrW$(39) & strText & "' is a reserved object name." & vbNewLine & _
                 "Are you sure you want to override it?", vbYesNo + vbQuestion + vbMsgBoxHelpButton, "Validate Global Define", WinAGIHelp, "htm\winagi\Global Defines.htm#syntax", _
                 "Don't show this warning again.", blnNoWarn)
        Settings.WarnResOvrd = Not blnNoWarn
      Else
        'override without asking
        msgRtn = vbYes
      End If
      
      If msgRtn = vbYes Then
        blnOverride = True
        rtn = 0
      Else
        'set error code to -1
        rtn = -1
        'set column to name
        EditCol = ctName
      End If
    Case 12 ' name is reserved message constant
      'verify user wants to override
      If Settings.WarnResOvrd Then
        msgRtn = MsgBoxEx(ChrW$(39) & strText & "' is a reserved message constant." & vbNewLine & _
                 "Are you sure you want to override it?", vbYesNo + vbQuestion + vbMsgBoxHelpButton, "Validate Global Define", WinAGIHelp, "htm\winagi\Global Defines.htm#syntax", _
                 "Don't show this warning again.", blnNoWarn)
        Settings.WarnResOvrd = Not blnNoWarn
      Else
        'override without asking
        msgRtn = vbYes
      End If
      
      If msgRtn = vbYes Then
        blnOverride = True
        rtn = 0
      Else
        'set error code to -1
        rtn = -1
        'set column to name
        EditCol = ctName
      End If
      
    Case 13 ' name contains improper character
      strErrMsg = "Invalid character in define name: !" & QUOTECHAR & "#$%&'()*+,-/:;<=>?@[\]^`{|}~ and spaces are not allowed"
      EditCol = ctName
      
    Case 14 ' no Value
      strErrMsg = "Define Value cannot be blank."
      EditCol = ctValue
    Case 15 ' undefined
    
    Case 16 ' Value contains an invalid argument Value
      strErrMsg = "Argument Value out of range (must be 0 - 255)"
      EditCol = ctValue
    Case 17 ' Value is not a string, number or argument marker
      'fix the define Value to be a string
      If Asc(txtEditValue.Text) <> 34 Then
        txtEditValue.Text = QUOTECHAR & txtEditValue.Text
      End If
      If Asc(Right$(txtEditValue.Text, 1)) <> 34 Then
        txtEditValue.Text = txtEditValue.Text & QUOTECHAR
      End If
      'reset return to zero, so error is ignored
      rtn = 0
    Case 18, 19 ' Value is already defined by a reserved name
      'does user really want to re-defiine this name?
      If Settings.WarnDupGVal Then
        msgRtn = MsgBoxEx(ChrW$(39) & strText & "' is already defined in this list, or as a reserved variable, flag or" & vbNewLine & _
                       "constant. Do you really want to have duplicate definitions for this Value?", vbYesNo + vbQuestion + vbMsgBoxHelpButton, "Duplicate Global Define", WinAGIHelp, "htm\winagi\Global Defines.htm#syntax", "Don't show this warning again.", blnNoWarn)
        Settings.WarnDupGVal = Not blnNoWarn
        
        If msgRtn = vbNo Then
          'same as error
          rtn = -1
          EditCol = ctValue
        Else
          'reset return to zero, so error is ignored
          rtn = 0
        End If
      Else
        'reset return to zero, so error is ignored
        rtn = 0
      End If
      
    End Select
  End If
  
  'if still an error code
  If rtn <> 0 Then
    'force back to edit row
    fgGlobals.Row = EditRow
    'set col to edit col
    fgGlobals.Col = EditCol
    
    'if user tried to redefine a reserved word,
    'a msgbox was already displayed; don't need to
    'show msgbox again
    'rtn is set to -1 if the msgbox was already shown
    If rtn <> -1 Then
      'show msgbox
      MsgBox strErrMsg, vbInformation + vbOKOnly, "Global Define Syntax Error"
'      'force focus back
'      If Me.txtEditName.Visible Then
'        txtEditName.SetFocus
'      End If
'      If Me.txtEditValue.Visible Then
'        txtEditValue.SetFocus
'      End If
    End If
    Exit Function
  Else
    'make change
    'force font to normal, if it turns out to be
    'a duplicate, the msghandler will set it to bold red
    If blnOverride Then
      fgGlobals.CellFontBold = True
      fgGlobals.CellForeColor = vbRed
    Else
      fgGlobals.CellFontBold = False
      fgGlobals.CellForeColor = 0
    End If
    
    'put the text back into grid
    If EditCol = ctName Then
      fgGlobals.TextMatrix(EditRow, EditCol) = txtEditName.Text
    Else
      fgGlobals.TextMatrix(EditRow, EditCol) = txtEditValue.Text
    End If
  End If
  
  'change made; file is dirty; enable save
  MarkAsDirty
  'valid;
  ValidateInput = True
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Public Sub fgGlobals_DblClick()
  
  On Error GoTo ErrHandler
  
  'save row and column being edited
  EditRow = fgGlobals.Row
  EditCol = fgGlobals.Col
  
  'save current define in case of cancel
  EditDefine.Name = fgGlobals.TextMatrix(EditRow, ctName)
  EditDefine.Value = fgGlobals.TextMatrix(EditRow, ctValue)

  'begin edit
  Select Case EditCol
  Case ctName
    'disable edit menu
    frmMDIMain.mnuEdit.Enabled = False
    
    'switch to edit name mode
    With txtEditName
      .Move fgGlobals.CellLeft + CellIndentH, fgGlobals.CellTop + fgGlobals.Top + CellIndentV, fgGlobals.CellWidth - CellIndentH, fgGlobals.CellHeight - CellIndentV
      .Text = fgGlobals.Text
      'Debug.Print "   grid_dblclick - show txtEditName"
      .Visible = True
      'select all
      .SelStart = 0
      .SelLength = Len(.Text)
      .SetFocus
    End With

  Case ctValue
    'dont edit, if this is last row
    'user has to start edit in name column
    If EditRow = fgGlobals.Rows - 1 Then
      Exit Sub
    End If
    
    'disable edit menu
    frmMDIMain.mnuEdit.Enabled = False
    
    'switch to edit value mode
    With txtEditValue
      .Move fgGlobals.CellLeft + CellIndentH, fgGlobals.CellTop + fgGlobals.Top + CellIndentV, fgGlobals.CellWidth - CellIndentH, fgGlobals.CellHeight - CellIndentV
      .Text = fgGlobals.Text
      .Visible = True
      'select all
      .SelStart = 0
      .SelLength = Len(.Text)
      .SetFocus
    End With
  End Select
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub fgGlobals_EnterCell()

  SetEditMenu
End Sub

Private Sub fgGlobals_GotFocus()
'Debug.Print "fgGlobals_GotFocus"
End Sub

Private Sub fgGlobals_KeyPress(KeyAscii As Integer)

  On Error GoTo ErrHandler
  
  'some keys should be ignored...?
  Select Case KeyAscii
  Case 9  'tab
    With fgGlobals
      'if on name, move to column
      If .Col = ctName Then
        .Col = ctValue
      Else
        If .Row < .Rows - 1 Then '(to account for header row)
          .Row = .Row + 1
          .Col = 1
        End If
      End If
    End With
    KeyAscii = 0
    
  Case 10, 13 'enter key
    'same as dbl-click
    fgGlobals_DblClick
    KeyAscii = 0
    
  Case Else
    'if in the empty row, AND on name column, begin editing
    If fgGlobals.Row = fgGlobals.Rows - 1 And fgGlobals.Col = 1 Then
      fgGlobals_DblClick
      txtEditName.Text = ChrW$(KeyAscii)
      txtEditName.SelStart = 1
    End If
  End Select
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Public Sub fgGlobals_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  
  Dim tmpRow As Long, tmpCol As Long
  Dim TopRow As Long, BtmRow As Long

  On Error GoTo ErrHandler
  
  If txtEditName.Visible Or txtEditValue.Visible Then
    Exit Sub
  End If

  With fgGlobals
    tmpCol = .MouseCol
    tmpRow = .MouseRow

    'if right click
    If Button = vbRightButton Then
      'determine top/bottom rows
      If .Row < .RowSel Then
        TopRow = .Row
        BtmRow = .RowSel
      Else
        TopRow = .RowSel
        BtmRow = .Row
      End If

      'if row and column are NOT within selected area
      If tmpRow < TopRow Or tmpRow > BtmRow Then
        'make new selection
        'check for selection of entire row
        If X < ScreenTWIPSX * 12 Then
          'select entire row
          .Col = 0
          .Row = tmpRow
          .ColSel = 2
          .SelectionMode = flexSelectionByRow
          .Highlight = flexHighlightAlways
          .MergeCells = flexMergeNever
        Else
          'select freely
          .Col = tmpCol
          .Row = tmpRow
          .SelectionMode = flexSelectionFree
          .Highlight = flexHighlightNever
          .MergeCells = flexMergeRestrictAll
        End If
      End If

      'if on an editable row
      If tmpRow > 0 Then
        'set edit menu parameters
        SetEditMenu

        'need doevents so form activation occurs BEFORE popup
        'otherwise, errors will be generated because of menu
        'adjustments that are made in the form_activate event
        SafeDoEvents
        'show popup menu
        PopupMenu frmMDIMain.mnuEdit
      End If
      'done with right click activities
      Exit Sub
    End If

    'check for selection of entire row
    If X < ScreenTWIPSX * 12 Then
      'select entire row
      .Col = 0
      .SelectionMode = flexSelectionByRow
      .Highlight = flexHighlightAlways
      .MergeCells = flexMergeNever
      .ColSel = 2
    
    'check for cursor in range of splitting
    ElseIf (X > .ColWidth(ctName) - SplitWidth / 2) And (X < .ColWidth(ctName) + SplitWidth / 2) Then
      'start splitting
      picSplit.Visible = True
      SplitOffset = .ColWidth(ctName) - X
      picSplit.Left = X + SplitOffset
      Exit Sub

    'check for left-click on header
    ElseIf tmpRow = 0 Then
      'sort, depending on column
      SortGlobals tmpCol
      Exit Sub
    Else
      'select freely
      If tmpCol <> -1 Then
        .Col = tmpCol
      Else
        .Col = ctName
      End If
      .Row = tmpRow
      .SelectionMode = flexSelectionFree
      .Highlight = flexHighlightNever
      .MergeCells = flexMergeRestrictAll
    End If
  End With
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub fgGlobals_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  
  Dim Pos As Single

  On Error GoTo ErrHandler
  
  'if not active form
  If Not frmMDIMain.ActiveForm Is Me Then
    Exit Sub
  End If

  'if editing,
  If txtEditName.Visible Or txtEditValue.Visible Then
    Exit Sub
  End If

  'if splitting
  If picSplit.Visible Then
    Pos = (X + SplitOffset)
    'validate it
    If Pos < fgGlobals.Width * 0.2 Then
      Pos = fgGlobals.Width * 0.2
    ElseIf Pos > fgGlobals.Width * 0.8 Then
      Pos = fgGlobals.Width * 0.8
    End If
    'move splitter
    picSplit.Left = Pos
    
  'elseif within splitzone
  ElseIf (X > fgGlobals.ColWidth(ctName) - SplitWidth / 2) And (X < fgGlobals.ColWidth(ctName) + SplitWidth / 2) Then
    'show split cursor
    fgGlobals.MousePointer = flexSizeEW

  'elseif on left edge,
  ElseIf X < 12 * ScreenTWIPSX Then
    'set cursor to row selector
    fgGlobals.MousePointer = flexCustom
    Set fgGlobals.MouseIcon = LoadResPicture("EGC_SELROW", vbResCursor)
  Else
    'set cursor to normal
    fgGlobals.MousePointer = flexDefault
  End If
  
  'if left button is down, begin dragging
  If Button = vbLeftButton Then
    If Not DroppingGlobal Then
      'if something selected,
      If fgGlobals.Col = 1 And fgGlobals.Row > 1 And fgGlobals.RowSel = fgGlobals.Row Then
        fgGlobals.OLEDrag
      End If
    End If
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Private Sub fgGlobals_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  
  Dim Pos As Single

  On Error GoTo ErrHandler
  
  'if splitting
  If picSplit.Visible Then
    'stop splitting
    picSplit.Visible = False
    
    With fgGlobals
      'validate position
      Pos = (X + SplitOffset)
      If Pos < 0.2 * .Width Then
        Pos = 0.2 * .Width
      ElseIf Pos > 0.8 * .Width Then
        Pos = 0.8 * .Width
      End If
  
      'reset columns
      .ColWidth(ctName) = Pos
  
      'check if top and bottom rows are both visible
      If .RowIsVisible(1) And .RowIsVisible(.Rows - 1) Then
        'no scrollbar
        'set width of second column
        .ColWidth(ctValue) = .Width - .ColWidth(ctName) - 2 * ScreenTWIPSX
      Else
        'take into account scrollbar
        .ColWidth(ctValue) = .Width - .ColWidth(ctName) - 17 * ScreenTWIPSX
      End If
    End With
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Private Sub fgGlobals_OLECompleteDrag(Effect As Long)

  'reset dragging flag
  DroppingGlobal = False
End Sub

Private Sub fgGlobals_OLEStartDrag(Data As MSFlexGridLib.DataObject, AllowedEffects As Long)

  On Error GoTo ErrHandler
  
  'wtf? for some reason, in the middle of a mouse down/mouse up
  'operation, the drag event fires; this effs up the splitting operation
  
  If picSplit.Visible Then
    'cancel drag/drop, so split action works as desired
    AllowedEffects = vbDropEffectNone
    Exit Sub
  End If
  
  'set global drop flag (so logics (or other text receivers) know
  'when an object is being dropped
  DroppingGlobal = True
  
  'set allowed effects to copy only
  AllowedEffects = vbDropEffectCopy
  Data.SetData fgGlobals.TextMatrix(fgGlobals.Row, 1), vbCFText
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Private Sub fgGlobals_Scroll()

  On Error GoTo ErrHandler
  
  'move txtbox, if visible
  If txtEditName.Visible Then
    txtEditName.Move fgGlobals.CellLeft + CellIndentH, fgGlobals.CellTop + fgGlobals.Top + CellIndentV, fgGlobals.CellWidth - CellIndentH, fgGlobals.CellHeight - CellIndentV
  End If
  If txtEditValue.Visible Then
    txtEditValue.Move fgGlobals.CellLeft + CellIndentH, fgGlobals.CellTop + fgGlobals.Top + CellIndentV, fgGlobals.CellWidth - CellIndentH, fgGlobals.CellHeight - CellIndentV
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub Form_Activate()

  On Error Resume Next

  'if minimized, exit
  '(to deal with occasional glitch causing focus to lock up)
  If Me.WindowState = vbMinimized Then
    Exit Sub
  End If
  
  'if hiding prevwin on lost focus, hide it now
  If Settings.HidePreview Then
    PreviewWin.Hide
  End If
 
  'if visible,
  If Visible Then
    'force resize
    Form_Resize
  End If

  'if findform is visible,
  If FindForm.Visible Then
    'hide it it
    FindForm.Visible = False
  End If

  'adjust menus and statusbar
  AdjustMenus rtGlobals, GameLoaded, True, IsDirty

  'set edit menu
  SetEditMenu

  If txtEditName.Visible Then
    txtEditName.SetFocus
  End If
  If txtEditValue.Visible Then
    txtEditValue.SetFocus
  End If
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

  'detect and respond to keyboard shortcuts
  
  'always check for help key
  If KeyCode = vbKeyF1 And Shift = 0 Then
    MenuClickHelp
    KeyCode = 0
    Exit Sub
  End If

  'if editing something
  If txtEditName.Visible Or txtEditValue.Visible Then
    Exit Sub
  End If

  'check for global shortcut keys
  CheckShortcuts KeyCode, Shift
  If KeyCode = 0 Then
    Exit Sub
  End If

  Select Case Shift
  Case 0
    Select Case KeyCode
    Case vbKeyDelete
      If frmMDIMain.mnuEDelete.Enabled And Not txtEditName.Visible Then
        MenuClickDelete
        KeyCode = 0
      End If
    End Select

  Case vbCtrlMask
    Select Case KeyCode
    Case vbKeyA
      If frmMDIMain.mnuESelectAll.Enabled And Not txtEditName.Visible Then
        MenuClickSelectAll
        KeyCode = 0
      End If

    Case vbKeyC
      If frmMDIMain.mnuECopy.Enabled And Not txtEditName.Visible Then
        MenuClickCopy
        KeyCode = 0
      End If

    Case vbKeyX
      If frmMDIMain.mnuECut.Enabled And Not txtEditName.Visible Then
        MenuClickCut
        KeyCode = 0
      End If

    Case vbKeyV
      If frmMDIMain.mnuEPaste.Enabled And Not txtEditName.Visible Then
        MenuClickPaste
        KeyCode = 0
      End If
    End Select

  Case vbShiftMask
    Select Case KeyCode
    Case vbKeyDelete
      If frmMDIMain.mnuEClear.Enabled Then
        MenuClickClear
        KeyCode = 0
      End If
    Case vbKeyInsert
      If frmMDIMain.mnuEInsert.Enabled Then
        MenuClickInsert
        KeyCode = 0
      End If
    End Select

  Case 3 'vbShiftMask + vbCtrlMask
    Select Case KeyCode
    Case vbKeyF
      If frmMDIMain.mnuECustom1.Enabled Then
        MenuClickECustom1
        KeyCode = 0
      End If
    End Select

  Case vbAltMask
    Select Case KeyCode
    Case vbKeyF
      If frmMDIMain.mnuRCustom1.Enabled Then
        MenuClickCustom1
        KeyCode = 0
      End If
    End Select
  End Select
End Sub

Private Sub Form_Load()

  On Error GoTo ErrHandler

  CalcWidth = MinWidth
  CalcHeight = MinHeight
  
  'hide column 0 (it's used to hold the starting name of a define
  '               so we can tell if it changed when the list is saved)
  fgGlobals.ColWidth(0) = 0
  
  'set font
  InitFonts

  'set initial column width to half of grid width
  fgGlobals.ColWidth(1) = fgGlobals.Width / 2

  'set indent Value
  CellIndentH = ScreenTWIPSX * 4
  CellIndentV = ScreenTWIPSY * 1

  'set both columns to leftcenter alignment
  fgGlobals.ColAlignment(1) = flexAlignLeftCenter
  fgGlobals.ColAlignment(2) = flexAlignLeftCenter
  
#If DEBUGMODE <> 1 Then
  'subclass the flexgrid
  PrevFGWndProc = SetWindowLong(Me.fgGlobals.hWnd, GWL_WNDPROC, AddressOf ScrollWndProc)
#End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Public Sub LoadGlobalDefines(ByVal GlobalFile As String, Optional ClearAll As Boolean = True)

  'loads the current global defines list into the grid for editing

  Dim intFile As Integer
  Dim strLine As String, strSplitLine() As String
  Dim i As Long, j As Long
  Dim tmpDefines() As TDefine
'''  Dim blnNoWarn As Boolean
  
  On Error GoTo ErrHandler
  
  blnDuplicates = False
  blnReserved = False
  'no edit row
  EditRow = -1
  
  'if clearing all
  If ClearAll Then
    'clear the flexgrid
    ClearGlobalDefines
  Else
    'remove last blank row
    If fgGlobals.TextMatrix(fgGlobals.Rows - 1, ctName) = vbNullString Then
      'if this is last row,
      If fgGlobals.Rows = 2 Then
        'clear it
        ClearGlobalDefines
      Else
        fgGlobals.RemoveItem fgGlobals.Rows - 1
      End If
    End If
    
    'move cursor to last row
    fgGlobals.Col = ctName
    fgGlobals.Row = fgGlobals.Rows - 1
  End If
  
  'open file for input
  intFile = FreeFile()
  Open GlobalFile For Input As intFile

  'read in globals
  Do Until EOF(intFile)
    'get line
    Line Input #intFile, strLine
    'trim it
    strLine = StripComments(strLine)
    'ignore blanks
    If LenB(strLine) <> 0 Then
    
      'even though new format is to match standard #define format,
      'still need to look for old format first just in case
      'when saved, the file will be in the new format
      
      'splitline into name and Value
      strSplitLine = Split(strLine, vbTab)
      
      'if exactly two elements,
      If UBound(strSplitLine) = 1 Then
        strSplitLine(0) = Trim$(strSplitLine(0))
        strSplitLine(1) = Trim$(strSplitLine(1))

        'if valid, add it to grid
        ValidateDefine strSplitLine(0), strSplitLine(1), False

      'not a valid global.txt; check for defines.txt
      Else
        'tabs need to be replaced with spaces first
        strLine = Trim$(Replace(strLine, vbTab, " "))
        If Left$(strLine, 8) = "#define " Then
          'set up splitline array
          ReDim strSplitLine(1)
          'strip off the define statement
          strLine = Trim$(Right$(strLine, Len(strLine) - 8))
          'extract define name
          i = InStr(1, strLine, " ")
          If i <> 0 Then
            strSplitLine(0) = Left$(strLine, i - 1)
            strLine = Right$(strLine, Len(strLine) - i)
            strSplitLine(1) = Trim$(strLine)
            
            ValidateDefine strSplitLine(0), strSplitLine(1), False
          End If
        End If
      End If
    End If
  Loop
  
  'close file
  Close intFile
  
  'add one blank line to bottom
  fgGlobals.AddItem vbNullString
  
  'if clearing all
  If ClearAll Then
    'select name cel of first non-readonly row
    fgGlobals.Row = 1
    fgGlobals.Col = ctName
    
    'file is clean
    IsDirty = False
    
    'set caption
    Caption = "Global Defines - "
    If InGame Then
      Caption = Caption & GameID
    Else
      Caption = Caption & JustFileName(FileName)
    End If

    'if filename is defines.txt,
    If JustFileName(GlobalFile) = "defines.txt" Then
      'change name
      FileName = JustPath(GlobalFile) & "globals.txt"
      'mark as dirty
      MarkAsDirty
    Else
      FileName = GlobalFile
    End If
    
  Else
    'mark as dirty
    MarkAsDirty
    
    'ensure selected cell is visible
    If Not fgGlobals.RowIsVisible(fgGlobals.Row) Then
      fgGlobals.TopRow = fgGlobals.Row
    End If
  End If
  
  'resize to ensure widths adjusted depending on whether
  'or not scroll bar is visible
  Form_Resize
  
  'if a defines.txt file was loaded, and warnings were generated,
  If blnDuplicates Then
    'reset cursor
    Screen.MousePointer = vbDefault
    MsgBoxEx "Some names in this global defines file had duplicate " & vbNewLine & _
                "definitions. Duplicate names have been replaced.", vbInformation + vbOKOnly, _
                "Open Global Defines"
    
  End If
  
Exit Sub

ErrHandler:
  Debug.Assert False
  'ensure file is closed
  Close intFile
  'reset cursor
  Screen.MousePointer = vbDefault
  'inform user
  MsgBox "An error occurred while loading the global defines file. Some entries may be missing or incorrect.", vbInformation + vbOKOnly, "Global Defines File Error"
  'ensure at least one row
  If fgGlobals.Rows = 1 Then
    fgGlobals.AddItem vbNullString
  End If
  Resume Next
End Sub

Private Sub Form_LostFocus()
'Debug.Print "Form_LostFocus"

End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

  'if right button
  If Button = vbRightButton Then
    'if edit menu is enabled
    If frmMDIMain.mnuEdit.Enabled Then
      'need doevents so form activation occurs BEFORE popup
      'otherwise, errors will be generated because of menu
      'adjustments that are made in the form_activate event
      SafeDoEvents
      'show edit menu
      PopupMenu frmMDIMain.mnuEdit
    End If
  End If
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

  Cancel = Not AskClose()
End Sub

Private Sub Form_Resize()

  Dim OldWidth As Single

  On Error GoTo ErrHandler

  'use separate variables for managing minimum width/height
  If ScaleWidth < MinWidth Then
    CalcWidth = MinWidth
  Else
    CalcWidth = ScaleWidth
  End If
  If ScaleHeight < MinHeight Then
    CalcHeight = MinHeight
  Else
    CalcHeight = ScaleHeight
  End If
  
  'if the form is not visible
  If Not Visible Then
    Exit Sub
  End If
  
  'if minimized, exit
  If Me.WindowState = vbMinimized Then
    Exit Sub
  End If
  
  With fgGlobals
    'save old width of grids
    OldWidth = .Width
  
    'resize grids
    .Width = CalcWidth - 2 * ScreenTWIPSX
    
    .Height = CalcHeight - 2 * ScreenTWIPSX
    'set splitter height
    picSplit.Height = .Height
    
    'ratio out new column width
    .ColWidth(ctName) = .ColWidth(ctName) / OldWidth * .Width
    
    'set width of globals grid Value column
    If .Rows = 1 Then
      'no scrollbar
      'set width of second column
      .ColWidth(ctValue) = .Width - .ColWidth(ctName) - 2 * ScreenTWIPSX
    Else
      'check if top and bottom rows are both visible
      If .RowIsVisible(1) And .RowIsVisible(.Rows - 1) Then
        'no scrollbar
        'set width of second column
        .ColWidth(ctValue) = .Width - .ColWidth(ctName) - 2 * ScreenTWIPSX
      Else
        'take into account scrollbar
        .ColWidth(ctValue) = .Width - .ColWidth(ctName) - 17 * ScreenTWIPSX
      End If
    End If
  
  End With
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Private Sub Form_Unload(Cancel As Integer)

  'if in a game,
  If InGame Then
    'reset inuse flag
    GEInUse = False
    'release object
    Set GlobalsEditor = Nothing
  End If

#If DEBUGMODE <> 1 Then
  'release subclass hook to flexgrid
  SetWindowLong Me.fgGlobals.hWnd, GWL_WNDPROC, PrevFGWndProc
#End If 'need to check if this is last form
  LastForm Me
End Sub


Private Sub txtEditName_Change()

  On Error GoTo ErrHandler
  
  'if this is last row,
  If EditRow = fgGlobals.Rows - 1 Then
    'add another row
    fgGlobals.AddItem vbNullString
    'adjust column widths by resizing
    Form_Resize
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub txtEditName_KeyPress(KeyAscii As Integer)
  
  On Error GoTo ErrHandler
  
  Select Case KeyAscii
  Case 9, 10, 13 'enter or tab
    'if result is valid,
    If ValidateInput() Then
      'if name is blank and input was valid,
      'it means we want to delete this row
      If Len(txtEditName.Text) = 0 Then
        'delete this row
'''  'if new name is blank
'''  If LenB(fgGlobals.TextMatrix(EditRow, ctName)) = 0 Then
        RemoveRow EditRow
'''  End If
      End If
      
      'hide the box
      txtEditName.Visible = False
    
      'tab moves to next column and begins editing
      If KeyAscii = 9 Then
        'move to Value column
        fgGlobals.Col = ctValue
        
        'start another edit operation
        fgGlobals_DblClick
      Else
        'reset menus
        SetEditMenu
      End If
    Else
      'need to force focus (might a a tab thing?)
      txtEditName.SetFocus
    End If
    
    'ignore key
    KeyAscii = 0
    
  Case 27 'escape
    'hide textbox without saving text
    txtEditName.Visible = False
    
    'ignore key
    KeyAscii = 0
  End Select
  
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Private Sub txtEditName_Validate(Cancel As Boolean)
  
  'this will handle cases where user tries to 'click' on something,
  
  On Error GoTo ErrHandler
  If Not txtEditName.Visible Then Exit Sub
  
  'if OK, hide the text box
  If ValidateInput() Then
    txtEditName.Visible = False
  Else
  'if not OK, cancel
    Cancel = True
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub txtEditValue_KeyPress(KeyAscii As Integer)

  On Error GoTo ErrHandler
  
  Select Case KeyAscii
  
  Case 9, 10, 13 'enter or tab
    'if result is valid,
    If ValidateInput() Then
      'hide the box
      txtEditValue.Visible = False
    
      'tab moves to next row, and begins editing
      If KeyAscii = 9 Then
'''        'if on last row
'''        If fgGlobals.Row = fgGlobals.Rows - 1 Then
'''          'add a new row
'''          fgGlobals.AddItem vbNullString
'''        End If
  
        'move to name column, next row
        fgGlobals.Col = ctName
        fgGlobals.Row = fgGlobals.Row + 1
        
'''        'start another edit operation
'''        fgGlobals_DblClick
'''      Else
        'done editing; enable edit menu
        SetEditMenu
      End If
    Else
      'need to force focus (might be a tab thing?)
      txtEditValue.SetFocus
    End If
    
    'ignore key
    KeyAscii = 0
  
  Case 27 'escape
    'hide textbox without saving text
    txtEditValue.Visible = False
    
    'ignore key
    KeyAscii = 0
  End Select
  
  'if new value is blank (can only happen if editing a new row)
  'add a blank space as a place holder
  If LenB(fgGlobals.TextMatrix(EditRow, ctValue)) = 0 Then
    fgGlobals.TextMatrix(EditRow, ctValue) = Chr$(34) & " " & Chr$(34)
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub txtEditValue_Validate(Cancel As Boolean)

  'this will handle cases where user tries to 'click' on something,
  
  If Not txtEditValue.Visible Then Exit Sub
  On Error GoTo ErrHandler
  
  'if OK, hide the text box
  If ValidateInput() Then
    txtEditValue.Visible = False
  Else
  'if not OK, cancel
    Cancel = True
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


