VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form frmObjectEdit 
   Caption         =   "Form1"
   ClientHeight    =   4650
   ClientLeft      =   135
   ClientTop       =   360
   ClientWidth     =   5250
   Icon            =   "frmObjectEdit.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MDIChild        =   -1  'True
   ScaleHeight     =   4650
   ScaleWidth      =   5250
   Begin VB.TextBox txtMaxScreenObj 
      Alignment       =   2  'Center
      Height          =   285
      Left            =   2970
      TabIndex        =   4
      TabStop         =   0   'False
      Text            =   "16"
      Top             =   0
      Width           =   690
   End
   Begin VB.TextBox txtRoomNo 
      Appearance      =   0  'Flat
      BackColor       =   &H00E0E0E0&
      BorderStyle     =   0  'None
      Height          =   288
      Left            =   0
      TabIndex        =   2
      Top             =   1200
      Visible         =   0   'False
      Width           =   840
   End
   Begin VB.TextBox txtObject 
      Appearance      =   0  'Flat
      BackColor       =   &H00E0E0E0&
      BorderStyle     =   0  'None
      Height          =   288
      Left            =   0
      TabIndex        =   1
      Top             =   900
      Visible         =   0   'False
      Width           =   3690
   End
   Begin MSFlexGridLib.MSFlexGrid fgObjects 
      Height          =   3135
      Left            =   0
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   300
      Width           =   3675
      _ExtentX        =   6482
      _ExtentY        =   5530
      _Version        =   393216
      Cols            =   3
      FixedCols       =   0
      AllowBigSelection=   0   'False
      ScrollTrack     =   -1  'True
      FocusRect       =   2
      ScrollBars      =   2
      MergeCells      =   2
      BorderStyle     =   0
   End
   Begin VB.Label Label1 
      Caption         =   "Maximum Screen Objects: "
      Height          =   285
      Left            =   15
      TabIndex        =   3
      Top             =   45
      Width           =   2100
   End
End
Attribute VB_Name = "frmObjectEdit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

  Public InGame As Boolean
  Public IsDirty As Boolean
  Public ObjectsEdit As AGIInventoryObjects
  
  Private UndoCol As Collection
  
  Private EditRow As Long, EditCol As ColType
  Private CellIndentH As Single
  Private CellIndentV As Single
  
  Private AddingItem As Boolean
  Private EditItemNum As Byte
  Private blnRecurse As Boolean
  
  Public PrevFGWndProc As Long
  
  Private Enum ColType
    ctNumber
    ctDesc
    ctRoom
  End Enum

  Private CalcWidth As Long, CalcHeight As Long
  Private Const MinHeight = 3000
  Private Const MinWidth = 3000


Public Sub MouseWheel(ByVal MouseKeys As Long, ByVal Rotation As Long, ByVal xPos As Long, ByVal yPos As Long)
  Dim NewValue As Long
  Dim Lstep As Single
  
  On Error Resume Next
  
  With fgObjects
    Lstep = 4
    
    If Rotation > 0 Then
      NewValue = .TopRow - Lstep
      If NewValue < 1 Then
        NewValue = 1
      End If
    Else
      NewValue = .TopRow + Lstep
      If NewValue > .Rows - 1 Then
        NewValue = .Rows - 1
      End If
    End If
    .TopRow = NewValue
  End With
End Sub


Public Sub MenuClickHelp()
  
  On Error GoTo ErrHandler
  
  'help
  HtmlHelpS HelpParent, WinAGIHelp, HH_DISPLAY_TOPIC, "htm\winagi\Objects_Editor.htm"
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Public Sub Activate()
  'bridge method to call the form's Activate event method
  Form_Activate
End Sub

Public Sub BeginFind()

  With FindForm
    'if any values changed
    If SearchFindText <> .FindText Or _
       SearchFindDir <> .FindDir Or _
       SearchMatchWord <> .MatchWord Or _
       SearchReplaceText <> .ReplaceText Then
      'reset search flags
      FirstFind = False
      ResetSearch = False
      StartPos = -1
    End If
    
    'update form values
    SearchFindText = .FindText
    SearchFindDir = .FindDir
    SearchMatchWord = .MatchWord
    SearchMatchCase = .MatchCase
    SearchReplaceText = .ReplaceText
    
    Select Case .FormAction
    Case faFind
      'now find the object
      FindInObjects SearchFindText, SearchFindDir, SearchMatchWord, SearchMatchCase
    Case faReplace
      FindInObjects SearchFindText, SearchFindDir, SearchMatchWord, SearchMatchCase, True, SearchReplaceText
    Case faReplaceAll
      ReplaceAll SearchFindText, SearchMatchWord, SearchMatchCase, SearchReplaceText
    Case faCancel
      'don't do anything
    End Select
  End With
End Sub

Private Sub FindInObjects(ByVal FindText As String, ByVal FindDir As FindDirection, ByVal MatchWord As Boolean, ByVal MatchCase As Boolean, Optional ByVal Replacing As Boolean = False, Optional ByVal ReplaceText As String = vbNullString)

  Dim SearchPos As Long, FoundPos As Long
  Dim rtn As VbMsgBoxResult
  Dim vbcComp As VbCompareMethod
  
  On Error GoTo ErrHandler
  
  'if replacing and new text is the same
  If Replacing And (StrComp(FindText, ReplaceText, vbTextCompare) = 0) Then
    'exit
    Exit Sub
  End If
    
  If ObjectsEdit.Count = 0 Then
    MsgBox "No inventory objects in list.", vbOKOnly + vbInformation, "Find in Object List"
    Exit Sub
  End If
  
  'show wait cursor
  WaitCursor
  
  'set comparison method for string search,
  vbcComp = CLng(MatchCase) + 1 ' CLng(True) + 1 = 0 = vbBinaryCompare; Clng(False) + 1 = 1 = vbTextCompare
  
  'if replacing and searching up   searchpos = current pos+1
  'if replacing and searching down searchpos = current pos
  'if not repl  and searching up   searchpos = current pos
  'if not repl  and searching down searchpos = current pos+1
  
  'set searchpos to current item index (current item index is row-1)
  SearchPos = fgObjects.Row - 1
  
  'adjust to next object per replace/direction selections
  If (Replacing And FindDir = fdUp) Or (Not Replacing And FindDir <> fdUp) Then
    'add one to skip current object
    SearchPos = SearchPos + 1
    If SearchPos > ObjectsEdit.Count - 1 Then
      SearchPos = 0
    End If
  Else
    'if already AT beginning of search, the replace function will mistakenly
    'think the find operation is complete and stop
    If Replacing And (SearchPos = StartPos) Then
      'reset search
      FirstFind = False
      ResetSearch = False
      StartPos = -1
    End If
  End If
  
  
  'main search loop
  Do
    'if direction is up
    If FindDir = fdUp Then
      'iterate backwards until word found or foundpos=-1
      FoundPos = SearchPos - 1
      Do Until FoundPos = -1
        If MatchWord Then
          If StrComp(ObjectsEdit(FoundPos).ItemName, FindText, vbcComp) = 0 Then
            'found
            Exit Do
          End If
        Else
          If InStr(1, ObjectsEdit(FoundPos).ItemName, FindText, vbcComp) <> 0 Then
            'found
            Exit Do
          End If
        End If
        FoundPos = FoundPos - 1
      Loop
      'reset searchpos
      SearchPos = ObjectsEdit.Count - 1
    Else
      'iterate forward until word found or foundpos=objcount
      FoundPos = SearchPos
      Do
        If MatchWord Then
          If StrComp(ObjectsEdit(FoundPos).ItemName, FindText, vbcComp) = 0 Then
            'found
            Exit Do
          End If
        Else
          If InStr(1, ObjectsEdit(FoundPos).ItemName, FindText, vbcComp) <> 0 Then
            'found
            Exit Do
          End If
        End If
        FoundPos = FoundPos + 1
      Loop Until FoundPos = ObjectsEdit.Count
      'reset searchpos
      SearchPos = 0
    End If
    
    'if found
    If FoundPos >= 0 And FoundPos < ObjectsEdit.Count Then
      'if back at start
      If FoundPos = StartPos Then
        FoundPos = -1
      End If
      Exit Do
    End If
    
    'if not found, action depends on search mode
    Select Case FindDir
    Case fdUp
      'if not reset yet
      If Not ResetSearch Then
        'if recursing
        If blnRecurse Then
          'just say no
          rtn = vbNo
        Else
          rtn = MsgBox("Beginning of search scope reached. Do you want to continue from the end?", vbQuestion + vbYesNo, "Find in Object List")
        End If
        If rtn = vbNo Then
          'reset search
          ResetSearch = False
          FirstFind = False
          StartPos = -1
          Screen.MousePointer = vbDefault
          Exit Sub
        End If
      Else
        'entire scope already searched; exit
        Exit Do
      End If
      
    Case fdDown
      'if not reset yet
      If Not ResetSearch Then
        'if recursing
        If blnRecurse Then
          'just say no
          rtn = vbNo
        Else
          rtn = MsgBox("End of search scope reached. Do you want to continue from the beginning?", vbQuestion + vbYesNo, "Find in Object List")
        End If
        If rtn = vbNo Then
          'reset search
          ResetSearch = False
          FirstFind = False
          StartPos = -1
          Screen.MousePointer = vbDefault
          Exit Sub
        End If
      Else
        'entire scope already searched; exit
        Exit Do
      End If
      
    Case fdAll
      If ResetSearch Then
        Exit Do
      End If
      
    End Select
    
    'reset search so when we get back to start, search will end
    ResetSearch = True
  
  'loop is exited by finding the searchtext or reaching end of search area
  Loop
        
  'if search string found
  If FoundPos >= 0 And FoundPos < ObjectsEdit.Count Then
    'if this is first occurrence
    If Not FirstFind Then
      'save this position
      FirstFind = True
      StartPos = FoundPos
    End If
    
    'highlight object
    fgObjects.Row = FoundPos + 1
    If Not fgObjects.RowIsVisible(FoundPos + 1) Then
      fgObjects.TopRow = FoundPos - 2
    End If
    
    'if replacing
    If Replacing Then
      If MatchWord Then
        ModifyItem FoundPos, ReplaceText
      Else
        ModifyItem FoundPos, Replace(ObjectsEdit(FoundPos).ItemName, FindText, ReplaceText, 1, -1, vbcComp)
      End If
      'change undoobject
      UndoCol(UndoCol.Count).UDAction = udoReplace
      frmMDIMain.mnuEUndo.Caption = "&Undo Replace" & vbTab & "Ctrl+Z"
      
      'recurs the find method to get next occurrence
      blnRecurse = True
      FindInObjects FindText, FindDir, MatchWord, MatchCase, False
      blnRecurse = False
    End If
    
  Else
    'if not recursing, show a msg
    If Not blnRecurse Then
      'if something was previously found
      If FirstFind Then
        'search complete; no new instances found
        MsgBox "The specified region has been searched.", vbInformation, "Find in Object List"
      Else
        'show not found msg
        MsgBox "Search text not found.", vbInformation, "Find in Object List"
      End If
    End If
    
    'reset search flags
    FirstFind = False
    ResetSearch = False
    StartPos = -1
  End If
  
  fgObjects.SetFocus
  
  'reset cursor
  Screen.MousePointer = vbDefault
Exit Sub
  
ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Public Sub InitFonts()

  On Error GoTo ErrHandler
  
  'set form font to enable height/width calculations
  Me.Font.Name = Settings.EFontName
  Me.Font.size = Settings.EFontSize
  
  'set grid font and column widths
  fgObjects.Font.Name = Settings.EFontName
  fgObjects.Font.size = Settings.EFontSize
  fgObjects.ColWidth(0) = Me.TextWidth("Item # ")
  fgObjects.ColWidth(2) = Me.TextWidth("Room # ")
  'if more rows than will fit on screen
  If fgObjects.Rows * fgObjects.RowHeight(0) > fgObjects.Height Then
    'account for scrollbar
    fgObjects.ColWidth(1) = fgObjects.Width - fgObjects.ColWidth(2) - fgObjects.ColWidth(0) - 320
  Else
    fgObjects.ColWidth(1) = fgObjects.Width - fgObjects.ColWidth(2) - fgObjects.ColWidth(0)
  End If
  fgObjects.Refresh
  
  txtObject.Font.Name = Settings.EFontName
  txtObject.Font.size = Settings.EFontSize
  
  txtRoomNo.Font.Name = Settings.EFontName
  txtRoomNo.Font.size = Settings.EFontSize
  txtMaxScreenObj.Font.Name = Settings.EFontName
  txtMaxScreenObj.Font.size = Settings.EFontSize
  txtMaxScreenObj.Height = 60 + fgObjects.RowHeight(1)
  Label1.Font.Name = Settings.EFontName
  Label1.Font.size = Settings.EFontSize
  Label1.Width = Me.TextWidth(Label1.Caption)
  Label1.Left = txtMaxScreenObj.Left - Label1.Width
  fgObjects.Top = txtMaxScreenObj.Top + txtMaxScreenObj.Height
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Sub MenuClickDescription(ByVal FirstProp As Long)

  Dim NextUndo As ObjectsUndo
  Dim strDesc As String
  
  'although it is never used, we need to use same form of this method as all other resources
  'otherwiae, we'll get an error when the main form tries to call this method
  
  'use the resource ID/Description change method
  strDesc = ObjectsEdit.Description
  If GetNewResID(rtObjects, -1, vbNullString, strDesc, InGame, 2) Then
    'create new undo object
    Set NextUndo = New ObjectsUndo
    NextUndo.UDAction = udoChangeDesc
    NextUndo.UDObjectText = ObjectsEdit.Description
    
    'add to undo
    AddUndo NextUndo
      
    'change description
    ObjectsEdit.Description = strDesc
  End If
End Sub

Public Sub MenuClickReplace()

  'use menuclickfind in replace mode
  MenuClickFind ffReplaceObject
End Sub


Private Sub AddItem(NewItem As String, Room As Byte, Optional DontUndo As Boolean = False)
  'adds a new item to end of list
  
  Dim NextUndo As ObjectsUndo
  
  'if already at Max
  If ObjectsEdit.Count >= 256 Then
    'just exit
    Exit Sub
  End If
  
  'add item to game object
  ObjectsEdit.Add NewItem, Room
  
  'add item to grid
  fgObjects.AddItem CStr(ObjectsEdit.Count - 1) & ". " & vbTab & NewItem & vbTab & CStr(Room)
  'select item that was just added
  fgObjects.Row = fgObjects.Rows - 1
  fgObjects.TopRow = fgObjects.Rows - 1
  fgObjects.Enabled = True
  
  'if not skipping undo
  If Not DontUndo Then
    Set NextUndo = New ObjectsUndo
    NextUndo.UDAction = udoAddItem
    'add to undo collection
    AddUndo NextUndo
  End If
  
  Debug.Assert frmMDIMain.ActiveForm Is Me
  'update status bar with Count (subtract one cuz first item doesnt Count)
  MainStatusBar.Panels("Count").Text = "Object Count: " & CStr(ObjectsEdit.Count) - 1
End Sub


Private Sub DeleteItem(ByVal ItemIndex As Byte, Optional ByVal DontUndo As Boolean = False)

  Dim NextUndo As ObjectsUndo
  
  'if not skipping undo
  If Not DontUndo Then
    Set NextUndo = New ObjectsUndo
    NextUndo.UDAction = udoDeleteItem
    NextUndo.UDObjectNo = ItemIndex
    NextUndo.UDObjectText = ObjectsEdit(ItemIndex).ItemName
    NextUndo.UDObjectRoom = ObjectsEdit(ItemIndex).Room
    'add to undo collection
    AddUndo NextUndo
  End If
  
  'if there are at least two objects and deleting last item
  If ObjectsEdit.Count >= 2 And ItemIndex = ObjectsEdit.Count - 1 Then
    'delete the row
    fgObjects.RemoveItem ItemIndex + 1
  Else
    'set item description to '?'
    fgObjects.TextMatrix(ItemIndex + 1, 1) = "?"
    'set row to zero
    fgObjects.TextMatrix(ItemIndex + 1, 2) = "0"
  End If
  
  'delete the object from game object
  ObjectsEdit.Remove ItemIndex
  
  Debug.Assert frmMDIMain.ActiveForm Is Me
  'update status bar with Count (subtract one cuz first item doesnt Count)
  MainStatusBar.Panels("Count").Text = "Object Count: " & CStr(ObjectsEdit.Count - 1)
End Sub

Public Sub MenuClickFind(Optional ByVal ffValue As FindFormFunction = ffFindObject)

  On Error GoTo ErrHandler
  
  With FindForm
    'set form defaults
    If Len(SearchFindText) > 0 Then
      'if it has quotes, remove them
      If Asc(SearchFindText) = 34 Then
        SearchFindText = Right$(SearchFindText, Len(SearchFindText) - 1)
      End If
      If Right$(SearchFindText, 1) = QUOTECHAR Then
        SearchFindText = Left$(SearchFindText, Len(SearchFindText) - 1)
      End If
    End If
    
    .FindText = SearchFindText
    .FindDir = SearchFindDir
    .MatchWord = SearchMatchWord
    .ReplaceText = SearchReplaceText
    
    'set find dialog to object mode
    .SetForm ffValue
    
    'show the form
    .Show , frmMDIMain
  
    'always highlight search text
    .txtFindText.SelStart = 0
    .txtFindText.SelLength = Len(.txtFindText.Text)
    .txtFindText.SetFocus
    
    'ensure this form is the search form
    Set SearchForm = Me
  End With
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Sub MenuClickFindAgain()
  
  On Error GoTo ErrHandler
  
  'if nothing in find form textbox
  If LenB(SearchFindText) <> 0 Then
    FindInObjects SearchFindText, SearchFindDir, SearchMatchWord, SearchMatchCase
  Else
    'show find form
    MenuClickFind
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Public Sub NewObjects()

  'creates a new objects file
  Dim i As Long
  On Error GoTo ErrHandler
  
  'set dirty status and caption
  IsDirty = True
  
  ObjCount = ObjCount + 1
  Caption = sDM & "Objects Editor - NewObjects" & CStr(ObjCount)
  fgObjects.TextMatrix(1, 0) = "0."
  fgObjects.TextMatrix(1, 1) = "?"
  fgObjects.TextMatrix(1, 2) = "0"
  
  'clear filename
  ObjectsEdit.ResFile = vbNullString
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Private Sub ReplaceAll(ByVal FindText As String, ByVal MatchWord As Boolean, ByVal MatchCase As Boolean, ByVal ReplaceText As String)

  'replace all occurrences of FindText with ReplaceText
  
  Dim i As Long, vbcComp As VbCompareMethod
  Dim lngCount As Long
  Dim NextUndo As ObjectsUndo
  
  On Error GoTo ErrHandler
  
  'if replacing and new text is the same
  If StrComp(FindText, ReplaceText, vbTextCompare) = 0 Then
    'exit
    Exit Sub
  End If
  
  'if no objects in list
  If ObjectsEdit.Count = 0 Then
    MsgBox "Object list is empty.", vbOKOnly + vbInformation, "Replace All"
    Exit Sub
  End If
  
  'show wait cursor
  WaitCursor
  
  'create new undo object
  Set NextUndo = New ObjectsUndo
  NextUndo.UDAction = udoReplaceAll
  
  'set comparison method for string search,
  vbcComp = CLng(MatchCase) + 1 ' CLng(True) + 1 = 0 = vbBinaryCompare; Clng(False) + 1 = 1 = vbTextCompare
  
  If MatchWord Then
    'step through all objects
    For i = 0 To ObjectsEdit.Count - 1
      If StrComp(ObjectsEdit(i).ItemName, FindText, vbcComp) = 0 Then
        'add  word being replaced to undo
        If lngCount = 0 Then
          NextUndo.UDObjectText = CStr(i) & "|" & ObjectsEdit(i).ItemName
        Else
          NextUndo.UDObjectText = NextUndo.UDObjectText & "|" & CStr(i) & "|" & ObjectsEdit(i).ItemName
        End If
        'replace the word
        ObjectsEdit(i).ItemName = ReplaceText
        'update grid
        fgObjects.TextMatrix(i + 1, ctDesc) = ReplaceText
        'increment counter
        lngCount = lngCount + 1
      End If
    Next i
  Else
    For i = 0 To ObjectsEdit.Count - 1
      If InStr(1, ObjectsEdit(i).ItemName, FindText, vbcComp) <> 0 Then
        'add  word being replaced to undo
        If lngCount = 0 Then
          NextUndo.UDObjectText = CStr(i) & "|" & ObjectsEdit(i).ItemName
        Else
          NextUndo.UDObjectText = NextUndo.UDObjectText & "|" & CStr(i) & "|" & ObjectsEdit(i).ItemName
        End If
        'replace the word
        ObjectsEdit(i).ItemName = Replace(ObjectsEdit(i).ItemName, FindText, ReplaceText, 1, -1, vbcComp)
        'update grid
        fgObjects.TextMatrix(i + 1, ctDesc) = Replace(ObjectsEdit(i).ItemName, FindText, ReplaceText)
        'increment counter
        lngCount = lngCount + 1
      End If
    Next i
  End If
  
  'if nothing found,
  If lngCount = 0 Then
    MsgBox "Search text not found.", vbInformation, "Replace All"
  Else
    'add undo
    AddUndo NextUndo
    
    'show how many replacements made
    MsgBox "The specified region has been searched. " & CStr(lngCount) & " replacments were made.", vbInformation, "Replace All"
  End If
  
  Screen.MousePointer = vbDefault
Exit Sub

ErrHandler:
  Resume Next
End Sub

Public Sub MenuClickClear()

  'clear the object list
  Clear
End Sub

Public Sub MenuClickDelete()
  'delete object
  
  'if on a valid row,
  If fgObjects.Row > 1 Then
    EditItemNum = fgObjects.Row - 1
    'delete
    DeleteItem EditItemNum
  End If
  
End Sub

Public Sub MenuClickInsert()
  'add object
  
  'if already at Max
  If ObjectsEdit.Count >= 255 Then
    MsgBox ("Maximum number of objects (255) already reached.")
  Else
    'add a new item to the grid
    fgObjects.AddItem CStr(fgObjects.Rows - 1) & ". " & vbTab & "?" & vbTab & "0"
    
    'add object to objectlist
    ObjectsEdit.Add "?", 0
    
    'set row to this object
    fgObjects.Row = fgObjects.Rows - 1
    fgObjects.Col = 1
    
    'set add flag
    AddingItem = True
    
  Debug.Assert frmMDIMain.ActiveForm Is Me
    'update status bar with Count (subtract one cuz first item doesnt Count)
    MainStatusBar.Panels("Count").Text = "Object Count: " & CStr(ObjectsEdit.Count - 1)

    'use doubleclick
    fgObjects_DblClick
  End If
End Sub


Public Sub MenuClickOpen()

End Sub

Public Sub MenuClickSave()

  'save the object file
  
  Dim strFileName As String
  Dim rtn As VbMsgBoxResult, blnDontAsk As Boolean
  Dim i As Long, tmpNode As Node
  
  On Error GoTo ErrHandler
  
  'AutoUpdate feature still needs significant work; disable it for now
  
''  'if in a game, and autoupdate is in ask mode or yes mode
''  If InGame And Settings.AutoUpdateObjects <> 1 Then
''    'if not automatic,
''    If Settings.AutoUpdateObjects = 0 Then
''      'get user's response
''      rtn = MsgBoxEx("Do you want to update all game logics with the changes made in the object list?", vbQuestion + vbYesNo, "Update Logics?", , , "Always take this action when saving the object list.", blnDontAsk)
''      If blnDontAsk Then
''        If rtn = vbYes Then
''          Settings.AutoUpdateObjects = 2
''        Else
''          Settings.AutoUpdateObjects = 1
''        End If
''      End If
''    Else
''      rtn = vbYes
''    End If
''
''    'if yes,
''    If rtn = vbYes Then
''      '
''      'test cmds that use vtIObj:
''      '  has, obj.in.room
''      '
''      'std cmds that use vtIObj:
''      '  get, drop, put
''
''
''
''      'hide find form
''      FindForm.Visible = False
''
''      'set mouse cursor and disable main form
''      'show wait cursor
''      WaitCursor
''      frmMDIMain.Enabled = False
''      'show progress form
''      With frmProgress
''        .Caption = "Updating Objects in Logics"
''        .lblProgress.Caption = "Searching..."
''        .pgbStatus.Max = InventoryObjects.Count - 1
''        .pgbStatus.Value = 0
''        .Show vbModeless, frmMDIMain
''        .Refresh
''      End With
''
''      'refresh
''      DoEvents
''
''      'step through all current objects; (skip first obj with '?'
''      For i = 1 To InventoryObjects.Count - 1
''        'if deleted
''        If i >= ObjectsEdit.Count Then
''          'mark all objects in logics as deleted
''          ResMan.ReplaceAll quotechar & InventoryObjects(i).ItemName & quotechar, "i" & CStr(i), fdAll, True, True, flAll, rtObjects
''        Else
''          'if now a '?'
''          If ObjectsEdit(i).ItemName = "?" Then
''            'mark all objects in logics as deleted
''            ResMan.ReplaceAll quotechar & InventoryObjects(i).ItemName & quotechar, "i" & CStr(i), fdAll, True, True, flAll, rtObjects
''          ElseIf ObjectsEdit(i).ItemName <> InventoryObjects(i).ItemName Then
''            'change to new object item name
''            ResMan.ReplaceAll quotechar & InventoryObjects(i).ItemName & quotechar, quotechar & ObjectsEdit(i).ItemName & quotechar, fdAll, True, True, flAll, rtObjects
''          End If
''        End If
''        frmProgress.pgbStatus.Value = i
''        frmProgress.Refresh
''      Next i
''
''      'close the progress form
''      Unload frmProgress
''
''      're-enable form
''      frmMDIMain.Enabled = True
''      Screen.MousePointer = vbDefault
''      frmMDIMain.SetFocus
''    End If
''  End If
''
  
  'if in a game
  If InGame Then
    'show wait cursor
    WaitCursor
    
    'copy back to game object
    InventoryObjects.SetObjects ObjectsEdit
    'compile
    InventoryObjects.Save
    If Err.Number <> 0 Then
      ErrMsgBox "Error during OBJECT compilation: ", "Existing OBJECT has not been modified.", "OBJECT Compile Error"
      Screen.MousePointer = vbDefault
      Exit Sub
    End If
    
    'force all logics to display as dirty
    Logics.MarkAllAsDirty
    'set them all to red text in the resource tree
    Set tmpNode = frmMDIMain.tvwResources.Nodes(2).Child
    Do Until tmpNode Is Nothing
      If FileExists(ResDir & Logics(CByte(tmpNode.Tag)).ID & LogicSourceSettings.SourceExt) Then
        tmpNode.ForeColor = vbRed
      End If
      Set tmpNode = tmpNode.Next
    Loop
    'if current selection is a logic, update it
    UpdateSelection SelResType, SelResNum, umPreview Or umProperty
    
    'reset mouse pointer
    Screen.MousePointer = vbDefault

    'update property window if object is currently selected
    UpdateSelection rtObjects, -1, umProperty
    
  Else
    'if no filename
    If LenB(ObjectsEdit.ResFile) = 0 Then
      MenuClickExport
      Exit Sub
    Else
      'show wait cursor
      WaitCursor
      'use save method
      ObjectsEdit.Save
      If Err.Number <> 0 Then
        ErrMsgBox "An error occurred while trying to save object list: ", "Existing object list has not been modified.", "Object List Save Error"
        Screen.MousePointer = vbDefault
        Exit Sub
      End If
      'reset mouse pointer
      Screen.MousePointer = vbDefault
    End If
  End If
  
  'reset dirty flag
  IsDirty = False
  
  'set caption
  Caption = "Objects Editor - "
  If InGame Then
    Caption = Caption & GameID
  Else
    Caption = Caption & CompactPath(ObjectsEdit.ResFile, 75)
  End If
  
  'disable menu and toolbar button
  frmMDIMain.mnuRSave.Enabled = False
  frmMDIMain.Toolbar1.Buttons("save").Enabled = False
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Public Sub MenuClickPrint()

  Load frmPrint
  frmPrint.SetMode rtObjects, ObjectsEdit, , InGame
  frmPrint.Show vbModal
  
End Sub

Public Sub MenuClickExport()

  If ExportObjects(ObjectsEdit, InGame) Then
    'if this is NOT the in game file,
    If Not InGame Then
      'reset dirty flag and caption
      IsDirty = False
      'update caption
      Caption = "Objects Editor - " & CompactPath(ObjectsEdit.ResFile, 75)
      'disable save menu/button
      frmMDIMain.mnuRSave.Enabled = False
      frmMDIMain.Toolbar1.Buttons("save").Enabled = False
    End If
  End If
End Sub

Public Sub MenuClickImport()

End Sub

Public Sub MenuClickNew()

End Sub

Public Sub MenuClickInGame()

End Sub

Public Sub MenuClickRenumber()

End Sub

Public Sub MenuClickECustom2()
  
  'call findinlogic with current invobj
  
  Dim strObj As String
  
  strObj = fgObjects.TextMatrix(fgObjects.Row, ctDesc)
  
  If strObj <> "?" Then
    'reset logic search
    FirstFind = False
    SearchStartLog = -1
    SearchStartPos = -1
    ClosedLogics = False
    
    'set search parameters
    SearchFindText = QUOTECHAR & strObj & QUOTECHAR
    SearchFindDir = fdAll
    SearchMatchWord = True
    SearchMatchCase = False
    LogicSearchLoc = flAll
    SearchType = rtObjects
    
    'if the findform is visible,
    If FindForm.Visible Then
      'set it to match desired search parameters
      With FindForm
        'set form defaults
        .FindDir = SearchFindDir
        .MatchWord = SearchMatchWord
        .MatchCase = SearchMatchCase
        .LogicFindLoc = LogicSearchLoc
        .ReplaceText = vbNullString
        .FindText = SearchFindText
        
        'set find dialog to find textinlogic mode
        .SetForm ffFindLogic
      End With
    End If
    
    'set search form to this form
    Set SearchForm = Me
    
    'now search all logics
    FindInLogic QUOTECHAR & Replace(strObj, QUOTECHAR, "\""") & QUOTECHAR, fdAll, True, False, flAll, False, vbNullString
  End If
End Sub

Public Sub Clear(Optional ByVal DontUndo As Boolean = False)

  Dim i As Long
  Dim NextUndo As ObjectsUndo
  
  On Error GoTo ErrHandler
  
  'if skipping undo
  If Not DontUndo Then
    'create new undo object
    Set NextUndo = New ObjectsUndo
    NextUndo.UDAction = udoClear
    
    With ObjectsEdit
      'store Max objects
      NextUndo.UDObjectRoom = .MaxScreenObjects
      'store encryption
      NextUndo.UDObjectNo = CLng(.Encrypted)
      'add first object, using tabs and cr's
      NextUndo.UDObjectText = .Item(0).ItemName & vbTab & CStr(.Item(0).Room)
      'now add rest of objects
      For i = 1 To .Count - 1
        NextUndo.UDObjectText = NextUndo.UDObjectText & vbCr & .Item(i).ItemName & vbTab & CStr(.Item(i).Room)
      Next i
    End With
    'add to undo
    AddUndo NextUndo
  End If
  
  'clear grid
  For i = fgObjects.Rows - 2 To 1 Step -1
    fgObjects.RemoveItem i
  Next i
  
  'add one blank line
  fgObjects.TextMatrix(1, 0) = "0."
  fgObjects.TextMatrix(1, 1) = "?"
  fgObjects.TextMatrix(1, 2) = "0"
  
  'now clear the object list
  ObjectsEdit.Clear
  ObjectsEdit.MaxScreenObjects = Settings.MaxSO
  ObjectsEdit.Encrypted = False
  
  'update status bar with Count (subtract one cuz first item doesnt Count)
  MainStatusBar.Panels("Count").Text = "Object Count: 0"
  MainStatusBar.Panels("Encrypt").Text = "Not Encrypted"
  frmMDIMain.mnuRCustom3.Checked = False
  Err.Clear
  
  txtMaxScreenObj.Text = CStr(ObjectsEdit.MaxScreenObjects)
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub AddUndo(NextUndo As ObjectsUndo)

  Debug.Assert Not (UndoCol Is Nothing)
  'adds the next undo object
  UndoCol.Add NextUndo
  
  'set undo menu
  frmMDIMain.mnuEUndo.Enabled = True
  frmMDIMain.mnuEUndo.Caption = "&Undo " & LoadResString(OBJUNDOTEXT + NextUndo.UDAction) & vbTab & "Ctrl+Z"
  
  If Not IsDirty Then
    'set dirty flag
    IsDirty = True
    
    'mark caption
    Caption = sDM & Caption
    
    'enable menu and toolbar button
    frmMDIMain.mnuRSave.Enabled = True
    frmMDIMain.Toolbar1.Buttons("save").Enabled = True
  End If
  
  'reset searchflags
  FirstFind = False
  StartPos = -1
End Sub

Public Sub MenuClickCustom3()
  'toggle encryption
  ObjectsEdit.Encrypted = Not ObjectsEdit.Encrypted
  
  'set menu check
  frmMDIMain.mnuRCustom3.Checked = ObjectsEdit.Encrypted
  
  Debug.Assert frmMDIMain.ActiveForm Is Me
  'update statusbar
  MainStatusBar.Panels("Encrypt").Text = "Encrypted"
  If Not ObjectsEdit.Encrypted Then
    MainStatusBar.Panels("Encrypt").Text = "Not " & MainStatusBar.Panels("Encrypt").Text
  End If
  
  If Not IsDirty Then
    'set dirty flag
    IsDirty = True
    
    'mark caption
    Caption = sDM & Caption
    
    'enable menu and toolbar button
    frmMDIMain.mnuRSave.Enabled = True
    frmMDIMain.Toolbar1.Buttons("save").Enabled = True
  End If
End Sub

Private Sub ModifyItem(ByVal ItemIndex As Long, ByVal NewItemText As String, Optional ByVal DontUndo As Boolean = False)

  Dim NextUndo As ObjectsUndo
  
  On Error GoTo ErrHandler
  
  'if no change
  If ObjectsEdit(ItemIndex).ItemName = NewItemText Then
    Exit Sub
  End If
  
  'if change is to empty string
  If LenB(NewItemText) = 0 Then
    'same as delete
    DeleteItem ItemIndex
    Exit Sub
  End If
  
  'if not skipping undo
  If Not DontUndo Then
    Set NextUndo = New ObjectsUndo
    'if adding a new item
    If AddingItem Then
      NextUndo.UDAction = udoAddItem
      AddingItem = False
    Else
      NextUndo.UDAction = udoModifyItem
    End If
    NextUndo.UDObjectNo = ItemIndex
    NextUndo.UDObjectText = ObjectsEdit(ItemIndex).ItemName
    'add to undo collection
    AddUndo NextUndo
  End If
  
  'make changes
  ObjectsEdit(ItemIndex).ItemName = NewItemText
  'update grid
  fgObjects.TextMatrix(ItemIndex + 1, 1) = NewItemText
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub ModifyMax(ByVal NewMax As Byte, Optional ByVal DontUndo As Boolean = False)

  Dim NextUndo As ObjectsUndo
  
  'if no change
  If ObjectsEdit.MaxScreenObjects = NewMax Then
    Exit Sub
  End If
  
  'if not skipping undo
  If Not DontUndo Then
    Set NextUndo = New ObjectsUndo
    NextUndo.UDAction = udoChangeMaxObj
    NextUndo.UDObjectRoom = ObjectsEdit.MaxScreenObjects
    'add to undo collection
    AddUndo NextUndo
  End If
  
  'make changes
  ObjectsEdit.MaxScreenObjects = NewMax
  txtMaxScreenObj.Text = CStr(ObjectsEdit.MaxScreenObjects)
End Sub


Private Sub ModifyRoom(ByVal ItemIndex As Long, ByVal NewRoom As Byte, Optional ByVal DontUndo As Boolean = False)

  Dim NextUndo As ObjectsUndo
  
  'if no change
  If ObjectsEdit(ItemIndex).Room = NewRoom Then
    Exit Sub
  End If
  
  'if not skipping undo
  If Not DontUndo Then
    Set NextUndo = New ObjectsUndo
    NextUndo.UDAction = udoModifyRoom
    NextUndo.UDObjectNo = ItemIndex
    NextUndo.UDObjectRoom = ObjectsEdit(ItemIndex).Room
    'add to undo collection
    AddUndo NextUndo
  End If
  
  'make changes
  ObjectsEdit(ItemIndex).Room = NewRoom
  'update grid
  fgObjects.TextMatrix(ItemIndex + 1, 2) = CStr(NewRoom)
End Sub

Public Sub LoadObjects(ByVal ObjectFile As String)
  
  'opens an object file and loads it into the editor
  Dim i As Long
  Dim tmpObjects As AGIInventoryObjects
  
  On Error GoTo ErrHandler
  
  'use a temp objects object to get items
  Set tmpObjects = New AGIInventoryObjects
  
  'trap errors
  On Error Resume Next
  tmpObjects.Load ObjectFile
  If Err.Number <> 0 Then
    ErrMsgBox "Unable to load this object file due to error: ", "", "Load Object Error"
    On Error GoTo 0: Err.Raise vbObjectError + 601, "frmObjectEdit", "Load Object Error"
    Exit Sub
  End If
  On Error GoTo ErrHandler
  
  'set Max screen objs
  txtMaxScreenObj.Text = CStr(tmpObjects.MaxScreenObjects)
  
  'add items
  For i = 0 To tmpObjects.Count - 1
    fgObjects.AddItem CStr(i) & ". " & vbTab & tmpObjects(i).ItemName & vbTab & CStr(tmpObjects(i).Room)
  Next i
  
  'remove first line that was left by the clear function
  fgObjects.RemoveItem 1
  
  'file is clean
  IsDirty = False
  
  'set caption
  Caption = "Objects Editor - "
  If InGame Then
    Caption = Caption & GameID
  Else
    Caption = Caption & CompactPath(ObjectFile, 75)
  End If
  
  'save filename
  Debug.Assert tmpObjects.ResFile = ObjectFile
    
  'copy to local objects object
  ObjectsEdit.Clear
  ObjectsEdit.SetObjects tmpObjects
  
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Public Sub ShowRow()
  'ensures selected row in the object grid is visible
  
  'top row needs to be adjusted down by one because
  'the fixed row (which is zero) is not counted by toprow)
  Dim LastRow As Long
  Dim NewTop As Long
  Dim RowNum As Long
  
  'get selected row
  RowNum = fgObjects.Row
  
  'last full row is top row plus number of fully visible rows (not including
  'top row)
  'number of fully visible rows is grid height divided by cell height
  'adjust by 3 (compensate once for heading row, and once for zero based state
  'of object counting and once to ensure toprow is not counted twice)
  LastRow = fgObjects.TopRow + fgObjects.Height \ fgObjects.CellHeight - 3
  
  'if rownum is between toprow(adjusted) and lastrow
  If RowNum >= fgObjects.TopRow - 1 And RowNum <= LastRow Then
    Exit Sub
  End If
  
  'set toprow so rownum will be the third row visible
  NewTop = RowNum - 3
  If NewTop < 0 Then
    NewTop = 0
  End If
  fgObjects.TopRow = NewTop
End Sub

Public Sub ToggleEncryption(NewEncrypt As Boolean, Optional ByVal DontUndo As Boolean = False)
  
  Dim NextUndo As ObjectsUndo
  
  'if no change
  If ObjectsEdit.Encrypted = NewEncrypt Then
    Exit Sub
  End If
  
  'if not skipping undo
  If Not DontUndo Then
    Set NextUndo = New ObjectsUndo
    NextUndo.UDAction = udoTglEncrypt
    NextUndo.UDObjectRoom = CByte(ObjectsEdit.Encrypted)
    'add to undo collection
    AddUndo NextUndo
  End If
  
  'set encryption
  ObjectsEdit.Encrypted = NewEncrypt
End Sub


Private Function ValidateRoom() As Boolean

  Dim NewRoom As Long
  
  'any value from 0-255 is valid
  
  On Error GoTo ErrHandler
  
  NewRoom = Val(Me.txtRoomNo.Text)
  
  If NewRoom > 255 Then
    'warn user
    MsgBox "Room numbers may not be greater than 255." & _
    "Resetting value to 255. ", vbInformation + vbOKOnly, "Room Value Limit"
    NewRoom = 255
  End If
  
  'save new room value
  ModifyRoom EditItemNum, NewRoom
  ValidateRoom = True
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Private Function ValidateObject() As Boolean

  Dim i As Long, rtn As VbMsgBoxResult
  Dim blnNoWarn As Boolean
  
  On Error GoTo ErrHandler
  
  If txtObject.Text <> "?" Then
    'check for duplicate name
    If Settings.WarnDupObj Then
      For i = 0 To ObjectsEdit.Count - 1
        If i <> EditItemNum Then
          If ObjectsEdit(i).ItemName = txtObject.Text Then
            'warn
            rtn = MsgBoxEx(ChrW$(39) & txtObject.Text & "' already exists in this object list. Do you want to keep this duplicate object?", vbQuestion + vbYesNo + vbMsgBoxHelpButton, "Duplicate Object", WinAGIHelp, "htm\winagi\Objects_Editor.htm#duplicates", "Don't show this warning again.", blnNoWarn)
            'reset warning flag, if necessary
            Settings.WarnDupObj = Not blnNoWarn
            'if now hiding update settings file
            If Not Settings.WarnDupObj Then
              WriteAppSetting SettingsList, sGENERAL, "WarnDupObj", Settings.WarnDupObj
            End If
            
            'if canceled,
            If rtn = vbNo Then
              ValidateObject = True
              Exit Function
            End If
            Exit For
          End If
        End If
      Next i
    End If
  End If

  'save change to item description
  ModifyItem EditItemNum, txtObject.Text
  ValidateObject = True
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function


Private Sub fgObjects_EnterCell()
  'if in first column
  If fgObjects.Col = 0 Then
    'move to second column
    fgObjects.Col = 1
  End If
    
  SetEditMenu
End Sub

Private Sub fgObjects_KeyPress(KeyAscii As Integer)

  On Error GoTo ErrHandler
  
  'some keys should be ignored...?
  Select Case KeyAscii
  Case 9  'tab
    With fgObjects
      'if on name, move to column
      If .Col = ctDesc Then
        .Col = ctRoom
      Else
        If .Row < .Rows - 1 Then '(to account for header row)
          .Row = .Row + 1
          .Col = 1
        End If
      End If
    End With
    KeyAscii = 0
    
  Case 10, 13 'enter key
    'same as dbl-click
    fgObjects_DblClick
    KeyAscii = 0
    
  Case Else
    'if in the empty row, AND on description column, begin editing
    If fgObjects.Row = fgObjects.Rows - 1 And fgObjects.Col = ctDesc Then
      fgObjects_DblClick
      txtObject.Text = ChrW$(KeyAscii)
      txtObject.SelStart = 1
    End If
  End Select
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub fgObjects_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  
  Dim tmpRow As Long, tmpCol As Long
  Dim TopRow As Long, BtmRow As Long

  On Error GoTo ErrHandler
  
  If txtObject.Visible Or txtRoomNo.Visible Then
    Exit Sub
  End If
  
  With fgObjects
    tmpCol = .MouseCol
    If tmpCol = 0 Then tmpCol = 1
    tmpRow = .MouseRow
    If tmpRow < 2 Then tmpRow = 2
    
    'if right click
    If Button = vbRightButton Then
      'determine top/bottom rows
      If .Row < .RowSel Then
        TopRow = .Row
        BtmRow = .RowSel
      Else
        TopRow = .RowSel
        BtmRow = .Row
      End If

      'if row and column are NOT within selected area
      If tmpRow < TopRow Or tmpRow > BtmRow Then
        'make new selection
        'check for selection of entire row
        If X < ScreenTWIPSX * 12 Then
          'select entire row
          .Col = 0
          .Row = tmpRow
          .ColSel = 3
          .SelectionMode = flexSelectionByRow
          .Highlight = flexHighlightAlways
          .MergeCells = flexMergeNever
        Else
          'select freely
          .Col = tmpCol
          .Row = tmpRow
          .SelectionMode = flexSelectionFree
          .Highlight = flexHighlightNever
          .MergeCells = flexMergeRestrictAll
        End If
      End If

      'if on an editable row
      If tmpRow > 1 Then
        'set edit menu parameters
        SetEditMenu

        'need doevents so form activation occurs BEFORE popup
        'otherwise, errors will be generated because of menu
        'adjustments that are made in the form_activate event
        SafeDoEvents
        'show popup menu
        PopupMenu frmMDIMain.mnuEdit
      End If
      'done with right click activities
      Exit Sub
    End If

'     'check for selection of entire row
'    If X < ScreenTWIPSX * 12 Then
'      'select entire row
'      .Col = 0
'      .SelectionMode = flexSelectionByRow
'      .Highlight = flexHighlightAlways
'      .MergeCells = flexMergeNever
'      .ColSel = 2
'
'    Else
      'select freely
      If tmpCol <> -1 Then
        .Col = tmpCol
      Else
        .Col = ctDesc
      End If
      .Row = tmpRow
      .SelectionMode = flexSelectionFree
      .Highlight = flexHighlightNever
      .MergeCells = flexMergeRestrictAll
'    End If
  End With
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub fgObjects_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

  'if left button is down, begin dragging
  If Button = vbLeftButton Then
    If Not DroppingObj Then
      'although not required, object i0 is not editable
      'if something selected,
      If fgObjects.Row > 1 And fgObjects.RowSel = fgObjects.Row Then
'''      If fgObjects.RowSel = fgObjects.Row Then
        fgObjects.OLEDrag
      End If
    End If
  End If
End Sub

Private Sub fgObjects_OLECompleteDrag(Effect As Long)

  'reset dragging flag
  DroppingObj = False
End Sub

Private Sub fgObjects_OLEStartDrag(Data As MSFlexGridLib.DataObject, AllowedEffects As Long)

  On Error GoTo ErrHandler
  
  'set global drop flag (so logics (or other text receivers) know
  'when an object is being dropped
  DroppingObj = True
  
  'set allowed effects to copy only
  AllowedEffects = vbDropEffectCopy
  Data.SetData fgObjects.TextMatrix(fgObjects.Row, 1), vbCFText
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub Form_Activate()

  On Error GoTo ErrHandler
  
  'if minimized, exit
  '(to deal with occasional glitch causing focus to lock up)
  If Me.WindowState = vbMinimized Then
    Exit Sub
  End If
  
  'if hiding prevwin on lost focus, hide it now
  If Settings.HidePreview Then
    PreviewWin.Hide
  End If
 
  'if visible,
  If Visible Then
    'force resize
    Form_Resize
  End If
  
  'show object menu
  AdjustMenus rtObjects, InGame, True, IsDirty
  
  'set edit menu
  SetEditMenu
  
  'update status bar with Count (subtract one cuz first item doesnt Count)
  MainStatusBar.Panels("Count").Text = "Object Count: " & CStr(ObjectsEdit.Count - 1)
  MainStatusBar.Panels("Encrypt").Text = IIf(ObjectsEdit.Encrypted, "Encrypted", "Not Encrypted")
  
  'if findform is visible,
  If FindForm.Visible Then
    'set correct mode
    Select Case FindForm.FormFunction
    Case ffFindLogic, ffFindWord
      'show in find object mode
      FindForm.SetForm ffFindObject
    Case ffReplaceLogic, ffReplaceWord
      'show in replace object mode
      FindForm.SetForm ffReplaceObject
    End Select
  End If
  
  'set searching form to this form
  Set SearchForm = Me
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

  'detect and respond to keyboard shortcuts
  
  'always check for help first
  If Shift = 0 And KeyCode = vbKeyF1 Then
    MenuClickHelp
    KeyCode = 0
    Exit Sub
  End If
  
  'if editing something
  If txtObject.Visible Or txtRoomNo.Visible Or ActiveControl Is txtMaxScreenObj Then
    Exit Sub
  End If
  
  'check for global shortcut keys
  CheckShortcuts KeyCode, Shift
  If KeyCode = 0 Then
    Exit Sub
  End If
  
  Select Case Shift
  Case vbCtrlMask
    Select Case KeyCode
    Case vbKeyZ 'undo
      If frmMDIMain.mnuEUndo.Enabled Then
        MenuClickUndo
        KeyCode = 0
      End If
      
    Case vbKeyF 'find
      If frmMDIMain.mnuEdit.Enabled Then
        MenuClickFind
        KeyCode = 0
      End If
      
    Case vbKeyH 'replace
      If frmMDIMain.mnuEReplace.Enabled Then
        MenuClickReplace
        KeyCode = 0
      End If
    End Select
   
  Case 0 'no shift, ctrl, alt
    Select Case KeyCode
    Case vbKeyDelete
      If frmMDIMain.mnuEDelete.Enabled Then
        MenuClickDelete
        KeyCode = 0
      End If
      
    Case vbKeyF3
      'find again
      If frmMDIMain.Enabled Then
        MenuClickFindAgain
        KeyCode = 0
      End If
    End Select
  
  Case vbShiftMask
    Select Case KeyCode
    Case vbKeyDelete
      If frmMDIMain.mnuEClear.Enabled Then
        MenuClickClear
        KeyCode = 0
      End If
    
    Case vbKeyInsert
      If frmMDIMain.mnuEInsert.Enabled Then
        MenuClickInsert
        KeyCode = 0
      End If
    End Select
    
  Case 3  'shift+ctrl
    Select Case KeyCode
    Case vbKeyF
      If frmMDIMain.mnuECustom2.Enabled Then
        MenuClickECustom2
        KeyCode = 0
      End If
    
    Case vbKeyE
      If frmMDIMain.mnuRCustom3.Enabled Then
        MenuClickCustom3
        KeyCode = 0
      End If
    End Select
  
  Case vbAltMask
    Select Case KeyCode
    Case vbKeyReturn
      If frmMDIMain.mnuECustom1.Enabled Then
        MenuClickECustom1
        KeyCode = 0
      End If
    End Select
  End Select
End Sub
Private Sub Form_Load()
  
  On Error GoTo ErrHandler
  
  Dim i As Long
  
  CalcWidth = MinWidth
  CalcHeight = MinHeight
  
  'initialize undo collection
  Set UndoCol = New Collection
  
  'set indent Value
  CellIndentH = ScreenTWIPSX * 3
  CellIndentV = ScreenTWIPSY * 1
  
  'setup fonts
  InitFonts
  
  'set grid format
  fgObjects.ColAlignment(0) = flexAlignRightCenter
  fgObjects.ColAlignment(1) = flexAlignLeftCenter
  fgObjects.ColAlignment(2) = flexAlignCenterCenter
  fgObjects.FixedAlignment(0) = flexAlignCenterCenter
  fgObjects.FixedAlignment(1) = flexAlignLeftCenter
  fgObjects.FixedAlignment(2) = flexAlignCenterCenter

  'add fixed row titles
  fgObjects.Clear
  fgObjects.TextMatrix(0, 0) = "Item #"
  fgObjects.TextMatrix(0, 1) = "Item Description"
  fgObjects.TextMatrix(0, 2) = "Room #"
  
  'select first cell
  fgObjects.Col = 1
  
  'initialize object
  Set ObjectsEdit = New AGIInventoryObjects
  ObjectsEdit.NewObjects
  ObjectsEdit.MaxScreenObjects = Settings.MaxSO
  txtMaxScreenObj.Text = CStr(Settings.MaxSO)
  'reset searchpos
  StartPos = -1
  
#If DEBUGMODE <> 1 Then
  'subclass the flexgrid
  PrevFGWndProc = SetWindowLong(Me.fgObjects.hWnd, GWL_WNDPROC, AddressOf ScrollWndProc)
#End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

  'if right button
  If Button = vbRightButton Then
    'if edit menu is enabled
    If frmMDIMain.mnuEdit.Enabled Then
      'need doevents so form activation occurs BEFORE popup
      'otherwise, errors will be generated because of menu
      'adjustments that are made in the form_activate event
      SafeDoEvents
      'show edit menu
      PopupMenu frmMDIMain.mnuEdit
    End If
  End If
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  
  Cancel = Not AskClose()
End Sub

Sub Form_Resize()

  Dim sngBorders As Single
  
  On Error GoTo ErrHandler
  
  'use separate variables for managing minimum width/height
  If ScaleWidth < MinWidth Then
    CalcWidth = MinWidth
  Else
    CalcWidth = ScaleWidth
  End If
  If ScaleHeight < MinHeight Then
    CalcHeight = MinHeight
  Else
    CalcHeight = ScaleHeight
  End If
  
  'if the form is not visible
  If Not Visible Then
    Exit Sub
  End If
  
  'if minimized
  If WindowState = vbMinimized Then
    Exit Sub
  End If
  
  sngBorders = Width - ScaleWidth
  
  fgObjects.Height = CalcHeight - fgObjects.Top
  
  'resize interior items
  'reposition Max objects stuff
  txtMaxScreenObj.Left = CalcWidth - txtMaxScreenObj.Width
  Label1.Left = txtMaxScreenObj.Left - Label1.Width
  
  fgObjects.Width = CalcWidth
  'if more rows than will fit on screen
  If fgObjects.Rows * fgObjects.RowHeight(0) > fgObjects.Height Then
    'account for scrollbar
    fgObjects.ColWidth(1) = fgObjects.Width - fgObjects.ColWidth(2) - fgObjects.ColWidth(0) - 320
  Else
    fgObjects.ColWidth(1) = fgObjects.Width - fgObjects.ColWidth(2) - fgObjects.ColWidth(0)
  End If
  
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Public Sub MenuClickECustom1()
  'edit object
  
  'if on a valid row
  If fgObjects.Row > 1 Then
    'use double-click to force edit
    fgObjects_DblClick
  End If
  
End Sub
Public Sub MenuClickUndo()
  
  Dim NextUndo As ObjectsUndo
  Dim i As Long, strObjs() As String
  
  On Error GoTo ErrHandler
  
  'if there are no undo actions
  If UndoCol.Count = 0 Then
    'just exit
    Exit Sub
  End If
  
  'get next undo object
  Set NextUndo = UndoCol(UndoCol.Count)
  
  'remove undo object
  UndoCol.Remove UndoCol.Count
  'reset undo menu
  frmMDIMain.mnuEUndo.Enabled = (UndoCol.Count > 0)
  If frmMDIMain.mnuEUndo.Enabled Then
    frmMDIMain.mnuEUndo.Caption = "&Undo " & LoadResString(OBJUNDOTEXT + UndoCol(UndoCol.Count).UDAction) & vbTab & "Ctrl+Z"
  Else
    frmMDIMain.mnuEUndo.Caption = "&Undo" & vbTab & "Ctrl+Z"
  End If
  
  'undo the action
  Select Case NextUndo.UDAction
  Case udoAddItem        'store object number that was added
    'delete the last item
    DeleteItem ObjectsEdit.Count - 1, True
    'select last item
    fgObjects.Row = fgObjects.Rows - 1
    fgObjects.Col = 1
  
  Case udoDeleteItem        'store object number, text, and room that was deleted
    'if object number is equal to current Count
    If NextUndo.UDObjectNo = ObjectsEdit.Count Then
      'need to add item to restore
      AddItem NextUndo.UDObjectText, NextUndo.UDObjectRoom, True
    Else
      'use modify item to restore
      ModifyItem NextUndo.UDObjectNo, NextUndo.UDObjectText, True
      ModifyRoom NextUndo.UDObjectNo, NextUndo.UDObjectRoom, True
    End If
    'select this item
    fgObjects.Row = NextUndo.UDObjectNo + 1
    fgObjects.Col = 1
    
  Case udoModifyItem, udoReplace    'store old object number, text
    ModifyItem NextUndo.UDObjectNo, NextUndo.UDObjectText, True
    'select this item
    fgObjects.Row = NextUndo.UDObjectNo + 1
    fgObjects.Col = 1
    
  Case udoModifyRoom    'store old object number, room
    ModifyRoom NextUndo.UDObjectNo, NextUndo.UDObjectRoom, True
    'select this item
    fgObjects.Row = NextUndo.UDObjectNo + 1
    fgObjects.Col = 2
  
  Case udoChangeDesc       'store old description
    'restore old id
    ObjectsEdit.Description = NextUndo.UDObjectText
    'if in a game
    If InGame Then
      'restore the ingame resource as well
      ChangeResDescription rtObjects, -1, NextUndo.UDObjectText
    End If
    
  Case udoChangeMaxObj     'store old maxobjects
    'old Max is stored in room variable
    ModifyMax NextUndo.UDObjectRoom, True
    
  Case udoTglEncrypt       'store old encryption Value
    'old encryption is stored in room variable
    ToggleEncryption CBool(NextUndo.UDObjectRoom), True
    
  Case udoClear            'restore old Objects
    'if undoing a clear, objectsedit is already empty
    'so don't need to clear it; grid will already be
    'empty also
    
    'restore Max objects
    ObjectsEdit.MaxScreenObjects = NextUndo.UDObjectRoom
    txtMaxScreenObj.Text = CStr(NextUndo.UDObjectRoom)
    
    'restore encryption
    ObjectsEdit.Encrypted = CBool(NextUndo.UDObjectNo)
    frmMDIMain.mnuRCustom3.Checked = ObjectsEdit.Encrypted
    MainStatusBar.Panels("Encrypt").Text = "Encrypted"
    If Not ObjectsEdit.Encrypted Then
      MainStatusBar.Panels("Encrypt").Text = "Not " & MainStatusBar.Panels("Encrypt").Text
    End If
    
    'split out items
    strObjs = Split(NextUndo.UDObjectText, vbCr)
    
    'add them back to grid and the objectedit object
    For i = 0 To UBound(strObjs)
      If i <> 0 Then
        fgObjects.AddItem CStr(i) & "." & vbTab & strObjs(i)
        ObjectsEdit.Add fgObjects.TextMatrix(i + 1, ctDesc), CByte(fgObjects.TextMatrix(i + 1, ctRoom))
      End If
    Next i
    
    'update status bar with Count (subtract one cuz first item doesnt Count)
    MainStatusBar.Panels("Count").Text = "Object Count: " & CStr(i - 1)
    
  Case udoReplaceAll
    'udstring has previous items in pipe-delimited string
    strObjs = Split(NextUndo.UDObjectText, "|")
    
    'object numbers and old values are in pairs
    For i = 0 To UBound(strObjs) Step 2
      'first element is obj number, second is old obj desc
      ObjectsEdit(CLng(strObjs(i))).ItemName = strObjs(i + 1)
      'update grid
      fgObjects.TextMatrix(CLng(strObjs(i)) + 1, ctDesc) = strObjs(i + 1)
      
    Next i
    
  End Select
  
  'ensure selected row is visible
  ShowRow
Exit Sub

ErrHandler:
  Resume Next
End Sub

Public Sub SetEditMenu()
  
  'sets the menu captions on the Edit menu
  'based on current selection
  
  On Error GoTo ErrHandler
  
  'always force form to current
  If Not frmMDIMain.ActiveForm Is Nothing Then
    If Not (frmMDIMain.ActiveForm Is Me) And Visible Then
      Me.SetFocus
    End If
  End If
  
  With frmMDIMain
    .mnuEdit.Enabled = True
    'redo, cut, copy, paste, select all are hidden
    .mnuERedo.Visible = False
    .mnuECut.Visible = False
    .mnuECopy.Visible = False
    .mnuEPaste.Visible = False
    .mnuESelectAll.Visible = False
    
    .mnuEUndo.Visible = True
    'if there is something to undo
    If UndoCol.Count > 0 Then
      .mnuEUndo.Caption = "&Undo " & LoadResString(OBJUNDOTEXT + UndoCol(UndoCol.Count).UDAction) & vbTab & "Ctrl+Z"
      .mnuEUndo.Enabled = True
    Else
      .mnuEUndo.Caption = "&Undo" & vbTab & "Ctrl+Z"
      .mnuEUndo.Enabled = False
    End If
    .mnuEBar0.Visible = True
    
    .mnuEDelete.Visible = True
    'although not required, object i0 is not editable
    .mnuEDelete.Enabled = fgObjects.Row > 1
'''    .mnuEDelete.Enabled = True
    .mnuEDelete.Caption = "&Delete Item" & vbTab & "Del"
    
    .mnuEClear.Visible = True
    .mnuEClear.Enabled = True
    .mnuEClear.Caption = "&Clear List" & vbTab & "Shift+Del"
    
    .mnuEInsert.Visible = True
    .mnuEInsert.Enabled = True
    .mnuEInsert.Caption = "&Add Item" & vbTab & "Shift+Ins"
    
    .mnuEBar1.Visible = True
    .mnuEFind.Visible = True
    .mnuEFind.Enabled = True
    .mnuEFind.Caption = "&Find" & vbTab & "Ctrl+F"
    
    .mnuEFindAgain.Visible = True
    .mnuEFindAgain.Enabled = LenB(SearchFindText) <> 0
    .mnuEFindAgain.Caption = "Find A&gain" & vbTab & "F3"
    
    .mnuEReplace.Visible = True
    .mnuEReplace.Enabled = True
    .mnuEReplace.Caption = "Replace" & vbTab & "Ctrl+H"
    
    'enable findinlogics if object is not a '?'
    .mnuEBar2.Visible = True
    .mnuECustom2.Visible = True
    .mnuECustom2.Enabled = (fgObjects.TextMatrix(fgObjects.Row, ctDesc) <> "?")
    .mnuECustom2.Caption = "Find In Logics" & vbTab & "Shift+Ctrl+F"
    
    .mnuECustom1.Visible = True
    'although not required, object i0 is not editable
    .mnuECustom1.Enabled = fgObjects.Row > 1
'''    .mnuECustom1.Enabled = True
    .mnuECustom1.Caption = "&Edit Item" & vbTab & "Alt+Enter"
    
    'set menu status for encryption
    If Not ObjectsEdit Is Nothing Then
      .mnuRCustom3.Checked = ObjectsEdit.Encrypted
    End If
  End With
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Private Sub fgObjects_DblClick()
  
  On Error GoTo ErrHandler
  
  'save row and column being edited
  EditRow = fgObjects.Row
  EditCol = fgObjects.Col
  EditItemNum = fgObjects.Row - 1

''' although not required, object i0 is traditionally set
''' to '?', as are all 'unused' objects

  'if on editable item row
  '(first object is always '?' and is uneditable)
  If fgObjects.Row > 1 Then
    'begin edit
    Select Case EditCol
    Case ctNumber, ctDesc
      'disable edit menu
      frmMDIMain.mnuEdit.Enabled = False

      'begin edit of item description
      With txtObject
        .Move fgObjects.CellLeft + CellIndentH, fgObjects.CellTop + fgObjects.Top + CellIndentV, fgObjects.CellWidth - CellIndentH, fgObjects.CellHeight - CellIndentV
        .Text = fgObjects.TextMatrix(fgObjects.Row, 1)
        .Visible = True
        .SelStart = 0
        .SelLength = Len(.Text)
        .SetFocus
      End With

    Case ctRoom
      'disable edit menu
      frmMDIMain.mnuEdit.Enabled = False

      'begin edit of room
      With txtRoomNo
        .Move fgObjects.CellLeft + CellIndentH, fgObjects.CellTop + fgObjects.Top + CellIndentV, fgObjects.CellWidth - CellIndentH, fgObjects.CellHeight - CellIndentV
        .Text = ObjectsEdit(fgObjects.Row - 1).Room
        .Visible = True
        'select all
        .SelStart = 0
        .SelLength = Len(.Text)
        .SetFocus
      End With
    End Select
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Sub fgObjects_KeyDown(KeyCode As Integer, Shift As Integer)
  
  If (fgObjects.Rows >= 1) Then
    Select Case KeyCode
    Case 46
      DeleteItem fgObjects.Row - 1
    Case 48
      MenuClickInsert
    End Select
  End If
End Sub
Public Function AskClose() As Boolean

  Dim rtn As VbMsgBoxResult

  'assume ok to close
  AskClose = True
  
  On Error GoTo ErrHandler
  'if object list has been modified since last save,
  If IsDirty Then
    'get user input
    rtn = MsgBox("Do you want to save changes to this objects file before closing?", vbYesNoCancel, "Objects Editor")
    
    'if user wants to save
    If rtn = vbYes Then
      'save by calling the menuclick method
      MenuClickSave
    End If
    
    'return false if cancel was selected
    AskClose = rtn <> vbCancel
  End If
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function


Private Sub Form_Unload(Cancel As Integer)

  'ensure object is cleared and dereferenced
  If Not ObjectsEdit Is Nothing Then
    Debug.Assert ObjectsEdit.Loaded
    ObjectsEdit.Unload
    Set ObjectsEdit = Nothing
  End If
  
  'if this is the ingame
  If InGame Then
    'reset inuse flag
    OEInUse = False
    'release the object
    Set ObjectEditor = Nothing
  End If

  'release subclass hook to flexgrid
#If DEBUGMODE <> 1 Then
  SetWindowLong Me.fgObjects.hWnd, GWL_WNDPROC, PrevFGWndProc
#End If
  'need to check if this is last form
  LastForm Me
End Sub

Private Sub txtMaxScreenObj_KeyPress(KeyAscii As Integer)

  'allow only numbers, backspace, and delete
  
  On Error GoTo ErrHandler
  
  Select Case KeyAscii
  Case 48 To 57, 8  'numbers and backspace
  Case 9, 10, 13 'enter or tab
    'if result is valid,
    If ValidateMaxSObj() Then
      'set focus to grid
      fgObjects.SetFocus
      'reenable edit menu
      frmMDIMain.mnuEdit.Enabled = True
      
    Else
      'need to force focus (might be a tab thing?)
      With txtMaxScreenObj
        .SelStart = 0
        .SelLength = Len(.Text)
        .SetFocus
      End With
    End If
    
    'ignore key
    KeyAscii = 0
    
  Case 27 'escape
    'restore value
    txtMaxScreenObj.Text = CStr(ObjectsEdit.MaxScreenObjects)

    'set focus to grid
    fgObjects.SetFocus
    'reenable edit menu
    frmMDIMain.mnuEdit.Enabled = True
  
    'ignore key
    KeyAscii = 0
    
  Case Else
    'ignore all other keys
    KeyAscii = 0
  End Select
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Function ValidateMaxSObj() As Boolean
  
  Dim NewMax As Long, rtn As Long
  
  On Error GoTo ErrHandler
  
  'assume ok until proven otherwise
  ValidateMaxSObj = True
  
  If Val(txtMaxScreenObj.Text) <= 0 Then
    'force it to 0 and warn user
    NewMax = 0
    If MsgBox("Setting Max Screenobject to 0 means only ego can be animated." & vbCrLf & _
    "Are you sure you want to set this value?", vbQuestion + vbYesNo, "Zero Screen Objects") = vbNo Then
      'fail validation
      ValidateMaxSObj = False
      Exit Function
    End If
    
  ElseIf Val(txtMaxScreenObj.Text) > 255 Then
    'force it to 255
    NewMax = 255
    'ask user to validate
    If MsgBox("Largest value for MaxScreenObject is 255. Setting a value this high will" & vbCrLf & _
    "likely result in running out of memory. Are you sure you want to set this value?", vbQuestion + vbYesNo, "Large Screen Objects") = vbNo Then
      'fail validation
      ValidateMaxSObj = False
      Exit Function
    End If
    
  Else
    'use it if it's a valid byte value
    NewMax = Val(txtMaxScreenObj.Text)
    
    'check for abnormally small or large values
    If NewMax < 16 Then
      If MsgBox("Less than 16 screen objects is unusually low." & vbCrLf & _
      "Are you sure you want to set this value?", vbQuestion + vbYesNo, "Low Number of Screen Objects") = vbNo Then
        'fail validation
        ValidateMaxSObj = False
        Exit Function
      End If
    ElseIf NewMax > 48 Then
      If MsgBox("More than 48 screen objects is unusually high." & vbCrLf & _
      "Are you sure you want to set this value?", vbQuestion + vbYesNo, "High Number of Screen Objects") = vbNo Then
        'fail validation
        ValidateMaxSObj = False
        Exit Function
      End If
    End If
  End If
  
  'if new value is OK, keep it,
  ModifyMax NewMax
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Private Sub txtMaxScreenObj_Validate(Cancel As Boolean)

  'this will handle cases where user tries to 'click' on something,
  
  On Error GoTo ErrHandler
  
  'if OK, hide the text box
  If ValidateMaxSObj() Then
    'set focus to grid
    fgObjects.SetFocus
  Else
  'if not OK, cancel
    Cancel = True
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub txtObject_Change()

  On Error GoTo ErrHandler
  
  'if this is last row,
  If EditRow = fgObjects.Rows - 1 Then
''    'add another row
''    fgObjects.AddItem vbNullString
''    'adjust column widths by resizing
''    Form_Resize
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub txtObject_KeyPress(KeyAscii As Integer)
  
  On Error GoTo ErrHandler
  
  Select Case KeyAscii
  Case 9, 10, 13 'enter or tab
    'if result is valid,
    If ValidateObject() Then
      'hide the box
      txtObject.Visible = False
      
      fgObjects.SetFocus
      'reenable edit menu
      frmMDIMain.mnuEdit.Enabled = True
      
      'tab moves to next column and begins editing
      If KeyAscii = 9 Then
        'move to Room column
        fgObjects.Col = ctRoom
        'start another edit operation
        fgObjects_DblClick
      End If
    Else
      'need to force focus (might be a tab thing?)
      txtObject.SetFocus
    End If
    
    'ignore key
    KeyAscii = 0
    
  Case 27 'escape
    'hide the textbox without saving text
    txtObject.Visible = False
    
    'ignore key
    KeyAscii = 0
  End Select
  
  'if new object is blank
  If LenB(fgObjects.TextMatrix(EditRow, ctDesc)) = 0 Then
    MenuClickDelete
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Private Sub txtObject_Validate(Cancel As Boolean)
  
  'this will handle cases where user tries to 'click' on something,
  
  On Error GoTo ErrHandler
  
  If Not txtObject.Visible Then Exit Sub
  
  'if OK, hide the text box
  If ValidateObject() Then
    txtObject.Visible = False
  Else
  'if not OK, cancel
    Cancel = True
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Private Sub txtRoomNo_KeyPress(KeyAscii As Integer)

  'allow only numbers, backspace, and delete
  On Error GoTo ErrHandler
  
  Select Case KeyAscii
  Case 48 To 57, 8  'numbers and backspace
  Case 9, 10, 13 'enter or tab
    'if result is valid,
    If ValidateRoom() Then
      'hide the box
      txtRoomNo.Visible = False
      fgObjects.SetFocus
      'reenable edit menu
      frmMDIMain.mnuEdit.Enabled = True
      
      'tab moves to next row, description
      If KeyAscii = 9 Then
        'if on last row
        If fgObjects.Row = fgObjects.Rows - 1 Then
''          'add a new row
''          fgObjects.AddItem vbNullString
        Else
          'move to next column, next row
          fgObjects.Col = 1
          fgObjects.Row = fgObjects.Row + 1
          
          'start another edit operation
          fgObjects_DblClick
        End If
        
      End If
    Else
      'need to force focus (might be a tab thing?)
      txtRoomNo.SetFocus
    End If
      
    'ignore key
    KeyAscii = 0
    
  Case 27 'escape
    'hide textbox without saving text
    txtRoomNo.Visible = False
    
    'ignore key
    KeyAscii = 0
    fgObjects.SetFocus
    'reenable edit menu
    frmMDIMain.mnuEdit.Enabled = True
  
  Case Else
    'ignore all other keys
    KeyAscii = 0
  End Select
  
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Private Sub txtRoomNo_Validate(Cancel As Boolean)

  'this will handle cases where user tries to 'click' on something,
  'but NOT when keys are pressed?
  
  On Error GoTo ErrHandler
  If Not txtRoomNo.Visible Then Exit Sub
  
  'if OK, hide the text box
  If ValidateRoom() Then
    txtRoomNo.Visible = False
  Else
  'if not OK, cancel
    Cancel = True
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


