VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AGICommands"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3E06727E02FD"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'agiCommandInfo Class
'
'this class holds objects that contain information relating to
'current game commands
'test commands are in a separate object class
'
Public Type CommandStruct
  Name As String
  ArgCount As Byte
  ArgType(7) As ArgTypeEnum
End Type

Public Enum ArgTypeEnum
  atNum = 0       'i.e. numeric Value
  atVar = 1       'v##
  atFlag = 2      'f##
  atMsg = 3       'm##
  atSObj = 4      'o##
  atIObj = 5      'i##
  atStr = 6       's##
  atWord = 7      'w## -- word argument (that user types in)
  atCtrl = 8      'c##
  atDefStr = 9    'defined string; could be msg, inv obj, or vocword
  atVocWrd = 10   'vocabulary word; NOT word argument
End Enum

Public strErrSource As String
Private Sub Class_Initialize()

  strErrSource = "WinAGI.agiCommandInfo"
End Sub



Public Property Get AGICommand(ByVal Index As Byte) As CommandStruct
Attribute AGICommand.VB_UserMemId = 0
  'validate index
  If Index > agNumCmds Then
    On Error GoTo 0: Err.Raise 9, strErrSource, "Subscript out of range"
  End If
  
  AGICommand = agCmds(Index)
  
End Property

Public Property Get Count() As Byte
  Count = agNumCmds
  
End Property
