VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WordsUndo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

  'WordsUndo
  
  Public UDAction As udwActionType
  Public UDGroup As StringList
  Public UDGroupNo As Long
  Public UDOldGroupNo As Long
  Public UDWord As String
  Public UDOldWord As String
  Public UDDescription As String
  
  Public Enum udwActionType
    udwAddGroup   'store group number that was added
    udwDelGroup   'store group number AND group object that was deleted
    udwRenumber   'store old group number AND new group number
    udwAddWord    'store group number AND new word that was added
    udwDelWord    'store group number AND old word that was deleted
    udwMoveWord   'store old group number, new group number and word that was moved
    udwChangeWord 'store old word and new word
    udwChangeDesc 'store old description
    udwCutWord    'same as delete
    udwCutGroup   'same as delete
    udwPasteWord  'store group number and old word that was pasted over
    udwPasteGroup 'store group number and list of old words that were pasted over
    udwReplace    'same as change word
    udwReplaceAll 'store list of all words changed
    udwClear      'store all words and their groups
  End Enum

Private Sub Class_Initialize()

  Set Me.UDGroup = New StringList
End Sub

Private Sub Class_Terminate()
  'ensure objects have been released
  Set UDGroup = Nothing
End Sub
