VERSION 5.00
Begin VB.Form frmGetResourceNum 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Add View"
   ClientHeight    =   3240
   ClientLeft      =   30
   ClientTop       =   330
   ClientWidth     =   6555
   Icon            =   "frmGetResourceNum.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3240
   ScaleWidth      =   6555
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdDont 
      Caption         =   "Open, Don't Import"
      Height          =   372
      Left            =   1500
      TabIndex        =   11
      Top             =   2700
      Visible         =   0   'False
      Width           =   1590
   End
   Begin VB.CheckBox chkRoom 
      Caption         =   "Include Room Template Code"
      Height          =   255
      Left            =   3360
      TabIndex        =   8
      Top             =   2640
      Visible         =   0   'False
      Width           =   2700
   End
   Begin VB.TextBox txtDescription 
      Height          =   1590
      Left            =   3120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   7
      Top             =   945
      Width           =   3240
   End
   Begin VB.TextBox txtID 
      Height          =   285
      Left            =   3120
      TabIndex        =   5
      Top             =   360
      Width           =   3240
   End
   Begin VB.CheckBox chkIncludePic 
      Caption         =   "Create matching Picture"
      Height          =   255
      Left            =   3360
      TabIndex        =   9
      Top             =   2880
      Visible         =   0   'False
      Width           =   2700
   End
   Begin VB.ListBox lstResNum 
      Height          =   1425
      Left            =   180
      TabIndex        =   3
      Top             =   1065
      Width           =   2640
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Height          =   372
      Left            =   1620
      TabIndex        =   12
      Top             =   2700
      Width           =   1120
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   372
      Left            =   210
      TabIndex        =   10
      Top             =   2700
      Width           =   1120
   End
   Begin VB.Label lblDescription 
      Caption         =   "&Description:"
      Height          =   270
      Left            =   3120
      TabIndex        =   6
      Top             =   705
      Width           =   2025
   End
   Begin VB.Label lblID 
      Caption         =   "&Resource ID:"
      Height          =   270
      Left            =   3120
      TabIndex        =   4
      Top             =   120
      Width           =   2025
   End
   Begin VB.Label lblCurrent 
      Alignment       =   2  'Center
      Caption         =   "1"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   345
      Left            =   900
      TabIndex        =   1
      Top             =   315
      Width           =   1095
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Current Resource Number: "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   225
      Left            =   360
      TabIndex        =   0
      Top             =   45
      Width           =   2415
   End
   Begin VB.Label Label1 
      Caption         =   "Select a view for testing pictures:"
      Height          =   465
      Left            =   165
      TabIndex        =   2
      Top             =   825
      Width           =   2730
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "frmGetResourceNum"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

  Public ResType As AGIResType
  Public NewResNum As Byte
  Public OldResNum As Byte
  Public Canceled  As Boolean
  Public DontImport As Boolean
  Public WindowFunction As EGetRes

  Private tmpView As AGIView, tmpLogic As AGILogic
  Private tmpSound As AGISound, tmpPicture As AGIPicture
  Private tmpCol As Collection
  Private tmpRes As Object
  

Public Sub Activate()
  'bridge method to call the form's Activate event method
  Form_Activate
End Sub

Private Sub AdjustControls()
  
  'shows/hides form controls and adjusts
  'form height and control positions based on window function
  
'defaults when form is initially loaded:
' size wide (6645)
'Label2/lblCurrent are visible
'Label1 and lstResNum in lower position (825/1065/1425)
'chkRoom and chkPic are both not visible
'cmdDont is not visible
'cmdCancel is visible at left position, with caption of 'cancel' (1620)
'form caption needs to be set!
'list caption (Label1) needs to be set!
'cmdOK disabled

  Dim i As Long
  
  Select Case WindowFunction
  Case grAddNew
    Me.Caption = "Add New " & ResTypeName(ResType)
    lblCurrent.Visible = False
    Label2.Visible = False
    Label1.Top = 120
    Label1.Caption = "Select a number for this new " & ResTypeName(ResType) & ":"
    lstResNum.Top = 360
    lstResNum.Height = 2130
    cmdDont.Visible = True
    cmdDont.Caption = "New Not in Game"
    cmdCancel.Left = 3270
    If ResType = rtLogic Then
      chkIncludePic.Value = vbChecked
      chkIncludePic.Visible = True
      chkIncludePic.Top = 2100
      chkRoom.Value = vbChecked
      chkRoom.Visible = True
      chkRoom.Enabled = False
      chkRoom.Top = 2340
      txtDescription.Height = 1050
    Else
      chkIncludePic.Visible = False
      chkRoom.Visible = False
    End If
    
    'nothing is selected
    lstResNum.ListIndex = -1
    
  Case grAddInGame
    Me.Caption = "Add " & ResTypeName(ResType)
    lblCurrent.Visible = False
    Label2.Visible = False
    Label1.Top = 120
    Label1.Caption = "Select a number for this " & ResTypeName(ResType) & ":"
    lstResNum.Top = 360
    lstResNum.Height = 2130
    cmdDont.Visible = False
    chkIncludePic.Visible = False
    chkRoom.Visible = False
    
    'nothing is selected
    lstResNum.ListIndex = -1
    
  Case grRenumber
    Me.Width = 3090
    Select Case ResType
    Case rtLogic
      Me.Caption = ResourceName(Logics(OldResNum), True, True)
    Case rtPicture
      Me.Caption = ResourceName(Pictures(OldResNum), True, True)
    Case rtSound
      Me.Caption = ResourceName(Sounds(OldResNum), True, True)
    Case rtView
      Me.Caption = ResourceName(Views(OldResNum), True, True)
    End Select
    lblCurrent.Caption = CStr(OldResNum)
    Label1.Caption = "Select a new number for this " & ResTypeName(ResType) & ":"
    
    'nothing is selected
    lstResNum.ListIndex = -1
    
 Case grOpen
    Me.Width = 3090
    Me.Caption = "Open " & ResTypeName(ResType)
    lblCurrent.Visible = False
    Label2.Visible = False
    Label1.Top = 120
    Label1.Caption = "Select the " & ResTypeName(ResType) & " to open:"
    lstResNum.Top = 360
    lstResNum.Height = 2130
    
    'nothing is selected
    lstResNum.ListIndex = -1
    
  Case grTestView
    Me.Width = 3090
    Me.Caption = "Select Test View"
    lblCurrent.Caption = CStr(OldResNum)
    Label1.Caption = "Select a view for testing pictures:"
    
    'select current test view, if there is one
    lstResNum.ListIndex = -1
    For i = 0 To lstResNum.ListCount - 1
      If lstResNum.ItemData(i) = OldResNum Then
        lstResNum.ListIndex = i
        Exit For
      End If
    Next i
    
  Case grAddLayout
    Me.Caption = "Add New Room"
    lblCurrent.Visible = False
    Label2.Visible = False
    Label1.Top = 120
    Label1.Caption = "Select a number for this new room:"
    lstResNum.Top = 360
    lstResNum.Height = 2130
    chkIncludePic.Visible = True
    chkIncludePic.Value = vbChecked
    chkRoom.Visible = True
    chkRoom.Value = vbChecked
    chkRoom.Enabled = False
    
    'nothing is selected
    lstResNum.ListIndex = -1
    
  Case grShowRoom
    Me.Width = 3090
    Me.Caption = "Show Room"
    lblCurrent.Visible = False
    Label2.Visible = False
    Label1.Top = 120
    Label1.Caption = "Select a room to show:"
    lstResNum.Top = 360
    lstResNum.Height = 2130
    
    'nothing is selected
    lstResNum.ListIndex = -1
  
  Case grMenu
    Me.Width = 3090
    Me.Caption = "Extract Menu"
    lblCurrent.Visible = False
    Label2.Visible = False
    Label1.Top = 120
    Label1.Caption = "Select the logic with the game's menu:"
    lstResNum.Top = 360
    lstResNum.Height = 2130
'''    cmdCancel.Caption = "Default"
    
    'nothing is selected
    lstResNum.ListIndex = -1
    
  Case grImport
    Me.Caption = "Import " & ResTypeName(ResType)
    lblCurrent.Visible = False
    Label2.Visible = False
    Label1.Top = 120
    Label1.Caption = "Select a number for this imported " & ResTypeName(ResType) & ":"
    lstResNum.Top = 360
    lstResNum.Height = 2130
    cmdDont.Visible = True
    cmdCancel.Left = 3270
    chkRoom.Visible = False
    chkIncludePic.Visible = False
    
    'nothing is selected
    lstResNum.ListIndex = -1
    
  Case grMenuBkgd
    Me.Width = 3090
    Caption = "Menu Background"
    lblCurrent.Caption = CStr(OldResNum)
    Label1.Caption = "Select picture to use as background:"
    'nothing is selected
    lstResNum.ListIndex = -1
  
  End Select
End Sub

Public Sub FormSetup()
  
  Dim i As Long, lngOldNum As Long, strID As String
  On Error GoTo ErrHandler
  
  'clear the listbox
  lstResNum.Clear
  
  Select Case WindowFunction
  Case grAddNew, grAddInGame, grRenumber, grAddLayout, grImport
    'add all numbers to temporary collection
    Set tmpCol = New Collection
    For i = 0 To 255
      tmpCol.Add CStr(i), CStr(i)
    Next i
  
    'if adding rooms in layout, ALWAYS include pic
    If WindowFunction = grAddLayout Then
      chkIncludePic.Value = vbChecked
      chkIncludePic.Enabled = False
    End If
    
    'remove all resource numbers that are in use
    Select Case ResType
    Case rtView
      'if any views,
      If Views.Count > 0 Then
        For Each tmpView In Views
          tmpCol.Remove CStr(tmpView.Number)
        Next
      End If
    Case rtPicture
      'if any pictures,
      If Pictures.Count > 0 Then
        For Each tmpPicture In Pictures
          tmpCol.Remove CStr(tmpPicture.Number)
        Next
      End If
    Case rtSound
      'if any sounds,
      If Sounds.Count > 0 Then
        For Each tmpSound In Sounds
          tmpCol.Remove CStr(tmpSound.Number)
        Next
      End If
    Case rtLogic
      'remove all logics that are in use
      If Logics.Count > 0 Then
        For Each tmpLogic In Logics
          tmpCol.Remove CStr(tmpLogic.Number)
        Next
      End If
      
      'if adding rooms in logic/picture pairs
      If Me.chkIncludePic.Value = vbChecked Then
        'ensure logic 0 is removed
        On Error Resume Next
        tmpCol.Remove CStr(0)
        Err.Clear
      End If
      
      'if adding to layout room 0 is NEVER available
      If WindowFunction = grAddLayout Then
        'ensure logic 0 is removed
        On Error Resume Next
        tmpCol.Remove CStr(0)
        Err.Clear
      End If
    End Select
    
    'add remaining numbers to the combobox
    For i = 1 To tmpCol.Count
      lstResNum.AddItem tmpCol(i)
      lstResNum.ItemData(i - 1) = tmpCol(i)
    Next i
    
  Case grOpen, grTestView, grMenu, grMenuBkgd
    'to ensure resources are sorted by number, use the tmpcollection;
    'only add resources that are in game
    Set tmpCol = New Collection
    
    On Error Resume Next
    
    Select Case ResType
    Case rtLogic
      For i = 0 To 255
        If Logics.Exists(i) Then
          tmpCol.Add CStr(i), CStr(i)
        End If
      Next i
      
      'step through collection to add numbers to list
      For i = 1 To tmpCol.Count
        If Settings.ShowResNum Then
          lstResNum.AddItem ResourceName(Logics(CByte(tmpCol(i))), True)
        Else
          lstResNum.AddItem tmpCol(i) & " - " & Logics(CByte(tmpCol(i))).ID
        End If
        lstResNum.ItemData(lstResNum.ListCount - 1) = tmpCol(i)
      Next i
      
    Case rtPicture
      For i = 0 To 255
        If Pictures.Exists(i) Then
          tmpCol.Add CStr(i), CStr(i)
        End If
      Next i
      
      'step through collection to add numbers to list
      For i = 1 To tmpCol.Count
        If Settings.ShowResNum Then
          lstResNum.AddItem ResourceName(Pictures(CByte(tmpCol(i))), True)
        Else
          lstResNum.AddItem tmpCol(i) & " - " & Pictures(CByte(tmpCol(i))).ID
        End If
        lstResNum.ItemData(lstResNum.ListCount - 1) = tmpCol(i)
      Next i
  
    Case rtSound
      For i = 0 To 255
        If Sounds.Exists(i) Then
          tmpCol.Add CStr(i), CStr(i)
        End If
      Next i
      
      'step through collection again to add numbers to list
      For i = 1 To tmpCol.Count
        If Settings.ShowResNum Then
          lstResNum.AddItem ResourceName(Sounds(CByte(tmpCol(i))), True)
        Else
          lstResNum.AddItem tmpCol(i) & " - " & Sounds(CByte(tmpCol(i))).ID
        End If
        lstResNum.ItemData(lstResNum.ListCount - 1) = tmpCol(i)
      Next i
  
    Case rtView
      For i = 0 To 255
        If Views.Exists(i) Then
          tmpCol.Add CStr(i), CStr(i)
        End If
      Next i
      
      'step through collection and add numbers to list
      For i = 1 To tmpCol.Count
        If Settings.ShowResNum Then
          lstResNum.AddItem ResourceName(Views(CByte(tmpCol(i))), True)
        Else
          lstResNum.AddItem tmpCol(i) & " - " & Views(CByte(tmpCol(i))).ID
        End If
        lstResNum.ItemData(lstResNum.ListCount - 1) = tmpCol(i)
      Next i
    End Select
  
  Case grShowRoom
    'displays all logics in game which do NOT have InRoom=True
    Set tmpCol = New Collection
    For i = 1 To 255
      If Logics.Exists(i) Then
        tmpCol.Add CStr(i), CStr(i)
      End If
    Next i
  
    'remove all logics that are rooms
    For Each tmpLogic In Logics
      If tmpLogic.IsRoom Then
        'remove
        tmpCol.Remove CStr(tmpLogic.Number)
      End If
    Next
    
    On Error Resume Next
    'add items from tmpCol to listbox
    For i = 1 To tmpCol.Count
      If Settings.ShowResNum Then
        lstResNum.AddItem ResourceName(Logics(tmpCol(i)), True)
      Else
        lstResNum.AddItem tmpCol(i) & " - " & Logics(CByte(tmpCol(i))).ID
      End If
      lstResNum.ItemData(lstResNum.ListCount - 1) = tmpCol(i)
    Next i
    
    'if no rooms added
    If lstResNum.ListCount = 0 Then
      MsgBox "All logics in the game are currently tagged as rooms and are visible.", vbInformation + vbOKOnly, "Show Room"
      'set cancel to true
      Canceled = True
      'hide form and exit
      Exit Sub
    Else
      Canceled = False
    End If
      
  End Select
  
  'set form size and controls
  AdjustControls
  
  'assume cancel
  Canceled = True
  'and not 'dont import'
  DontImport = False
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub cmdCancel_Click()

  'user canceled
  Canceled = True
  
  Me.Hide
End Sub

Private Sub cmdDont_Click()

  'not canceled, but not importing
  Canceled = False
  DontImport = True
  Me.Hide
End Sub


Private Sub cmdOK_Click()
  
  'get resnum
  NewResNum = CByte(lstResNum.ItemData(lstResNum.ListIndex))
  
  'if renumbering AND number hasn't changed,
  If (WindowFunction = grRenumber) And (OldResNum = NewResNum) Then
    'same as canceling
    Canceled = True
  ElseIf WindowFunction = grAddNew Or WindowFunction = grAddInGame Then
    'validate the resource ID
    Select Case ResType
    Case rtLogic
      For Each tmpRes In Logics
        If tmpRes.ID = txtID.Text Then
          MsgBox txtID.Text & " is already assigned. Choose a different ID.", vbInformation + vbOKOnly, "Duplicate Resource ID"
          Exit Sub
        End If
      Next
    Case rtPicture
      For Each tmpRes In Pictures
        If tmpRes.ID = txtID.Text Then
          MsgBox txtID.Text & " is already assigned. Choose a different ID.", vbInformation + vbOKOnly, "Duplicate Resource ID"
          Exit Sub
        End If
      Next
    Case rtSound
      For Each tmpRes In Sounds
        If tmpRes.ID = txtID.Text Then
          MsgBox txtID.Text & " is already assigned. Choose a different ID.", vbInformation + vbOKOnly, "Duplicate Resource ID"
          Exit Sub
        End If
      Next
    Case rtView
      For Each tmpRes In Views
        If tmpRes.ID = txtID.Text Then
          MsgBox txtID.Text & " is already assigned. Choose a different ID.", vbInformation + vbOKOnly, "Duplicate Resource ID"
          Exit Sub
        End If
      Next
    End Select
    'id is ok
    Canceled = False
  Else
    'user did not cancel
    Canceled = False
  End If
  
  Me.Hide
End Sub

Private Sub Form_Activate()

  'set focus to resnum list
  lstResNum.SetFocus
End Sub

Private Sub Form_Deactivate()

  'make sure all objects are de-referenced, otherwise
  'form will not unload! it'll just sit there and fester
  
  'and when the load event is called, it doesn't load,
  'it just references the festering version with all
  'it's crapped up settings and things...
  
  
  Set tmpView = Nothing
  Set tmpLogic = Nothing
  Set tmpSound = Nothing
  Set tmpPicture = Nothing
  Set tmpCol = Nothing
  Set tmpRes = Nothing
  Debug.Print "deactivated..."
End Sub


Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

  'check for help key
  If Shift = 0 And KeyCode = vbKeyF1 Then
    HtmlHelpS HelpParent, WinAGIHelp, HH_DISPLAY_TOPIC, "htm\winagi\Managing Resources.htm#resnum"
    KeyCode = 0
  End If
End Sub


Private Sub lstResNum_Click()
  
  'enable ok button
  cmdOK.Enabled = True
  
  'if adding or importing a new resource
  Select Case WindowFunction
  Case grAddLayout, grAddNew, grAddInGame, grImport
'  If (WindowFunction = grAddLayout Or WindowFunction = grAddNew Or WindowFunction = grImport) Then
    'if format is restype and resnum (i.e., "Logic0") OR is blank
    If LenB(txtID.Text) = 0 Or (Left$(txtID.Text, Len(ResTypeName(ResType))) = ResTypeName(ResType)) Then
      'update id box
      txtID.Text = ResTypeName(ResType) & lstResNum.Text
    End If
    
    'if adding a room (logic, with matching pic) check for existing pic
    If WindowFunction = grAddLayout Or ((WindowFunction = grAddNew Or WindowFunction = grImport) And ResType = rtLogic) Then
    
      'if this pic number exists,
      If Pictures.Exists(CByte(lstResNum.Text)) Then
        'change checkbox text
        Me.chkIncludePic.Caption = "Replace existing Picture"
      Else
        chkIncludePic.Caption = "Create matching Picture"
      End If
    End If
    
    'never allow adding pic for room 0!
    If lstResNum.Text = "0" Then
      chkIncludePic.Enabled = False
      chkIncludePic.Value = vbUnchecked
      chkRoom.Enabled = False
      chkRoom.Value = vbUnchecked
    Else
      chkIncludePic.Enabled = True
      chkRoom.Enabled = (WindowFunction <> grAddLayout)
    End If
  End Select
End Sub

Private Sub lstResNum_DblClick()
  'same as clicking OK
  cmdOK_Click
  
End Sub

Private Sub txtID_Change()

  'enable ok only if id is Not null AND a valid number is selected
  cmdOK.Enabled = LenB(txtID.Text) <> 0 And lstResNum.ListIndex <> -1
End Sub


