VERSION 5.00
Object = "{86CF1D34-0C5F-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCT2.OCX"
Begin VB.Form frmPlotEdit 
   AutoRedraw      =   -1  'True
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Edit Plot Point"
   ClientHeight    =   3285
   ClientLeft      =   2760
   ClientTop       =   3690
   ClientWidth     =   4080
   ControlBox      =   0   'False
   Icon            =   "frmPlotEdit.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3285
   ScaleWidth      =   4080
   ShowInTaskbar   =   0   'False
   Begin VB.TextBox txtY 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   510
      Left            =   1770
      TabIndex        =   3
      Text            =   "167"
      Top             =   300
      Width           =   720
   End
   Begin VB.TextBox txtX 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   510
      Left            =   480
      TabIndex        =   1
      Text            =   "159"
      Top             =   300
      Width           =   720
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   2700
      TabIndex        =   10
      Top             =   600
      Width           =   1215
   End
   Begin VB.TextBox txtSeed 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   585
      Left            =   2640
      TabIndex        =   7
      Text            =   "109"
      Top             =   1860
      Width           =   975
   End
   Begin MSComCtl2.UpDown udSeed 
      Height          =   495
      Left            =   3600
      TabIndex        =   8
      Top             =   1905
      Width           =   255
      _ExtentX        =   450
      _ExtentY        =   873
      _Version        =   393216
      OrigLeft        =   3600
      OrigTop         =   480
      OrigRight       =   3855
      OrigBottom      =   975
      Max             =   119
      Wrap            =   -1  'True
      Enabled         =   -1  'True
   End
   Begin VB.PictureBox picPlot 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   2025
      Left            =   240
      ScaleHeight     =   135
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   135
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   1080
      Visible         =   0   'False
      Width           =   2025
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   2700
      TabIndex        =   9
      Top             =   120
      Width           =   1215
   End
   Begin VB.PictureBox picBackground 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   405
      Left            =   360
      ScaleHeight     =   27
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   14
      TabIndex        =   5
      TabStop         =   0   'False
      Top             =   1560
      Width           =   210
   End
   Begin VB.Label lblY 
      Caption         =   "Y:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   1440
      TabIndex        =   2
      Top             =   345
      Width           =   360
   End
   Begin VB.Label lblX 
      Caption         =   "X:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   120
      TabIndex        =   0
      Top             =   345
      Width           =   360
   End
   Begin VB.Label lblPattern 
      Caption         =   "Pattern Number"
      Height          =   255
      Left            =   2640
      TabIndex        =   6
      Top             =   1620
      Width           =   1200
   End
End
Attribute VB_Name = "frmPlotEdit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

Public Canceled As Boolean
Public NewPattern As Byte, OldPattern As Byte
Public PenSize As Long, PenShape As EPlotShape
Public PenColor As AGIColors, VisPic As Boolean

Private CircleData(63) As Byte


Public Sub FormSetup(ByVal CmdType As DrawFunction, OldX As Byte, OldY As Byte, Optional ByVal Splat As Boolean)

  'change height, depending on whether or not splatter pattern is applicable
  
  'default to just coords
  Me.Height = 1560
  
  Select Case CmdType
  Case dfPlotPen
    Me.Caption = "Edit Plot Coordinate"
    If Splat Then
      Me.Height = 3720
      Me.Caption = Me.Caption & " and Pattern"
      'show the plot area
      Me.picPlot.Visible = True
    End If
  Case dfAbsLine  'abs line
    Me.Caption = "Edit Line Coordinate"
  Case dfXCorner  'x corner
    Me.Caption = "Edit X Corner Coordinate"
  Case dfYCorner  'y corner
    Me.Caption = "Edit Y Corner Coordinate"
  Case dfFill  'fill
    Me.Caption = "Edit Fill Coordinate"
  End Select
  
  txtX.Text = CStr(OldX)
  txtY.Text = CStr(OldY)
  
End Sub


Private Sub cmdCancel_Click()

  Canceled = True
  Me.Hide
  
End Sub

Private Sub Form_Activate()
  Dim rtn As Long
  
  'set initial Value
  txtSeed.Text = CStr(OldPattern)
  NewPattern = OldPattern
  
  'draw this pattern on the background
  DrawPlotPoint
  
End Sub

Private Sub Form_Load()
  
  InitializePlotData
End Sub

Private Sub cmdOK_Click()

  Canceled = False
  Me.Hide
  
End Sub

Private Sub txtSeed_Change()

  If Val(txtSeed.Text) > 119 Then
    txtSeed.Text = 119
  End If
  If Val(txtSeed.Text) < 1 Then
    txtSeed.Text = 1
  End If
  
  'if pattern is different, redraw
  If NewPattern <> Val(txtSeed.Text) Then
    NewPattern = CByte(Val(txtSeed.Text))
    DrawPlotPoint
  End If
End Sub

Private Sub txtSeed_KeyPress(KeyAscii As Integer)

  'only numbers, cursor keys, backspace and delete accepted
  If (KeyAscii < vbKey0 Or KeyAscii > vbKey9) And KeyAscii <> 8 Then
    KeyAscii = 0
  End If
End Sub

Private Sub txtX_Change()

  'only non-numeric, no less than 0, no greater than 159
  If Not IsNumeric(txtX.Text) Then
    'nothing is OK
    If Len(txtX.Text) <> 0 Then
      txtX.Text = "0"
    End If
  ElseIf Val(txtX.Text) < 0 Then
    txtX.Text = "0"
  ElseIf Val(txtX.Text) > 159 Then
    txtX.Text = "159"
  End If
  
End Sub

Private Sub txtX_KeyPress(KeyAscii As Integer)

  'only allow numbers, backspace and enter
  Select Case KeyAscii
  Case 8, 10, 13, 48 To 57
  Case Else
    KeyAscii = 0
  End Select
  
End Sub


Private Sub txtX_LostFocus()

  'if nothing, change it to zero
  If Len(txtX.Text) = 0 Then
    txtX.Text = "0"
  End If
End Sub

Private Sub txtY_Change()

  'only non-numeric, no less than 0, no greater than 159
  If Not IsNumeric(txtY.Text) Then
    'nothing is OK
    If Len(txtY.Text) <> 0 Then
      txtY.Text = "0"
    End If
  ElseIf Val(txtY.Text) < 0 Then
    txtY.Text = "0"
  ElseIf Val(txtY.Text) > 167 Then
    txtY.Text = "167"
  End If

End Sub

Private Sub txtY_KeyPress(KeyAscii As Integer)

  'only allow numbers, backspace and enter
  Select Case KeyAscii
  Case 8, 10, 13, 48 To 57
  Case Else
    KeyAscii = 0
  End Select

End Sub


Private Sub txtY_LostFocus()

  'if nothing, make it a zero
  If Len(txtY.Text) = 0 Then
    txtY.Text = "0"
  End If
End Sub

Private Sub udSeed_DownClick()

  Dim bCurVal As Byte
  'decrement txtSeed Value
  bCurVal = Val(txtSeed.Text)
  bCurVal = bCurVal - 1
  If bCurVal <= 0 Then
    bCurVal = 119
  End If
  txtSeed.Text = CStr(bCurVal)
End Sub

Private Sub udSeed_UpClick()
  
  Dim bCurVal As Byte
  'increment txtSeed Value
  bCurVal = Val(txtSeed.Text)
  bCurVal = bCurVal + 1
  If bCurVal >= 120 Then
    bCurVal = 1
  End If
  txtSeed.Text = CStr(bCurVal)
End Sub

Private Sub DrawPlotPoint()

  Dim PlotX As Byte, PlotY As Byte
  Dim intBCeil As Integer, intBFloor As Integer
  Dim X As Integer, Y As Integer
  Dim newpatt As Byte, PatternNum As Byte
  Dim rtn As Long
  
  'disable screen updating for the picture control until after point is plotted
  SendMessage Me.picPlot.hWnd, WM_SETREDRAW, 0, 0
  'stretch background into main window
  rtn = StretchBlt(Me.picPlot.hDC, 0&, 0&, 140&, 135&, Me.picBackground.hDC, 0&, 0&, 14&, 27&, SRCCOPY)
  
  PlotX = 7
  PlotY = 13
  PatternNum = NewPattern * 2 Or 1
  
  'calculate brush ceiling/floor values
  intBCeil = (PenSize + 1) \ 2
  intBFloor = PenSize \ 2
    
  'if brush is a circle
  If PenShape = psCircle Then
    For Y = PlotY - PenSize To PlotY + PenSize
      For X = PlotX - intBCeil To PlotX + intBFloor
        'if pixel is within circle shape,
        If (CircleData(PenSize ^ 2 + Y - PlotY + PenSize) \ 2 ^ (7 - (CLng(X) - PlotX + intBCeil)) And 1) Then
          'only draw if pattern bit is set
          newpatt = PatternNum \ 2
          If (PatternNum Mod 2) Then
            newpatt = newpatt Xor &HB8
          End If
          PatternNum = newpatt
          If (PatternNum And 3) = 2 Then
            picPlot.Line (10 * X, 5 * Y)-Step(9, 4), EGAColor(PenColor), BF
          End If
        End If
      Next X
    Next Y
  Else 'square
    For Y = PlotY - PenSize To PlotY + PenSize
      For X = PlotX - intBCeil To PlotX + intBFloor
        'only draw if pattern bit is set
        newpatt = PatternNum \ 2
        If (PatternNum Mod 2) Then
          newpatt = newpatt Xor &HB8
        End If
        PatternNum = newpatt
        If (PatternNum And 3) = 2 Then
          picPlot.Line (10 * X, 5 * Y)-Step(9, 4), EGAColor(PenColor), BF
        End If
      Next X
    Next Y
  End If
  
  'reenable screen updating
  SendMessage Me.picPlot.hWnd, WM_SETREDRAW, 1, 0
  picPlot.Refresh
End Sub

Private Sub InitializePlotData()
  'circle data used by the
  'brush drawing functions to paint
  'pictures
  CircleData(0) = &H80
  CircleData(1) = &HC0
  CircleData(2) = &HC0
  CircleData(3) = &HC0
  CircleData(4) = &H40
  CircleData(5) = &HE0
  CircleData(6) = &HE0
  CircleData(7) = &HE0
  CircleData(8) = &H40
  CircleData(9) = &H60
  CircleData(10) = &H60
  CircleData(11) = &HF0
  CircleData(12) = &HF0
  CircleData(13) = &HF0
  CircleData(14) = &H60
  CircleData(15) = &H60
  CircleData(16) = &H20
  CircleData(17) = &H70
  CircleData(18) = &HF8
  CircleData(19) = &HF8
  CircleData(20) = &HF8
  CircleData(21) = &HF8
  CircleData(22) = &HF8
  CircleData(23) = &H70
  CircleData(24) = &H20
  CircleData(25) = &H30
  CircleData(26) = &H78
  CircleData(27) = &H78
  CircleData(28) = &H78
  CircleData(29) = &HFC
  CircleData(30) = &HFC
  CircleData(31) = &HFC
  CircleData(32) = &H78
  CircleData(33) = &H78
  CircleData(34) = &H78
  CircleData(35) = &H30
  CircleData(36) = &H38
  CircleData(37) = &H7C
  CircleData(38) = &H7C
  CircleData(39) = &H7C
  CircleData(40) = &HFE
  CircleData(41) = &HFE
  CircleData(42) = &HFE
  CircleData(43) = &HFE
  CircleData(44) = &HFE
  CircleData(45) = &H7C
  CircleData(46) = &H7C
  CircleData(47) = &H7C
  CircleData(48) = &H38
  CircleData(49) = &H18
  CircleData(50) = &H3C
  CircleData(51) = &H7E
  CircleData(52) = &H7E
  CircleData(53) = &H7E
  CircleData(54) = &HFF
  CircleData(55) = &HFF
  CircleData(56) = &HFF
  CircleData(57) = &HFF
  CircleData(58) = &HFF
  CircleData(59) = &H7E
  CircleData(60) = &H7E
  CircleData(61) = &H7E
  CircleData(62) = &H3C
  CircleData(63) = &H18
End Sub


