VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form frmReserved 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Reserved Defines Editor"
   ClientHeight    =   4650
   ClientLeft      =   60
   ClientTop       =   330
   ClientWidth     =   5250
   Icon            =   "frmReserved.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   NegotiateMenus  =   0   'False
   ScaleHeight     =   4650
   ScaleWidth      =   5250
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.TextBox txtEditName 
      Appearance      =   0  'Flat
      BackColor       =   &H00E0E0E0&
      BorderStyle     =   0  'None
      Height          =   288
      Left            =   0
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   1200
      Visible         =   0   'False
      Width           =   840
   End
   Begin VB.PictureBox picSplit 
      BackColor       =   &H00C0C0C0&
      ForeColor       =   &H80000008&
      Height          =   4155
      Left            =   2310
      ScaleHeight     =   4155
      ScaleWidth      =   30
      TabIndex        =   5
      TabStop         =   0   'False
      Top             =   0
      Visible         =   0   'False
      Width           =   30
   End
   Begin MSFlexGridLib.MSFlexGrid fgReserved 
      Height          =   4155
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   5250
      _ExtentX        =   9260
      _ExtentY        =   7329
      _Version        =   393216
      Cols            =   3
      FixedCols       =   0
      AllowBigSelection=   0   'False
      ScrollTrack     =   -1  'True
      FocusRect       =   2
      ScrollBars      =   2
      MergeCells      =   2
      BorderStyle     =   0
   End
   Begin VB.PictureBox picButtons 
      Align           =   2  'Align Bottom
      Appearance      =   0  'Flat
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   495
      Left            =   0
      ScaleHeight     =   495
      ScaleWidth      =   5250
      TabIndex        =   6
      TabStop         =   0   'False
      Top             =   4155
      Width           =   5250
      Begin VB.CommandButton cmdReset 
         Caption         =   "Reset"
         Height          =   375
         Left            =   2070
         TabIndex        =   2
         Top             =   60
         Width           =   1110
      End
      Begin VB.CommandButton cmdCancel 
         Cancel          =   -1  'True
         Caption         =   "Cancel"
         Height          =   375
         Left            =   3690
         TabIndex        =   3
         Top             =   60
         Width           =   1110
      End
      Begin VB.CommandButton cmdSave 
         Caption         =   "Save"
         Height          =   375
         Left            =   450
         TabIndex        =   1
         Top             =   60
         Width           =   1110
      End
   End
End
Attribute VB_Name = "frmReserved"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Option Compare Text

  Private Const SplitWidth = 60 'in twips
  
  Public Canceled As Boolean
  
  Private SplitOffset As Single
  
  Private EditRow As Long
  Private EditDefine As TDefine
  
  Private CellIndentH As Single
  Private CellIndentV As Single
  
  Public PrevFGWndProc As Long
  
Private Sub LoadReservedNames()

  Dim i As Long, j As Long
  Dim tmpDefines() As TDefine
  Dim blnLoaded As Boolean
  
  On Error GoTo ErrHandler
  
  'clear grid
  With fgReserved
    .Clear
    'enable merging so we can have header rows
    .MergeCells = flexMergeRestrictRows
    .FillStyle = flexFillRepeat
    
    'set one row
    .Rows = 1
  
    'set up grid headings
    .TextMatrix(0, 1) = "Name"
    .TextMatrix(0, 2) = "Value"
    
    'load by group, not by data type!
    '(the returned array is actually a copy, not the actual array of defines)
    
    'RESERVED VARIABLES
    .AddItem vbTab & "Reserved Variables" & vbTab & "Reserved Variables"
    .MergeRow(1) = True
    .Row = 1
    .Col = 0
    .ColSel = 2
    .CellFontSize = 14
    .CellFontBold = True
    
    tmpDefines = LogicSourceSettings.ResDefByGrp(1) ' variables are group 1
    For i = 0 To UBound(tmpDefines)
      'add reserved variables
      .AddItem vbTab & tmpDefines(i).Name & vbTab & tmpDefines(i).Value
      .Row = .Rows - 1
      .Col = 1
      If .TextMatrix(.Row, 1) = tmpDefines(i).Default Then
        'black if default name
        .CellForeColor = vbBlack
      Else
        'red if changed
        .CellForeColor = vbRed
      End If
      .Col = 2
      .CellForeColor = RGB(127, 127, 127)
      'mark row with the group(high byte) and index(low byte)
      .RowData(.Row) = 256 + i
    Next i
    
    'add a blank row
    .AddItem vbTab & " " & vbTab & " "
    .MergeRow(.Rows - 1) = True
    
    'RESERVED FLAGS
    .AddItem vbTab & "Reserved Flags" & vbTab & "Reserved Flags"
    .MergeRow(30) = True
    .Row = 30
    .Col = 0
    .ColSel = 2
    .CellFontSize = Settings.EFontSize + 2 ' 14
    .CellFontBold = True
    
    tmpDefines = LogicSourceSettings.ResDefByGrp(2) ' flags are group 2
    For i = 0 To UBound(tmpDefines)
      'add reserved variables
      .AddItem vbTab & tmpDefines(i).Name & vbTab & tmpDefines(i).Value
      .Row = .Rows - 1
      .Col = 1
      If .TextMatrix(.Row, 1) = tmpDefines(i).Default Then
        'black if default name
        .CellForeColor = vbBlack
      Else
        'red if changed
        .CellForeColor = vbRed
      End If
      .Col = 2
      .CellForeColor = RGB(127, 127, 127)
      'mark row with the group(high byte) and index(low byte)
      .RowData(.Row) = 256 * 2 + i
    Next i
    
    'add a blank row
    .AddItem vbTab & " " & vbTab & " "
    .MergeRow(.Rows - 1) = True
    
    'EDGECODES
    .AddItem vbTab & "Edge Code Values" & vbTab & "Edge Code Values"
    .MergeRow(50) = True
    .Row = 50
    .Col = 0
    .ColSel = 2
    .CellFontSize = 14
    .CellFontBold = True
    tmpDefines = LogicSourceSettings.ResDefByGrp(3) ' edgecodes are group 3
    For i = 0 To UBound(tmpDefines)
      'add reserved variables
      .AddItem vbTab & tmpDefines(i).Name & vbTab & tmpDefines(i).Value
      .Row = .Rows - 1
      .Col = 1
      If .TextMatrix(.Row, 1) = tmpDefines(i).Default Then
        'black if default name
        .CellForeColor = vbBlack
      Else
        'red if changed
        .CellForeColor = vbRed
      End If
      .Col = 2
      .CellForeColor = RGB(127, 127, 127)
      'mark row with the group(high byte) and index(low byte)
      .RowData(.Row) = 256 * 3 + i
    Next i
    
    'add a blank row
    .AddItem vbTab & " " & vbTab & " "
    .MergeRow(.Rows - 1) = True
    
    'OBJ DIRECTION
    .AddItem vbTab & "Object Direction Values" & vbTab & "Object Direction Values"
    .MergeRow(57) = True
    .Row = 57
    .Col = 0
    .ColSel = 2
    .CellFontSize = 14
    .CellFontBold = True
    tmpDefines = LogicSourceSettings.ResDefByGrp(4) ' objdirs are group 4
    For i = 0 To UBound(tmpDefines)
      'add reserved variables
      .AddItem vbTab & tmpDefines(i).Name & vbTab & tmpDefines(i).Value
      .Row = .Rows - 1
      .Col = 1
      If .TextMatrix(.Row, 1) = tmpDefines(i).Default Then
        'black if default name
        .CellForeColor = vbBlack
      Else
        'red if changed
        .CellForeColor = vbRed
      End If
      .Col = 2
      .CellForeColor = RGB(127, 127, 127)
      'mark row with the group(high byte) and index(low byte)
      .RowData(.Row) = 256 * 4 + i
    Next i
    
    'add a blank row
    .AddItem vbTab & " " & vbTab & " "
    .MergeRow(.Rows - 1) = True
    
    'VIDEO MODES
    .AddItem vbTab & "Video Type Values" & vbTab & "Video Type Values"
    .MergeRow(68) = True
    .Row = 68
    .Col = 0
    .ColSel = 2
    .CellFontSize = 14
    .CellFontBold = True
    tmpDefines = LogicSourceSettings.ResDefByGrp(5) ' vidmodes are group 5
    For i = 0 To UBound(tmpDefines)
      'add reserved variables
      .AddItem vbTab & tmpDefines(i).Name & vbTab & tmpDefines(i).Value
      .Row = .Rows - 1
      .Col = 1
      If .TextMatrix(.Row, 1) = tmpDefines(i).Default Then
        'black if default name
        .CellForeColor = vbBlack
      Else
        'red if changed
        .CellForeColor = vbRed
      End If
      'mark row with the default index
      .Col = 2
      .CellForeColor = RGB(127, 127, 127)
      'mark row with the group(high byte) and index(low byte)
      .RowData(.Row) = 256 * 5 + i
    Next i
    
    'add a blank row
    .AddItem vbTab & " " & vbTab & " "
    .MergeRow(.Rows - 1) = True
    
    'COMPUTER TYPES
    .AddItem vbTab & "Computer Type Values" & vbTab & "Computer Type Values"
    .MergeRow(75) = True
    .Row = 75
    .Col = 0
    .ColSel = 2
    .CellFontSize = 14
    .CellFontBold = True
    tmpDefines = LogicSourceSettings.ResDefByGrp(6) ' pctypes are group 6
    For i = 0 To UBound(tmpDefines)
      'add reserved variables
      .AddItem vbTab & tmpDefines(i).Name & vbTab & tmpDefines(i).Value
      .Row = .Rows - 1
      .Col = 1
      If .TextMatrix(.Row, 1) = tmpDefines(i).Default Then
        'black if default name
        .CellForeColor = vbBlack
      Else
        'red if changed
        .CellForeColor = vbRed
      End If
      .Col = 2
      .CellForeColor = RGB(127, 127, 127)
      'mark row with the group(high byte) and index(low byte)
      .RowData(.Row) = 256 * 6 + i
    Next i
    
    'add a blank row
    .AddItem vbTab & " " & vbTab & " "
    .MergeRow(.Rows - 1) = True
    
    'COLORS
    .AddItem vbTab & "Colors" & vbTab & "Colors"
    .MergeRow(86) = True
    .Row = 86
    .Col = 0
    .ColSel = 2
    .CellFontSize = 14
    .CellFontBold = True
    
    tmpDefines = LogicSourceSettings.ResDefByGrp(7)
    For i = 0 To UBound(tmpDefines)
      'add reserved variables
      .AddItem vbTab & tmpDefines(i).Name & vbTab & tmpDefines(i).Value
      .Row = .Rows - 1
      .Col = 1
      If .TextMatrix(.Row, 1) = tmpDefines(i).Default Then
        'black if default name
        .CellForeColor = vbBlack
      Else
        'red if changed
        .CellForeColor = vbRed
      End If
      'mark row with the default index
      .Col = 2
      .CellForeColor = RGB(127, 127, 127)
      'mark row with the group(high byte) and index(low byte)
      .RowData(.Row) = 256 * 7 + i
    Next i

    'add a blank row
    .AddItem vbTab & " " & vbTab & " "
    .MergeRow(.Rows - 1) = True
    
    'OTHER RESERVED DEFINES
    .AddItem vbTab & "Other Reserved Defines" & vbTab & "Other Reserved Defines"
    .MergeRow(104) = True
    .Row = 104
    .Col = 0
    .ColSel = 2
    .CellFontSize = 14
    .CellFontBold = True
    tmpDefines = LogicSourceSettings.ResDefByGrp(8) ' others are group 8
    For i = 0 To UBound(tmpDefines)
      'add reserved variables (values added separately for 1-4)
      .AddItem vbTab & tmpDefines(i).Name & vbTab & tmpDefines(i).Value
      .Row = .Rows - 1
      .Col = 1
      If tmpDefines(i).Name = tmpDefines(i).Default Then
        'black if default name
        .CellForeColor = vbBlack
      Else
        'red if changed
        .CellForeColor = vbRed
      End If
      'mark row with the default index
      .Col = 2
      .CellForeColor = RGB(127, 127, 127)
      'mark row with the group(high byte) and index(low byte)
      .RowData(.Row) = 256 * 8 + i
    Next i

    'add a blank row
    .AddItem vbTab & " " & vbTab & " "
    .MergeRow(.Rows - 1) = True
    
    'add values for game-dependent reserved names
    .TextMatrix(106, 2) = Chr(34) & GameVersion & Chr(34)
    .TextMatrix(107, 2) = Chr(34) & GameAbout & Chr(34)
    .TextMatrix(108, 2) = Chr(34) & GameID & Chr(34)
    blnLoaded = InventoryObjects.Loaded
    If Not blnLoaded Then
      InventoryObjects.Load
    End If
    .TextMatrix(109, 2) = InventoryObjects.Count
    If Not blnLoaded Then
      InventoryObjects.Unload
    End If
    
    'select first item
    .Col = 1
    .Row = 2
  End With
  
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Sub MouseWheel(ByVal MouseKeys As Long, ByVal Rotation As Long, ByVal xPos As Long, ByVal yPos As Long)
  
  Dim NewValue As Long
  Dim Lstep As Single
  
  On Error Resume Next
  
  'scroll whichever grid is visible
  With fgReserved
    Lstep = 4
    If Rotation > 0 Then
      NewValue = .TopRow - Lstep
      If NewValue < 1 Then
        NewValue = 1
      End If
    Else
      NewValue = .TopRow + Lstep
      If NewValue > .Rows - 1 Then
        NewValue = .Rows - 1
      End If
    End If
    .TopRow = NewValue
  End With
End Sub


Public Sub InitFonts()

  On Error Resume Next
  
  fgReserved.Font.Name = Settings.EFontName
  fgReserved.Font.size = Settings.EFontSize
  fgReserved.Refresh
  
  txtEditName.Font.Name = Settings.EFontName
  txtEditName.Font.size = Settings.EFontSize
End Sub
Public Sub MenuClickCopy()

  'if editing
  If txtEditName.Visible Then
    Exit Sub
  End If
  
  'copies the selected cell or the selected rows to the clipboard
  
  Dim i As Long, strData As String
  Dim TopRow As Long, BtmRow As Long
  
  With fgReserved
    If .SelectionMode = flexSelectionByRow Then
      'select all the rows
      'ensure starting at top
      If .Row < .RowSel Then
        TopRow = .Row
        BtmRow = .RowSel
      Else
        TopRow = .RowSel
        BtmRow = .Row
      End If
      
      'add first row
      strData = fgReserved.TextMatrix(TopRow, 1) & vbTab & fgReserved.TextMatrix(TopRow, 2)
      'add remaining rows, with carriage return separator
      For i = TopRow + 1 To BtmRow
        'add text
        strData = strData & vbCr & fgReserved.TextMatrix(i, 1) & vbTab & fgReserved.TextMatrix(i, 2)
      Next i
    Else
      'select just this cell
      strData = fgReserved.TextMatrix(.Row, .Col)
    End If
  
    'put on clipboard
    Clipboard.SetText strData
    
    'enable pasting, if selection contained entire row
    frmMDIMain.mnuEPaste.Enabled = (.SelectionMode = flexSelectionByRow)
  End With
End Sub


Public Sub MenuClickHelp()
  
  On Error GoTo ErrHandler
  HtmlHelpS HelpParent, WinAGIHelp, HH_DISPLAY_TOPIC, "htm\winagi\reservednames.htm#editor"
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Public Sub MenuClickPaste()

  'no paste function for this form
  
End Sub
Private Function ValidateName(NewDefName As String) As Long
  'validates if a define name is agreeable or not
  'returns zero if ok;
  'error Value if not
  
  '1 = no name
  '2 = name is numeric
  '3 = name is command
  '4 = name is test command
  '5 = name is a compiler keyword
  '6 = name is an argument marker
  '7 = name is already used as a reserved define name '''globally defined
'''  '8 = name is reserved variable name
'''  '9 = name is reserved flag name
'''  '10 = name is reserved number constant
'''  '11 = name is reserved object constant
'''  '12 = name is reserved message constant
  '13 = name contains improper character
    
  Dim i As Long
  Dim tmpDefines() As TDefine
  
  On Error GoTo ErrHandler
  
  'if no name,
  If LenB(NewDefName) = 0 Then
    ValidateName = 1
    Exit Function
  End If
  
  'name cant be numeric
  If IsNumeric(NewDefName) Then
    ValidateName = 2
    Exit Function
  End If
  
  'check against regular commands
  For i = 0 To Commands.Count
    If NewDefName = Commands(i).Name Then
      ValidateName = 3
      Exit Function
    End If
  Next i
  
  'check against test commands
  For i = 0 To TestCommands.Count
    If NewDefName = TestCommands(i).Name Then
      ValidateName = 4
      Exit Function
    End If
  Next i
  
  'check against keywords
  If (NewDefName = "if") Or (NewDefName = "else") Or (NewDefName = "goto") Then
    ValidateName = 5
    Exit Function
  End If
      
  'check against variable/flag/controller/string/message names
  Select Case Asc(LCase$(NewDefName))
  '     v    f    m    o    i    s    w    c
  Case 118, 102, 109, 111, 105, 115, 119, 99
    If IsNumeric(Right$(NewDefName, Len(NewDefName) - 1)) Then
      ValidateName = 6
      Exit Function
    End If
  End Select
  
'''  If LogicSourceSettings.UseReservedNames Then
'''    'check against reserved names
'''    tmpDefines = LogicSourceSettings.ReservedDefines(atVar)
'''    For i = 0 To UBound(tmpDefines)
'''      If NewDefName = tmpDefines(i).Name Then
'''        ValidateName = 8
'''        Exit Function
'''      End If
'''    Next i
'''    tmpDefines = LogicSourceSettings.ReservedDefines(atFlag)
'''    For i = 0 To UBound(tmpDefines)
'''      If NewDefName = tmpDefines(i).Name Then
'''        ValidateName = 9
'''        Exit Function
'''      End If
'''    Next i
'''    tmpDefines = LogicSourceSettings.ReservedDefines(atNum)
'''    For i = 0 To UBound(tmpDefines)
'''      If NewDefName = tmpDefines(i).Name Then
'''        ValidateName = 10
'''        Exit Function
'''      End If
'''    Next i
'''    tmpDefines = LogicSourceSettings.ReservedDefines(atSObj)
'''    For i = 0 To UBound(tmpDefines)
'''      If NewDefName = tmpDefines(i).Name Then
'''        ValidateName = 11
'''        Exit Function
'''      End If
'''    Next i
'''    tmpDefines = LogicSourceSettings.ReservedDefines(atDefStr)
'''    For i = 0 To UBound(tmpDefines)
'''      If NewDefName = tmpDefines(i).Name Then
'''        ValidateName = 12
'''        Exit Function
'''      End If
'''    Next i
'''  End If
  
  'check against existing globals (skip editrow)
'''  '(do this check after checking reserved because reserved defines may be displayed
  For i = 1 To fgReserved.Rows - 1
    If (NewDefName = fgReserved.TextMatrix(i, 1)) And i <> EditRow Then
      ValidateName = 7
      Exit Function
    End If
  Next i
  
  'check name against improper character list
  For i = 1 To Len(NewDefName)
    Select Case Asc(Mid$(NewDefName, i, 1))
    '!"#$%&'()*+,-/:;<=>?@[\]^`{|}~
    Case 32 To 45, 47, 58 To 64, 91 To 94, 96, Is >= 123
      ValidateName = 13
      Exit Function
    End Select
  Next i
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function
Private Function ValidateInput() As Boolean
  
  Dim rtn As Long, msgRtn As VbMsgBoxResult
  Dim strText As String, blnBlank As Boolean
  Dim strErrMsg As String, blnOverride As Boolean
  Dim blnNoWarn As Boolean, lngRow As Long, lngCol As Long
  
  'checks input for new name
  On Error GoTo ErrHandler
  
  'if no change made, that's OK
  '(name in textbox matches previous name)
  If txtEditName.Text = EditDefine.Name Then
    'no change made; return success
    ValidateInput = True
    Exit Function
  End If
  
  'if blank, restore default
  If Len(txtEditName.Text) = 0 Then
    strText = LogicSourceSettings.ResDefByGrp(fgReserved.RowData(EditRow) \ 256)(fgReserved.RowData(EditRow) Mod 256).Default
  Else
    'make local copy of name
    strText = txtEditName.Text
  End If
  
  'validate the define name
  rtn = ValidateName(strText)
  
  'if return code indicates error
  If rtn <> 0 Then
    Select Case rtn
    Case 1 ' no name
      strErrMsg = "Define name cannot be blank."
      
    Case 2 ' name is numeric
      strErrMsg = "Define names cannot be numeric."
      
    Case 3 ' name is command
      strErrMsg = ChrW$(39) & strText & "' is an AGI command, and cannot be redefined"
      
    Case 4 ' name is test command
      strErrMsg = ChrW$(39) & strText & "' is an AGI test command, and cannot be redefined"
      
    Case 5 ' name is a compiler keyword
      strErrMsg = ChrW$(39) & strText & "' is a compiler reserved word, and cannot be redefined"
      
    Case 6 ' name is an argument marker
      strErrMsg = "invalid define statement - define names cannot be argument markers"
      
    Case 7 ' name is already reserved
      strErrMsg = ChrW$(39) & strText & "' is already in use as a reserved define"
      
    Case 13 ' name contains improper character
      strErrMsg = "Invalid character in define name: !" & QUOTECHAR & "#$%&'()*+,-/:;<=>?@[\]^`{|}~ and spaces are not allowed"
            
    End Select
  End If
  
  'if still an error code
  If rtn <> 0 Then
    'force back to edit row
    fgReserved.Row = EditRow
    
    'show msgbox
    MsgBox strErrMsg, vbInformation + vbOKOnly, "Edit Reserved Defines Error"
    Exit Function
  Else
    'save current row/col;
    With fgReserved
      lngRow = .Row
      lngCol = .Col
      
      'put the text back into grid
      .TextMatrix(EditRow, 1) = strText
      .Row = EditRow
      .Col = 1
      If strText = LogicSourceSettings.ResDefByGrp(fgReserved.RowData(EditRow) \ 256)(fgReserved.RowData(EditRow) Mod 256).Default Then
        'black if default name
        .CellForeColor = vbBlack
      Else
        'red if changed
        .CellForeColor = vbRed
      End If
      'restore row/col
      .Row = lngRow
      .Col = lngCol
    End With
  End If
  
  'valid;
  ValidateInput = True
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Private Sub cmdCancel_Click()

  'if esc is pressed, we go here regardless of what's happening;
  'so we need to check for editing - if that's the case, we
  'don't really want to exit, we just want to stop editing
  If txtEditName.Visible Then
    'stop editing (by hiding the text box
    txtEditName.Visible = False
    fgReserved.SetFocus
    Exit Sub
  End If
  
  'set cancel flag
  Me.Canceled = True
  Me.Hide
End Sub

Private Sub cmdReset_Click()

  'restores all reserved defines to their original value
  LogicSourceSettings.ResetResDefines
  
  'reload to reflect the change
  Me.fgReserved.Visible = False
  LoadReservedNames
  Me.fgReserved.Visible = True
End Sub

Private Sub cmdSave_Click()

  'save the results!
  Dim i As Long
  
  On Error Resume Next
  
  'variables
  For i = 0 To 26
    LogicSourceSettings.ResDef(1, i) = fgReserved.TextMatrix(i + 2, 1)
  Next i
  
  'flags
  For i = 0 To 17
    LogicSourceSettings.ResDef(2, i) = fgReserved.TextMatrix(i + 31, 1)
  Next i
  
  'edgecodes
  For i = 0 To 4
    LogicSourceSettings.ResDef(3, i) = fgReserved.TextMatrix(i + 51, 1)
  Next i
  
  'directions
  For i = 0 To 8
    LogicSourceSettings.ResDef(4, i) = fgReserved.TextMatrix(i + 58, 1)
  Next i
  
  'vidmodes
  For i = 0 To 4
    LogicSourceSettings.ResDef(5, i) = fgReserved.TextMatrix(i + 69, 1)
  Next i
  
  'comptypes
  For i = 0 To 8
    LogicSourceSettings.ResDef(6, i) = fgReserved.TextMatrix(i + 76, 1)
  Next i
  
  'others
  For i = 0 To 5
    LogicSourceSettings.ResDef(7, i) = fgReserved.TextMatrix(i + 87, 1)
  Next i
  
  'and save them
  SaveResDefOverrides
  
  Me.Hide
End Sub


Private Sub fgReserved_DblClick()

  On Error GoTo ErrHandler
  
  'if on a blank or header line (can easily tell by checking rowdata)
  If fgReserved.Row <> 2 And fgReserved.RowData(fgReserved.Row) = 0 Then
    Exit Sub
  End If
  
  'force to first column
  If fgReserved.Col <> 1 Then
    fgReserved.Col = 1
  End If
  
  'save row being edited
  EditRow = fgReserved.Row
  
  'save current define in case of cancel
  EditDefine.Name = fgReserved.TextMatrix(EditRow, 1)

  'begin edit
    With txtEditName
      .Move fgReserved.CellLeft + CellIndentH, fgReserved.CellTop + fgReserved.Top + CellIndentV, fgReserved.CellWidth - CellIndentH, fgReserved.CellHeight - CellIndentV
      .Text = fgReserved.Text
      .Visible = True
      'select all
      .SelStart = 0
      .SelLength = Len(.Text)
      .SetFocus
    End With
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub fgReserved_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

  Dim tmpRow As Long, tmpCol As Long
  Dim TopRow As Long, BtmRow As Long
  
  On Error GoTo ErrHandler

  If txtEditName.Visible Then
    Exit Sub
  End If

  With fgReserved
    tmpCol = .MouseCol
    tmpRow = .MouseRow

    'if right click
    If Button = vbRightButton Then
      'determine top/bottom rows
      If .Row < .RowSel Then
        TopRow = .Row
        BtmRow = .RowSel
      Else
        TopRow = .RowSel
        BtmRow = .Row
      End If

      'if row and column are NOT within selected area
      If tmpRow < TopRow Or tmpRow > BtmRow Then
        'make new selection
        'check for selection of entire row
        If X < ScreenTWIPSX * 12 Then
          'select entire row
          .Col = 0
          .Row = tmpRow
          .ColSel = 2
          .SelectionMode = flexSelectionByRow
          .Highlight = flexHighlightAlways
          .MergeCells = flexMergeNever
        Else
          'select freely
          .Col = tmpCol
          .Row = tmpRow
          .SelectionMode = flexSelectionFree
          .Highlight = flexHighlightNever
          .MergeCells = flexMergeRestrictAll
        End If
      End If

      'done with right click activities
      Exit Sub
    End If

    'check for selection of entire row
    If X < ScreenTWIPSX * 12 Then
      'select entire row
      .Col = 0
      .SelectionMode = flexSelectionByRow
      .Highlight = flexHighlightAlways
      .MergeCells = flexMergeNever
      .ColSel = 2
    
    'check for cursor in range of splitting
    ElseIf (X > .ColWidth(1) - SplitWidth / 2) And (X < .ColWidth(1) + SplitWidth / 2) Then
      'start splitting
      picSplit.Visible = True
      SplitOffset = .ColWidth(1) - X
      picSplit.Left = X + SplitOffset
      Exit Sub

    'check for left-click on header
    ElseIf tmpRow = 0 Then
      'ignore
      Exit Sub
    Else
      'select freely
      If tmpCol <> -1 Then
        .Col = tmpCol
      Else
        .Col = 1
      End If
      .Row = tmpRow
      .SelectionMode = flexSelectionFree
      .Highlight = flexHighlightNever
      '.MergeCells = flexMergeRestrictAll
    End If
  End With
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Private Sub fgReserved_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

  Dim Pos As Single

  On Error GoTo ErrHandler
  
  'if editing,
  If txtEditName.Visible Then
    Exit Sub
  End If

  'if editing,
  If txtEditName.Visible Then
    Exit Sub
  End If

  'if splitting
  If picSplit.Visible Then
    Pos = (X + SplitOffset)
    'validate it
    If Pos < fgReserved.Width * 0.2 Then
      Pos = fgReserved.Width * 0.2
    ElseIf Pos > fgReserved.Width * 0.8 Then
      Pos = fgReserved.Width * 0.8
    End If
    'move splitter
    picSplit.Left = Pos

  'elseif within splitzone
  ElseIf (X > fgReserved.ColWidth(1) - SplitWidth / 2) And (X < fgReserved.ColWidth(1) + SplitWidth / 2) Then
    'show split cursor
    fgReserved.MousePointer = flexSizeEW

  'elseif on left edge,
  ElseIf X < 12 * ScreenTWIPSX Then
    'set cursor to row selector
    fgReserved.MousePointer = flexCustom
    Set fgReserved.MouseIcon = LoadResPicture("EGC_SELROW", vbResCursor)
  Else
    'set cursor to normal
    fgReserved.MousePointer = flexDefault
  End If
  
  'if left button is down, begin dragging
  If Button = vbLeftButton Then
    If Not DroppingGlobal Then
      'if something selected,
      If fgReserved.Col = 1 And fgReserved.Row > 1 And fgReserved.RowSel = fgReserved.Row Then
        fgReserved.OLEDrag
      End If
    End If
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Private Sub fgReserved_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

  Dim Pos As Single

  On Error GoTo ErrHandler
  
  'if splitting
  If picSplit.Visible Then
    'stop splitting
    picSplit.Visible = False

    With fgReserved
      'validate position
      Pos = (X + SplitOffset)
      If Pos < 0.2 * .Width Then
        Pos = 0.2 * .Width
      ElseIf Pos > 0.8 * .Width Then
        Pos = 0.8 * .Width
      End If
  
      'reset columns
      .ColWidth(1) = Pos
  
      'take into account scrollbar
      .ColWidth(2) = .Width - .ColWidth(1) - 17 * ScreenTWIPSX
    End With
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Private Sub fgReserved_OLECompleteDrag(Effect As Long)

  'reset dragging flag
  DroppingGlobal = False
End Sub

Private Sub fgReserved_OLEStartDrag(Data As MSFlexGridLib.DataObject, AllowedEffects As Long)

  On Error GoTo ErrHandler
  
  'wtf? for some reason, in the middle of a mouse down/mouse up
  'operation, the drag event fires; this effs up the splitting operation
  
  If picSplit.Visible Then
    'cancel drag/drop, so split action works as desired
    AllowedEffects = vbDropEffectNone
    Exit Sub
  End If
  
  'set global drop flag (so logics (or other text receivers) know
  'when an object is being dropped
  DroppingGlobal = True
  
  'set allowed effects to copy only
  AllowedEffects = vbDropEffectCopy
  Data.SetData fgReserved.TextMatrix(fgReserved.Row, 1), vbCFText
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  'detect and respond to keyboard shortcuts
  
  'always check for help key
  If KeyCode = vbKeyF1 And Shift = 0 Then
    MenuClickHelp
    KeyCode = 0
    Exit Sub
  End If

  'if editing something
  If txtEditName.Visible Then
    Exit Sub
  End If
End Sub

Private Sub Form_Load()

  On Error GoTo ErrHandler

  With fgReserved
    'hide column 0
    .ColWidth(0) = 0
    
    'set font
    InitFonts
  
    'set initial column width to 2/3 of grid width
    .ColWidth(1) = .Width * 2 / 3
    .ColWidth(2) = .Width - .ColWidth(1) - 17 * ScreenTWIPSX
    
    'set indent Value
    CellIndentH = ScreenTWIPSX * 4
    CellIndentV = ScreenTWIPSY * 1
  
    'set both columns to leftcenter alignment
    .ColAlignment(1) = flexAlignLeftCenter
    .ColAlignment(2) = flexAlignLeftCenter
    
    'load reserved names
    LoadReservedNames
  
#If DEBUGMODE <> 1 Then
    'subclass the flexgrid
    PrevFGWndProc = SetWindowLong(.hWnd, GWL_WNDPROC, AddressOf ScrollWndProc)
#End If
  End With
  
  'make sure canceled is false
  Me.Canceled = False
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

  'if right button
  If Button = vbRightButton Then
    'if edit menu is enabled
    If frmMDIMain.mnuEdit.Enabled Then
      'need doevents so form activation occurs BEFORE popup
      'otherwise, errors will be generated because of menu
      'adjustments that are made in the form_activate event
      SafeDoEvents
      'show edit menu
      PopupMenu frmMDIMain.mnuEdit
    End If
  End If
End Sub

Private Sub Form_Unload(Cancel As Integer)

#If DEBUGMODE <> 1 Then
  'release subclass hook to flexgrid
  SetWindowLong Me.fgReserved.hWnd, GWL_WNDPROC, PrevFGWndProc
#End If 'need to check if this is last form
End Sub

Private Sub txtEditName_KeyPress(KeyAscii As Integer)
  
  On Error GoTo ErrHandler
  
  Select Case KeyAscii
  Case 9, 10, 13 'enter or tab
    'if result is valid,
    If ValidateInput() Then
      'hide the box
      txtEditName.Visible = False
      fgReserved.SetFocus
    Else
      'need to force focus (might a a tab thing?)
      txtEditName.SetFocus
    End If
    
    'ignore key
    KeyAscii = 0
    
  Case 27 'escape
    'hide textbox without saving text
    txtEditName.Visible = False
    
    'ignore key
    KeyAscii = 0
  End Select
  
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Private Sub txtEditName_Validate(Cancel As Boolean)
  
  'this will handle cases where user tries to 'click' on something,
  
  On Error GoTo ErrHandler
  If Not txtEditName.Visible Then Exit Sub
  
  'if OK, hide the text box
  If ValidateInput() Then
    txtEditName.Visible = False
  Else
  'if not OK, cancel
    Cancel = True
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

