VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form frmTools 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Customize Tools Menu"
   ClientHeight    =   2895
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   7155
   Icon            =   "frmTools.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2895
   ScaleWidth      =   7155
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdBrowse 
      Caption         =   ""
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   3360
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   480
      Visible         =   0   'False
      Width           =   270
   End
   Begin VB.TextBox txtEdit 
      Appearance      =   0  'Flat
      BorderStyle     =   0  'None
      Height          =   288
      Left            =   480
      MultiLine       =   -1  'True
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   960
      Visible         =   0   'False
      Width           =   3690
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   2265
      TabIndex        =   1
      Top             =   2400
      Width           =   1215
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   375
      Left            =   3705
      TabIndex        =   2
      Top             =   2400
      Width           =   1215
   End
   Begin MSFlexGridLib.MSFlexGrid fgTools 
      Height          =   2265
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   7185
      _ExtentX        =   12674
      _ExtentY        =   3995
      _Version        =   393216
      Rows            =   7
      Cols            =   3
      FixedCols       =   0
      AllowBigSelection=   0   'False
      HighLight       =   0
      ScrollBars      =   0
      BorderStyle     =   0
   End
End
Attribute VB_Name = "frmTools"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

  Private CellIndentH As Single
  Private CellIndentV As Single

  Private EditRow As Long, EditCol As Long
  Private blnTab As Boolean
  
  Private Dragging As Boolean
  Private StartRow As Long

Public Sub Activate()
  'bridge method to call the form's Activate event method
  
  'not used for this form
  'Form_Activate
End Sub

Private Sub cmdCancel_Click()

  'dont save and close
  Unload Me
End Sub

Private Sub cmdCancel_GotFocus()

  'if editing
  If txtEdit.Visible Then
    txtEdit.Visible = False
    cmdBrowse.Visible = False
  End If
End Sub


Private Sub cmdBrowse_Click()
  
  Dim strCmd As String
  
  On Error GoTo ErrHandler
  
  'get target command
  With MainDialog
    .Flags = cdlOFNHideReadOnly
    .DialogTitle = "Select Command"
    .FileName = fgTools.TextMatrix(EditRow, 2)
    .Filter = "Programs (*.exe)|*.exe|URLs (*.url)|*.url|All Files (*.*)|*.*"
    .ShowOpen
    .InitDir = ProgramDir
  
    'use selected file as target
    txtEdit.Text = .FileName
  End With
 
  'set focus to grid
  fgTools.SetFocus
Exit Sub

ErrHandler:
  'if user canceled the dialogbox,
  If Err.Number = cdlCancel Then
    Exit Sub
  End If

  Debug.Assert False
  Resume Next
End Sub

Private Sub fgTools_DblClick()

  On Error GoTo ErrHandler
  
  'reset dragging status
  Dragging = False
  
  'save row and column being edited
  EditRow = fgTools.Row
  EditCol = fgTools.Col
  
  'begin edit
  txtEdit.Move fgTools.CellLeft + CellIndentH, fgTools.CellTop + fgTools.Top + CellIndentV, fgTools.CellWidth - CellIndentH, fgTools.CellHeight - CellIndentV
  txtEdit.Text = fgTools.Text
  txtEdit.Visible = True
  txtEdit.SetFocus
  
  'if editing column 2
  If EditCol = 2 Then
    'show browse button as well
    cmdBrowse.Move fgTools.CellLeft + fgTools.ColWidth(2) - cmdBrowse.Width - 3 * ScreenTWIPSX, fgTools.CellTop + fgTools.Top + CellIndentV, cmdBrowse.Width, cmdBrowse.Height
    txtEdit.Width = txtEdit.Width - cmdBrowse.Width
    cmdBrowse.Visible = True
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub fgTools_GotFocus()

  On Error GoTo ErrHandler
  
  'if editing
  If txtEdit.Visible Then
    'if tab flag NOT set
    If Not blnTab Then
      'send tabkey to the textbox keypress
      txtEdit_KeyPress 9
      'if still visible
      If txtEdit.Visible Then
        txtEdit.SetFocus
      End If
    Else
      txtEdit.Visible = False
      cmdBrowse.Visible = False
    End If
    
  End If
  'always reset blntab
  blnTab = False
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Private Sub fgTools_KeyDown(KeyCode As Integer, Shift As Integer)

  On Error GoTo ErrHandler
  
  If Shift = 0 Then
    Select Case KeyCode
    Case 13  'enter
      'edit it
      fgTools_DblClick
    Case 46  'delete
      'erase this row
      fgTools.TextMatrix(fgTools.Row, 1) = vbNullString
      fgTools.TextMatrix(fgTools.Row, 2) = vbNullString
      
    End Select
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Private Sub fgTools_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

  Dim tmpRow As Long, tmpCol As Long
  
  On Error GoTo ErrHandler
  'if editing
  If txtEdit.Visible Then
    'f***ing hack to trap the damn tab key
    blnTab = True
    Exit Sub
  End If
    
  'dont select left most column
  If fgTools.Col = 0 Then
    fgTools.Col = 1
  End If
  
  
  'if left button, start dragging
  If Button = vbLeftButton Then
    Dragging = True
    StartRow = fgTools.MouseRow
  End If
  
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Private Sub fgTools_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

  If Dragging Then
    If Y < fgTools.RowPos(1) Or Y > fgTools.Height Then
      fgTools.MousePointer = flexNoDrop
      Me.MousePointer = vbNoDrop
    Else
      fgTools.Row = fgTools.MouseRow
      If fgTools.Row = StartRow Then
        fgTools.MousePointer = flexDefault
      Else
        fgTools.MousePointer = flexSizeNS
      End If
      Me.MousePointer = vbDefault
    End If
  End If
  
End Sub

Private Sub fgTools_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

  'if droprow is different, make a move
  Dim tgtRow As Long
  Dim i As Long, j As Long
  Dim tmpCaption As String, tmpTarget As String
  
  On Error GoTo ErrHandler
  
  'always restore cursors
  fgTools.MousePointer = flexDefault
  Me.MousePointer = vbDefault
  
  If Not Dragging Then
    Exit Sub
  End If
  
  Dragging = False
  
  'exit if not valid target
  If Y < fgTools.RowPos(1) Or Y > fgTools.Height Then
    Exit Sub
  Else
    tgtRow = fgTools.MouseRow
    If StartRow <> tgtRow Then
      With fgTools
        tmpCaption = .TextMatrix(StartRow, 1)
        tmpTarget = .TextMatrix(StartRow, 2)
        'which way?
        If tgtRow > StartRow Then
          For i = StartRow To tgtRow - 1
            .TextMatrix(i, 1) = .TextMatrix(i + 1, 1)
            .TextMatrix(i, 2) = .TextMatrix(i + 1, 2)
          Next i
        Else
          For i = StartRow To tgtRow + 1 Step -1
            .TextMatrix(i, 1) = .TextMatrix(i - 1, 1)
            .TextMatrix(i, 2) = .TextMatrix(i - 1, 2)
          Next i
        End If
        .TextMatrix(tgtRow, 1) = tmpCaption
        .TextMatrix(tgtRow, 2) = tmpTarget
      End With
    End If
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

  'check for help key
  If Shift = 0 And KeyCode = vbKeyF1 Then
    HtmlHelpS HelpParent, WinAGIHelp, HH_DISPLAY_TOPIC, "htm\winagi\customtools.htm"
    KeyCode = 0
  End If
End Sub

Private Sub Form_Load()

  Dim i As Long
  
  On Error GoTo ErrHandler
  
  'set font
  With fgTools
    Me.Font.Name = Settings.EFontName
    Me.Font.size = Settings.EFontSize
    .Font.Name = Settings.EFontName
    .Font.size = Settings.EFontSize
    txtEdit.Font.Name = Settings.EFontName
    txtEdit.Font.size = Settings.EFontSize
    
    'set indent Value
    CellIndentH = ScreenTWIPSX * 4
    CellIndentV = ScreenTWIPSY * 1
    
    'set both columns to leftcenter alignment
    .ColAlignment(1) = flexAlignLeftCenter
    .ColAlignment(2) = flexAlignLeftCenter
    
    'set column widths
    .ColWidth(0) = Me.TextWidth("1.") * 2
    
    .ColWidth(1) = (.Width - .ColWidth(0)) / 3
    .ColWidth(2) = .ColWidth(1) * 2
    
    'set form height so all rows are visible
    .Height = 7 * .RowHeight(0)
    Me.Height = (Me.Height - Me.ScaleHeight) + .Height + 2 * cmdOK.Height
    cmdOK.Top = .Height + cmdOK.Height / 2
    cmdCancel.Top = cmdOK.Top
    
    'set browse button so it fits inside a row
    cmdBrowse.Height = .RowHeight(0) - ScreenTWIPSY
    
    'add captions
    .TextMatrix(0, 1) = "Caption"
    .TextMatrix(0, 2) = "Target"
    For i = 1 To 6
      .TextMatrix(i, 0) = CStr(i) & "."
    Next i
    
    'get tools info from registry
    For i = 1 To 6
      .TextMatrix(i, 1) = ReadSettingString(SettingsList, sTOOLS, "Caption" & CStr(i), vbNullString)
      .TextMatrix(i, 2) = ReadSettingString(SettingsList, sTOOLS, "Source" & CStr(i), vbNullString)
    Next i
  End With
  
  'text box fonts and size
  txtEdit.Font.Name = Settings.EFontName
  txtEdit.Font.size = Settings.EFontSize
  'set column to 1
  fgTools.Col = 1
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Private Sub cmdOK_Click()
  
  Dim i As Long, lngRow As Long
  Dim blnTools As Boolean
  
  'first item to add will be row 1
  lngRow = 1
  'step through all rows
  For i = 1 To 6
    'if both columns are NON blank
    If LenB(fgTools.TextMatrix(i, 1)) <> 0 And LenB(fgTools.TextMatrix(i, 2)) <> 0 Then
      'add this item
      WriteAppSetting SettingsList, sTOOLS, "Caption" & CStr(lngRow), fgTools.TextMatrix(i, 1)
      WriteAppSetting SettingsList, sTOOLS, "Source" & CStr(lngRow), fgTools.TextMatrix(i, 2)
      'update tools menu
      With frmMDIMain.mnuTCustom(lngRow)
        .Visible = True
        .Caption = fgTools.TextMatrix(i, 1)
        .Tag = fgTools.TextMatrix(i, 2)
        blnTools = True
      End With
      lngRow = lngRow + 1
    End If
  Next i
  
  'erase any remaining rows
  For i = lngRow To 6
    WriteAppSetting SettingsList, sTOOLS, "Caption" & CStr(i), vbNullString
    WriteAppSetting SettingsList, sTOOLS, "Source" & CStr(i), vbNullString
    With frmMDIMain.mnuTCustom(i)
      .Visible = False
      .Caption = vbNullString
      .Tag = vbNullString
    End With
  Next i
  
  'if no tools, hide separator
  frmMDIMain.mnuTBar1.Visible = blnTools
  
  'Close
  Unload Me
End Sub


Private Sub cmdOK_GotFocus()

  'if editing
  If txtEdit.Visible Then
    txtEdit.Visible = False
    cmdBrowse.Visible = False
  End If
End Sub


Private Sub txtEdit_GotFocus()

  'select all
  txtEdit.SelStart = 0
  txtEdit.SelLength = Len(txtEdit.Text)
End Sub


Private Sub txtEdit_KeyPress(KeyAscii As Integer)

  On Error GoTo ErrHandler
  
  Select Case KeyAscii
  Case 9, 10, 13 'enter or tab
    'ignore key
    KeyAscii = 0
    
    'if on first column
    If EditCol = 1 Then
      'put this text back into grid
      fgTools.TextMatrix(EditRow, EditCol) = txtEdit.Text
      'shift to second column
      fgTools.Col = 2
      EditCol = 2
      
      'move editbox
      txtEdit.Move fgTools.CellLeft + CellIndentH, fgTools.CellTop + fgTools.Top + CellIndentV, fgTools.CellWidth - CellIndentH - cmdBrowse.Width, fgTools.CellHeight - CellIndentV
      txtEdit.Text = fgTools.Text
      'move browse button
      cmdBrowse.Move fgTools.CellLeft + fgTools.ColWidth(2) - cmdBrowse.Width - 3 * ScreenTWIPSX, fgTools.CellTop + fgTools.Top + CellIndentV, cmdBrowse.Width, cmdBrowse.Height
      cmdBrowse.Visible = True
      
      'select all
      txtEdit.SelStart = 0
      txtEdit.SelLength = Len(txtEdit.Text)
    Else
      'copy text back to grid
      fgTools.TextMatrix(EditRow, EditCol) = txtEdit.Text
      fgTools.SetFocus
      
      'hide text box and browse button
      txtEdit.Visible = False
      cmdBrowse.Visible = False
      
      'now change row and column to next item
      If fgTools.Row < fgTools.Rows - 1 Then
        fgTools.Row = fgTools.Row + 1
      End If
      fgTools.Col = 1
      EditCol = 1
    End If
    
  Case 27 'escape
  'ignore key
    KeyAscii = 0
    'restore original text
    txtEdit.Text = fgTools.TextMatrix(EditRow, EditCol)
    'set focus to grid to force update
    '(which is ignored, since object not changed)
    fgTools.SetFocus
  End Select
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub txtEdit_LostFocus()
  
  On Error GoTo ErrHandler
  
  'if the text box is visible,
  'it means user clicked on something else
  If txtEdit.Visible Then
    'put this text back into grid
    fgTools.TextMatrix(EditRow, EditCol) = txtEdit.Text
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


