VERSION 5.00
Begin VB.Form frmSndSubclass 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   BorderStyle     =   0  'None
   ClientHeight    =   3090
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4680
   ControlBox      =   0   'False
   HasDC           =   0   'False
   Icon            =   "frmSndSubclass.frx":0000
   MaxButton       =   0   'False
   MinButton       =   0   'False
   NegotiateMenus  =   0   'False
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   ShowInTaskbar   =   0   'False
End
Attribute VB_Name = "frmSndSubclass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public agSndToPlay As AGISound
Public Sub PlaySound(SndRes As AGISound)
  
  Dim strTempFile As String, strShortFile As String
  Dim rtn As Long, intFile As Integer
  Dim strError As String, strID As String
  
    
  On Error Resume Next
  

  'no spaces allowed in id
  If InStr(1, SndRes.ID, Chr$(32)) <> 0 Then
    strID = Replace(SndRes.ID, Chr$(32), Chr$(95))
  Else
    strID = SndRes.ID
  End If
  
  'create MIDI sound file
  strTempFile = TempFileName()
  intFile = FreeFile()
  Open strTempFile For Binary As intFile
  Put intFile, 1, SndRes.MIDIData
  Close intFile
  'convert to shortname
  rtn = GetShortPathName(strTempFile, strShortFile, 0&)
  strShortFile = String$(rtn, 0)
  rtn = GetShortPathName(strTempFile, strShortFile, rtn)
  strShortFile = Left$(strShortFile, Len(strShortFile) - 1)
  
  'open midi file and assign alias
  rtn = mciSendString("open " & strShortFile & " type sequencer alias " & strID, 0&, 0&, 0&)
  'check for error
  If rtn Then
    strError = String$(255, 32)
    rtn = mciGetErrorString(rtn, strError, 255)
    strError = Trim$(strError)
    'return the error
    On Error GoTo 0: Err.Raise vbObjectError + 678, "SndSubclass", strError
    Exit Sub
  End If
  
  'set playing flag and number of sound being played
  blnPlaying = True
  PlaySndResNum = SndRes.Number
  Set agSndToPlay = SndRes
  
  'play the file
  rtn = mciSendString("play " & strID & " notify", 0&, 0&, Me.hWnd)
  
  'check for errors
  If rtn Then
    strError = String$(255, 32)
    rtn = mciGetErrorString(rtn, strError, 255)
    strError = Trim$(strError)
    'reset playing flag
    blnPlaying = False
    Set agSndToPlay = Nothing
    'close sound
    rtn = mciSendString("close all", 0&, 0&, 0&)
    'return the error
    On Error GoTo 0: Err.Raise vbObjectError + 628, "SndSubclass", Replace(LoadResString(628), ARG1, strError)
  End If
End Sub

